<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/CKEditor.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js			
	</xsl:variable>
	
	<xsl:variable name="scripts">
		/js/addmanagerevaluator.js			
	</xsl:variable>
	
	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateAddClosestManagerAsFlowInstanceManagerEvaluator" />
			
		</div>

	</xsl:template>

	<xsl:template match="UpdateAddClosestManagerAsFlowInstanceManagerEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="AddClosestManagerAsFlowInstanceManagerEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="AddClosestManagerAsFlowInstanceManagerEvaluator" />
			</xsl:call-template>

			<div class="floatleft full marginbottom">
	
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'showInLog'" />
						<xsl:with-param name="name" select="'showInLog'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="AddClosestManagerAsFlowInstanceManagerEvaluator" />
					</xsl:call-template>
	
					<label for="showInLog">
						<xsl:value-of select="$i18n.ShowInLog" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full marginbottom">
	
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'sendEmail'" />
						<xsl:with-param name="name" select="'sendEmail'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="AddClosestManagerAsFlowInstanceManagerEvaluator" />
					</xsl:call-template>
	
					<label for="sendEmail">
						<xsl:value-of select="$i18n.SendEmail" />
					</label>
				</div>
				<div class="floatleft fifty">
					<span class="tiny"><xsl:value-of select="$i18n.SendEmailInformation" /></span>
				</div>
			</div>

			<div id="email">
			
				<h2 class="floatleft full bigmargintop">
					<xsl:value-of select="$i18n.EmailHeader" />
				</h2>
				
				<xsl:call-template name="addUserTagsTable"/>
				
				<label class="clearboth floatleft" for="emailSubject">
					<xsl:value-of select="$i18n.EmailSubject" />
				</label>
	
				<div class="floatleft full marginbottom">
	
					<div class="floatleft full">
						<xsl:call-template name="createTextField">
							<xsl:with-param name="id" select="'emailSubject'" />
							<xsl:with-param name="name" select="'emailSubject'" />
							<xsl:with-param name="title" select="$i18n.EmailSubject"/>
							<xsl:with-param name="element" select="AddClosestManagerAsFlowInstanceManagerEvaluator" />
						</xsl:call-template>
					</div>
				</div>
				
				<label class="floatleft" for="emailMessage">
					<xsl:value-of select="$i18n.EmailMessage" />
				</label>
	
				<div class="floatleft full marginbottom">
	
					<div class="floatleft full">
						<xsl:call-template name="createTextArea">
							<xsl:with-param name="id" select="'emailMessage'" />
							<xsl:with-param name="name" select="'emailMessage'" />
							<xsl:with-param name="title" select="$i18n.EmailMessage"/>
							<xsl:with-param name="class" select="'message-ckeditor'" />
							<xsl:with-param name="element" select="AddClosestManagerAsFlowInstanceManagerEvaluator" />
						</xsl:call-template>
					</div>
				</div>
	
				<xsl:call-template name="initializeFCKEditor">
					<xsl:with-param name="basePath"><xsl:value-of select="/Document/requestinfo/contextpath"/>/static/f/<xsl:value-of select="/Document/module/sectionID"/>/<xsl:value-of select="/Document/module/moduleID"/>/ckeditor/</xsl:with-param>
					<xsl:with-param name="customConfig">config.js</xsl:with-param>
					<xsl:with-param name="editorContainerClass">message-ckeditor</xsl:with-param>
					<xsl:with-param name="editorHeight">150</xsl:with-param>
					<xsl:with-param name="contentsCss">
						<xsl:if test="/Document/cssPath">
							<xsl:value-of select="/Document/cssPath"/>
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
	
				<div class="floatleft full marginbottom">
		
					<div class="floatleft full">
						<xsl:call-template name="createCheckbox">
							<xsl:with-param name="id" select="'attachPDF'" />
							<xsl:with-param name="name" select="'attachPDF'" />
							<xsl:with-param name="value" select="'true'" />
							<xsl:with-param name="element" select="AddClosestManagerAsFlowInstanceManagerEvaluator" />
						</xsl:call-template>
		
						<label for="attachPDF">
							<xsl:value-of select="$i18n.AttachPDF" />
						</label>
					</div>
				</div>
				
			</div>
			
			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.Submit}" />
			</div>

		</form>

	</xsl:template>
	
	<xsl:template name="addUserTagsTable">
		<div class="floatleft margintop full">

			<p><xsl:value-of select="$i18n.UserTagsTable.description"/></p>
		
			<table class="full border">
				<tr>
					<th>
						<xsl:value-of select="$i18n.Tag"/>
					</th>
					<th>
						<xsl:value-of select="$i18n.Description"/>
					</th>
				</tr>
				
				<tr>
					<td>
						<xsl:text>$flow.name</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.FlowNameTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$flowInstance.flowInstanceID</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.FlowInstanceIDTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$flowInstance.url</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.FlowInstanceURLTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$poster.firstname</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.PosterFirstnameTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$poster.lastname</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.PosterLastnameTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$manager.firstname</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.ManagerFirstnameTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$manager.lastname</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.ManagerLastnameTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$submitter.firstname</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.SubmitterFirstnameTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$submitter.lastname</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.SubmitterLastnameTag"/>
					</td>
				</tr>
				<tr class="hidden attached-pdf-tag">
					<td>
						<xsl:text>$flowInstance.pdfAttachedText</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.FLowInstanceAttachedPDFTextTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$attribute{attributnamn}</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.Tags.Attribute"/>
					</td>
				</tr>
				
			</table>
		
		</div>
	
	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'emailSubject'">
				<xsl:value-of select="$i18n.emailSubject" />
			</xsl:when>
			<xsl:when test="$fieldName = 'emailMessage'">
				<xsl:value-of select="$i18n.emailMessage" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>