package com.nordicpeak.flowengine.alternativelist.beans;

import java.io.Serializable;

import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement(name = "AlternativeListDescriptor")
public class AlternativeListDescriptor extends GeneratedElementable implements Comparable<AlternativeListDescriptor>, Serializable {

	private static final long serialVersionUID = -5123935033897780547L;
	
	@XMLElement
	private final String providerID;
	
	@XMLElement
	private final String name;
	
	public AlternativeListDescriptor(String providerID, String name) {
		super();
		this.providerID = providerID;
		this.name = name;
	}

	@Override
	public int compareTo(AlternativeListDescriptor other) {
		
		return getName().compareToIgnoreCase(other.getName());
	}
	
	public String getProviderID() {
		
		return providerID;
	}
	
	public String getName() {
	
		return name;
	}	
}
