package com.nordicpeak.flowengine.alternativelist.provider;

import java.io.Serializable;
import java.util.List;

import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement(name = "AlternativeList")
public abstract class BaseAlternativeList<BaseList extends BaseAlternativeList<BaseList, BaseListEvent>, BaseListEvent extends BaseAlternativeListEvent<BaseList, BaseListEvent>> extends GeneratedElementable implements Comparable<BaseList>, Serializable {
	
	private static final long serialVersionUID = 8659636372288063398L;
	public abstract String getListName();
	
	public abstract Integer getListID();
	
	@Override
	public int hashCode() {
		
		final int prime = 31;
		int result = 1;
		result = prime * result + ((getListID() == null) ? 0 : getListID().hashCode());
		return result;
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public boolean equals(Object obj) {
		
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BaseList other = (BaseList) obj;
		if (getListID() == null) {
			if (other.getListID() != null)
				return false;
		} else if (!getListID().equals(other.getListID()))
			return false;
		return true;
	}
	
	@Override
	public int compareTo(BaseList other) {
		
		return getListName().toLowerCase().compareTo(other.getListName().toLowerCase());
	}
	
	@Override
	public String toString() {
		
		return StringUtils.toLogFormat(getListName(), 30) + " (ID: " + getListID() + ")";
	}
	
	public abstract List<BaseListEvent> getEvents();
	public abstract void setEvents(List<BaseListEvent> events);
	
}
