package com.nordicpeak.flowengine.queries.alternativelistpriorityquery;

import java.io.Serializable;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OrderBy;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.interfaces.ImmutableAlternative;

@Table(name = "alternative_list_priority_query_instance_alternatives")
@XMLElement(name = "Alternative")
public class AlternativeListPriorityAlternative extends GeneratedElementable implements ImmutableAlternative, Serializable, Comparable<AlternativeListPriorityAlternative> {
	
	
	private static final long serialVersionUID = 5726529434531933383L;
	
	@DAOManaged(columnName = "queryInstanceID")
	@Key
	@ManyToOne
	private AlternativeListPriorityQueryInstance queryInstance;
	
	@DAOManaged
	@Key
	@XMLElement
	private Integer alternativeID;
	
	@DAOManaged
	@XMLElement
	private String name;
	
	@DAOManaged
	@OrderBy
	@XMLElement
	private Integer sortIndex;
	
	@DAOManaged
	@XMLElement
	private String alternativeXMLValue;

	//TODO remove this field, it does not need to be persisted
	@DAOManaged
	@XMLElement
	private String alternativeAttributeValue;

	
	public AlternativeListPriorityAlternative() {
		super();
	}
	
	public AlternativeListPriorityAlternative(ImmutableAlternative alternative, int sortIndex) {
		super();
		this.alternativeID = alternative.getAlternativeID();
		this.name = alternative.getName();
		this.sortIndex = sortIndex;
		this.alternativeXMLValue = alternative.getExportXMLValue();
		this.alternativeAttributeValue = alternative.getAttributeValue();
	}
	
	@Override
	public Integer getAlternativeID() {
		return alternativeID;
	}
	
	public AlternativeListPriorityQueryInstance getQueryInstance() {
		
		return queryInstance;
	}
	
	@Override
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public Integer getSortIndex() {
		return sortIndex;
	}
	
	public void setSortIndex(Integer sortIndex) {
		this.sortIndex = sortIndex;
	}
	
	@Override
	public String toString() {
		
		return name + " (alternativeID: " + alternativeID + ")";
	}
	
	@Override
	public int hashCode() {
		
		final int prime = 31;
		int result = 1;
		result = prime * result + ((alternativeID == null) ? 0 : alternativeID.hashCode());
		return result;
	}
	
	@Override
	public boolean equals(Object obj) {
		
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		AlternativeListPriorityAlternative other = (AlternativeListPriorityAlternative) obj;
		if (alternativeID == null) {
			if (other.alternativeID != null) {
				return false;
			}
		} else if (!alternativeID.equals(other.alternativeID)) {
			return false;
		}
		return true;
	}
	
	public void setQueryInstance(AlternativeListPriorityQueryInstance queryInstance) {
		this.queryInstance = queryInstance;
	}
	
	@Override
	public String getExportXMLValue() {
		return alternativeXMLValue;
	}

	@Override
	public String getAttributeValue() {
		return alternativeAttributeValue;
	}

	@Override
	public int compareTo(AlternativeListPriorityAlternative o) {
		return sortIndex.compareTo(o.getSortIndex());
	}
}