$(function() {
	
	setQueryRequiredFunctions["AlternativeListPriorityQueryInstance"] = makeAlternativeListPriorityQueryRequired;
});

function initAlternativeListPriorityQuery(queryID) {
	
	var query = $("#query_" + queryID);
		
	var selects = query.find("select");
	
	selects.on("change", function() {
		
		var select = $(this);
		var parent = select.parent();
		
		parent.removeClass("invalid input-error");
		parent.find(".errorIconDiv").empty();
		
		hideShowAlternativeListPriorityQueryDropDowns(query);
		hideShowAlternativeListPriorityQueryErrors(query, selects);
		
		if (query.hasClass("enableAjaxPosting")) {
			runAlternativeListPriorityQueryEvaluators(selects, queryID);
		}
	});
	
	hideShowAlternativeListPriorityQueryDropDowns(query);
}

function hideShowAlternativeListPriorityQueryErrors(query, allSelects){
	
	var values = allSelects.first().find("option");
	
	values.each(function(){
		
		var option = $(this);
		var value = option.val();
		var allowMultiple = option.data("multiple");
		
		if(value != "" && allowMultiple != true){
	
			var relevantSelects = allSelects.find("option[value='" + value + "']:selected").closest("select");
			
			if(relevantSelects.length > 1){
			
				relevantSelects.each(function(){
					
					var select = $(this);
					var parent = select.parent();
					
					if(!parent.hasClass("input-error")){
						
						parent.addClass("invalid input-error");
						
						var errorDiv = parent.find(".errorIconDiv"); 
						errorDiv.empty();
						errorDiv.append(query.find(".CanOnlyChooseAlternativeOnceTemplate").children().clone());
					}
				});
				
			} else {
				
				var parents = relevantSelects.parent();
				parents.removeClass("invalid input-error");
				parents.find(".errorIconDiv").empty();
			}
		}
	});
}

function hideShowAlternativeListPriorityQueryDropDowns(query){
	
	var minChoices = query.find(".minChoices").text();
	var previousSet = true;
	
	query.find("fieldset").children("div").each(function(index){
		
		var div = $(this);
		var select = div.find("select");
		
		div.toggle(previousSet);
		select.prop("disabled", !previousSet);
		
		if(!previousSet && select.val() != ""){
			
			select.val("");
			
			var parent = select.parent();
			parent.removeClass("invalid input-error");
			parent.find(".errorIconDiv").empty();
		}
		
		if (index + 1 >= minChoices && previousSet) {
			previousSet = select.val() != "";
		}
	});
}

function runAlternativeListPriorityQueryEvaluators(selects, queryID) {
	
	var parameters = {};
	
	selects.each(function(){
		var $this = $(this);
		parameters[$this.attr("name")] = $this.val();
	});
	
	runQueryEvaluators(queryID, parameters);
}

function makeAlternativeListPriorityQueryRequired(queryID) {
	
	$("#query_" + queryID).find(".heading-wrapper h2").addClass("required");
}