package com.nordicpeak.flowengine.integration.base.beans;

import java.sql.Timestamp;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;

public abstract class BaseQueuedIntegrationRequest {

	@Key
	@DAOManaged
	private Integer eventID;

	@DAOManaged
	private Integer flowInstanceID;

	@DAOManaged
	private int retryCount;

	@DAOManaged
	private Timestamp lastRetry;

	public BaseQueuedIntegrationRequest() {}

	public Integer getEventID() {

		return eventID;
	}

	public void setEventID(Integer eventID) {

		this.eventID = eventID;
	}

	public Integer getFlowInstanceID() {

		return flowInstanceID;
	}

	public void setFlowInstanceID(Integer flowInstanceID) {

		this.flowInstanceID = flowInstanceID;
	}

	public int getRetryCount() {

		return retryCount;
	}

	public void setRetryCount(int retryCount) {

		this.retryCount = retryCount;
	}

	public Timestamp getLastRetry() {

		return lastRetry;
	}

	public void setLastRetry(Timestamp lastRetry) {

		this.lastRetry = lastRetry;
	}

	@Override
	public String toString() {

		if (getLogName() != null) {

			return getLogName() + " (eventID: " + eventID + ", flowInstanceID: " + flowInstanceID + ")";
		}

		return " Queued integration request (eventID: " + eventID + ", flowInstanceID: " + flowInstanceID + ")";
	}

	public abstract String getLogName();

}
