package com.nordicpeak.flowengine.booking.beans;

import se.unlogic.hierarchy.core.beans.SimpleAttribute;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "bookings_events_attributes")
@XMLElement(name = "Attribute")
public class BookingEventAttribute extends SimpleAttribute {

	private static final long serialVersionUID = 8352980246886449952L;

	@DAOManaged(columnName = "eventID")
	@Key
	@ManyToOne
	protected BookingEvent event;

	public BookingEventAttribute() {}

	public BookingEventAttribute(String name, String value) {

		super(name, value);
	}

	public BookingEvent getEvent() {

		return event;
	}

	public void setEvent(BookingEvent event) {

		this.event = event;
	}

}
