package com.nordicpeak.flowengine.booking.events;

import java.io.Serializable;
import java.sql.Timestamp;

import com.nordicpeak.flowengine.booking.beans.BookingSlot;

public class BookingSlotRebookedEvent implements Serializable {

	private static final long serialVersionUID = -2388474140483146725L;

	private final BookingSlot bookingSlot;
	private final Timestamp bookingSlotOldStart;
	private final Timestamp bookingSlotOldEnd;

	public BookingSlotRebookedEvent(BookingSlot bookingSlot, Timestamp bookingSlotOldStart, Timestamp bookingSlotOldEnd) {

		this.bookingSlot = bookingSlot;
		this.bookingSlotOldStart = bookingSlotOldStart;
		this.bookingSlotOldEnd = bookingSlotOldEnd;
	}

	public BookingSlot getBookingSlot() {

		return bookingSlot;
	}

	public Timestamp getBookingSlotOldStart() {

		return bookingSlotOldStart;
	}

	public Timestamp getBookingSlotOldEnd() {

		return bookingSlotOldEnd;
	}

	@Override
	public String toString() {

		return "BookingSlotRebookedEvent (bookingSlot=" + bookingSlot + ", bookingSlotOldStart=" + bookingSlotOldStart + ", bookingSlotOldEnd=" + bookingSlotOldEnd + ")";
	}

}
