package com.nordicpeak.flowengine.booking.interfaces;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.interfaces.ViewFragment;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.booking.beans.BookingCalendar;

public interface CalendarFormExtensionProvider {

	String getProviderID();

	ViewFragment getCalendarFormViewFragment(BookingCalendar bookingCalendar, HttpServletRequest req, User user, URIParser uriParser, ValidationException validationException) throws Exception;

	void validateCalendarFormRequest(HttpServletRequest req, User user, URIParser uriParser) throws ValidationException;

	void processCalendarFormRequest(BookingCalendar calendar, HttpServletRequest req, User user, URIParser uriParser) throws Exception;

}
