$(function() {
	var $repeating = $("#repeating");
	var $addBookings = $("#addBookings");
	var $client = $("#client");
	var $clientError = $("#clientError");
	var $bookingClients = $("#bookingClients");
	var $clientTemplate = $("#clientTemplate");
	var $duplicateError = $("#duplicateError");
	var $bookableRestricted = $('#bookableRestricted')

	var toggleRepeatingFields = function() {
		
		$("#repetitionIntervalContainer, #repetitionToDateContainer").toggle($repeating.is(":checked"));
		$addBookings.add($bookableRestricted).prop("disabled", $repeating.is(":checked"));
	};

	toggleRepeatingFields();

	var toggleCustomerRepeatInterval = function() {
		
		var used = $("#repetitionIntervalUseCustom").is(":checked");
		$("#repetitionIntervalCustom").prop("disabled", !used).parent().toggle(used);
	};

	toggleCustomerRepeatInterval();
	$("input[name='repetitionInterval']").on("change", toggleCustomerRepeatInterval);

	var toggleAddBookings = function() {
		
		$("#addBookingsContainer").toggle($addBookings.is(":checked"));
		$repeating.prop("disabled", $addBookings.add($bookableRestricted).is(":checked"));
	};

	toggleAddBookings();

	$addBookings.on("click", function() {
		
		toggleAddBookings();
	});

	var toggleBookable = function() {
		
		$repeating.prop("disabled", $addBookings.add($bookableRestricted).is(":checked"));
	};

	toggleBookable();

	$bookableRestricted.on("click", function() {
		
		toggleBookable();
	});

	$repeating.on("click", function() {
		
		toggleRepeatingFields();
	});

	$client.on("keypress", function(e) {
		
		var ssn = $(this).val();

		$clientError.hide();
		$duplicateError.hide();

		if (e.which == 13) {
			
			e.preventDefault();
			e.stopPropagation();

			validateSSN(ssn);
		}
		
	}).on("blur", function(e) {
		
		var ssn = $(this).val();

		$clientError.hide();
		$duplicateError.hide();

		validateSSN(ssn);
	});

	var validateSSN = (function(ssn) {
		
		if (ssn) {
			
			if ($("input[name=citizenID][value=" + ssn + "]").length > 0) {
				
				$duplicateError.show();
				
			} else {
				
				$.get($client.parent().data("url") + ssn, function(data) {
					
					if (data.isValid) {
						
						var clone = $clientTemplate.html();

						var phone = data.phone ? data.phone + '" readonly' : "";

						if (phone) { // Fix for repopulation from requestparams
						
							phone += '\/><input type="hidden" name="readonly-' + ssn + '" value="true"';
						}

						var name = data.fullName || AddFormi18n.UnknownBooking;

						$bookingClients.append(clone.replace(/\$ssn/g, ssn).replace("$phone", phone).replace(/\$name/g, name));

						$client.val("");
						
					} else {
						
						$clientError.show();
					}
				});
			}
		}
	});

	$("#bookingSlotForm").on("submit", function(e) {

		if ($client.val()) {

			return false;
		}

		var startDate = $('#startDate').val();

		if (!$.featherlight.current() && $('#bookingClients:visible').children().length && startDate) {

			$.featherlight($('#confirmBookingsModal'), {

				variant: 'small-modal',
				afterContent: function() {

					var $modalContent = this.$content;

					$modalContent.removeClass("no-sections");

					$modalContent.find('#confirmBookingsModalDate').html(startDate);

					$('#bookingClients .citizen').each(function() {

						$modalContent.find('#confirmBookingsModalList').append($(this).siblings('img').clone()).append("<div>" + this.innerHTML + "</div>");
					});

					if ($('input[type="checkbox"].mute-contact-notifications:checked').length) {

						$modalContent.find('#confirmBookingsModalNotificationText').hide();
					}
				}
			});

			return false;
		}
	});

	$bookingClients.on("click", ".delete", function(e) {
		
		e.preventDefault();

		$(this).closest("div").remove();
	});

	var $startTime = $("#startTime");
	var $endTime = $("#endTime");
	var defaultSlotLength = $startTime.parent().data("slotlength");
	var endTimeChanged = false;

	if ($endTime.length > 0 && defaultSlotLength > 0) {
		
		$endTime.on("change", function() {
			
			endTimeChanged = true;
		});

		$startTime.on("change", function() {
			
			var startTime = $startTime.val();
			
			if (!endTimeChanged && startTime) {
				
				var hour = parseInt(startTime.substring(0, 2));
				var minute = parseInt(startTime.substring(3));

				var addMinutes = defaultSlotLength;

				while (addMinutes > 59) {
					
					hour++;
					addMinutes -= 60;
				}

				minute += addMinutes;

				if (minute > 59) {
					
					hour++;
					minute -= 60;
				}

				if (hour > 23) {
					
					var newHour = -1;
					
					while (hour > 23) {
						
						newHour++;
						hour--;
					}

					hour = newHour;
				}

				hour = "" + hour;

				if (hour.length == 1) {
					
					hour = "0" + hour;
				}

				minute = "" + minute;

				if (minute.length == 1) {
					
					minute = "0" + minute;
				}

				$endTime.val(hour + ":" + minute);
			}
		});
	}
	
	initBookingSizeSelector($bookingClients);

});
