$(function() {

	$(".notification-text-toggle").on("click", function() {

		$(this).closest(".notification").find(".notification-text").toggle();

	});

	$(".notification-value-toggle").on("change", function() {

		$(this).closest(".notification")
			.find(".notification-value").toggle(this.checked)
			.find("input").prop("disabled", !this.checked);

	}).trigger("change");

	var disableRebooking = $("#disableRebooking");
	var disableRebookingFields = $("#restrictRebookingToPreviousManager, #minVisibleDaysRebooking");

	var showRebookingFields = function() {

		var checked = disableRebooking.prop("checked");

		disableRebookingFields.prop("disabled", checked).parent().toggle(!checked);
	};

	showRebookingFields();
	disableRebooking.on("change", showRebookingFields);

	var allowPreliminaryBookings = $("#allowPreliminaryBookings");
	var allowDuplicateBookings = $("#allowDuplicateBookings");

	var showPreliminaryBookingsFields = function() {

		var checked = allowPreliminaryBookings.prop("checked");

		$("#hoursPreliminaryBookingsAreValidFor").prop("disabled", !checked).parent().parent().toggle(checked);
	};

	showPreliminaryBookingsFields();
	allowPreliminaryBookings.on("change", showPreliminaryBookingsFields);

	$("#allowMultipleBookings").on("change", function() {

		var disableAllowDuplicateBookings = !this.checked || allowPreliminaryBookings.prop("checked");

		allowDuplicateBookings.prop("disabled", disableAllowDuplicateBookings).parent().toggle( !! this.checked);

	}).trigger("change");

	$("#hideExternalMessages").on("change", function() {

		$("#newExternalMessagesAllowedDays").parent().toggle(!this.checked);

	}).trigger("change");

	$("#showFullyBookedDaysInCalendar").on("change", function() {

		$("#fullyBookedCalendarDayText").parent().toggle( !! this.checked);

	}).trigger("change");

	$("#showFullyBookedSlotsInList").on("change", function() {

		$("#fullyBookedListSlotText").parent().toggle( !! this.checked);

	}).trigger("change");

	$("#hideBookingsPerWeekday").on("change", function() {

		$("#weekdaysWithHiddenBookingsContainer").toggle( !! this.checked);

	}).trigger("change");

	makeCheckboxesMutualExclusive(allowPreliminaryBookings, allowDuplicateBookings);

	function makeCheckboxesMutualExclusive($first, $second) {

		[$first, $second].forEach(function($current, index) {

			var $other = index == 0 ? $second : $first;

			$current.on("change", function() {

				if (this.checked) {

					$other.prop({
						"checked": false,
						"disabled": true
					}).trigger("change");

				} else {

					$other.prop("disabled", false);
				}

			}).trigger("change");
		});
	}

	$("input[name='viewMode']").on("change", function() {

		$("#calendarWeekViewContainer").toggle(this.value !== "LIST");

	}).filter(":checked").trigger("change");

	$("#sendUserRebookedManagerEmail").on("change", function() {

		var checked = $(this).prop("checked");

		$("#sendUserRebookedManagerEmailOnlyToBookingSlotManagers").prop("disabled", !checked).parent().toggle(checked);

	}).trigger("change");

	$("#sendRebookedGlobalEmail").on("change", function() {

		var $sendUserRebookedManagerEmail = $("#sendUserRebookedManagerEmail");

		$sendUserRebookedManagerEmail.prop("disabled", !this.checked);

		if (!this.checked) {

			$sendUserRebookedManagerEmail.prop("checked", true).trigger("change");
		}

	}).trigger("change");
	
	var $allowUserBookingSizeSelection = $("#allowUserBookingSizeSelection");
	var $bookingSizeSelectorEnabled = $("#bookingSizeSelectorEnabled");
	var $restrictRebookingToCurrentBookingSize = $("#restrictRebookingToCurrentBookingSize");
	var $price = $("#price");
	
	$bookingSizeSelectorEnabled.on("change", function(){
		
		$allowUserBookingSizeSelection
			.prop("disabled", !this.checked)
			.trigger("change")
			.parent()
			.toggle(this.checked);
			
		$restrictRebookingToCurrentBookingSize
			.prop("disabled", !this.checked)
			.parent()
			.toggle(this.checked);
			
	}).trigger("change");
	
	$bookingSizeSelectorEnabled.add($price).on("change", function () {
		
		var forceRestrictRebookingToCurrentBookingSize = $bookingSizeSelectorEnabled.prop("checked") && $price.val() > 0;
		
		$restrictRebookingToCurrentBookingSize.prop("disabled", forceRestrictRebookingToCurrentBookingSize);
		
		if (!$restrictRebookingToCurrentBookingSize.prop("checked")) {
			
			$restrictRebookingToCurrentBookingSize.prop("checked", forceRestrictRebookingToCurrentBookingSize);
		}
		
	}).trigger("change");
	
	$allowUserBookingSizeSelection.on("change", function(){
		
		var enable = this.checked && !this.disabled;
		
		$("#userBookingMaxSize")
			.prop("disabled", !enable)
			.parent()
			.toggle(enable);
			
	}).trigger("change");

});
