package com.nordicpeak.flowengine.integration.boverket.beans;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

@XMLElement
public class ControlPlan extends GeneratedElementable {

	@XMLElement
	private String uuid;

	@XMLElement
	private String status;

	@XMLElement
	private List<ControlPoint> controlPoints;

	@XMLElement
	private int totalCount;

	@XMLElement
	private int finishedCount;

	public ControlPlan(XMLParser xmlParser) {

		uuid = xmlParser.getString("UUID");
		status = xmlParser.getString("Kontrollplanstatus/Varde");

		List<XMLParser> points = xmlParser.getNodes("Kontrollpunkt/Kontrollpunkt");

		if (points != null) {

			controlPoints = new ArrayList<ControlPoint>(points.size());

			finishedCount = 0;

			for (XMLParser pointParser : points) {

				ControlPoint controlPoint = new ControlPoint(pointParser);

				if (controlPoint.isFinished()) {

					finishedCount++;
				}

				controlPoints.add(controlPoint);

			}

			totalCount = controlPoints.size();

			Collections.sort(controlPoints);

		}

	}

	public String getUuid() {

		return uuid;
	}

	public void setUuid(String uuid) {

		this.uuid = uuid;
	}

	public String getStatus() {

		return status;
	}

	public void setStatus(String status) {

		this.status = status;
	}

	public List<ControlPoint> getControlPoints() {

		return controlPoints;
	}

	public void setControlPoints(List<ControlPoint> controlPoints) {

		this.controlPoints = controlPoints;
	}

	public int getTotalCount() {

		return totalCount;
	}

	public void setTotalCount(int totalCount) {

		this.totalCount = totalCount;
	}

	public int getFinishedCount() {

		return finishedCount;
	}

	public void setFinishedCount(int finishedCount) {

		this.finishedCount = finishedCount;
	}

}
