package com.nordicpeak.flowengine.queries.colorpickerquery;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.beans.QueryDescriptor;
import com.nordicpeak.flowengine.queries.basequery.BaseQueryCRUD;

public class ColorPickerQueryCRUD extends BaseQueryCRUD<ColorPickerQuery, ColorPickerQueryProviderModule> {
	
	
	protected AnnotatedDAOWrapper<ColorPickerQuery, Integer> queryDAO;
	
	public ColorPickerQueryCRUD(AnnotatedDAOWrapper<ColorPickerQuery, Integer> queryDAO, BeanRequestPopulator<ColorPickerQuery> populator, String typeElementName, String typeLogName, String listMethodAlias, ColorPickerQueryProviderModule callback) {
		
		super(ColorPickerQuery.class, queryDAO, populator, typeElementName, typeLogName, listMethodAlias, callback);
		
		this.queryDAO = queryDAO;
	}
	
	@Override
	protected ColorPickerQuery populateFromUpdateRequest(ColorPickerQuery bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {
		
		ColorPickerQuery query = super.populateFromUpdateRequest(bean, req, user, uriParser);
		
		List<ValidationError> validationErrors = new ArrayList<ValidationError>();
		
		if (query.isUseAlpha() && query.getPreferedFormat() == ColorPickerFormat.HEX) {
			
			validationErrors.add(new ValidationError("AlphaNotSupportedWithHEX"));
		}
		
		populateQueryDescriptor((QueryDescriptor) query.getQueryDescriptor(), req, validationErrors);
		
		if (!validationErrors.isEmpty()) {
			throw new ValidationException(validationErrors);
		}
		
		return query;
	}
	
}
