$(function() {

	setQueryRequiredFunctions["ConstructionPermitQueryInstance"] = makeConstructionPermitQuery;
});

function initConstructionPermitQuery(queryID) {

	var query = $("#query_" + queryID);

	query.find("a.add-permits").on("click", function(e) {
		
		e.preventDefault();
		
		var button = $(this)
		
		button.closest(".permit-list").hide();
		
		$("#permit-tree-" + queryID).show();
	});	
	
	query.find("a.select-permits").on("click", function(e) {
		
		e.preventDefault();
		
		var button = $(this)
		var tree = button.closest(".permit-tree");
		tree.find(".subselection-required-error").remove();
		
		var checkedSubcategories = tree.find(".permit-foldable-checkbox:checked");
		
		if (checkedSubcategories.length > 0) {
			
			var error = false;
			
			checkedSubcategories.each(function(){
				
				var checkbox = $(this);
				var selectedSubChecks = checkbox.closest("li").find("ul li input:checked");
				
				if (selectedSubChecks.length == 0) {
				
					error = true;
					
					query.find(".subselection-required-template").children().clone().insertAfter(checkbox.closest("li").children(".permit-foldable"));
				}
			});
			
			var errors = checkedSubcategories.closest("li").find(".subselection-required-error");
			
			if (errors.length > 0) {
				
				$('html, body').animate({
			        scrollTop: errors.first().offset().top - 150
			    }, 500);
			}
			
			if (error) {
				return;
			}
		}
		
		tree.hide();
		
		$("#permit-list-" + queryID).show();
	});	
	
	query.find("a.deletepermit").on("click", function(e) {
		
		e.preventDefault();
		
		var button = $(this)
		
		//$("#permit-form-" + button.data("id")).hide();
		
		$("#permit-hidden-" + button.data("id")).attr("disabled","disabled");
		
		//$("#permit-toggler-" + button.data("id")).removeAttr("checked");
		
		$("#permit-toggler-" + button.data("id")).trigger("click");
		
		if(query.find("input[type='checkbox']:checked.permit-toggler").length == 0){
			
			query.find("a.select-permits").addClass('hidden');
			
			query.find(".permit-list").hide();
			
			$("#permit-tree-" + queryID).show();
		}
		
		//runConstructionPermitQueryEvaluators(query, queryID);
	});
	
	query.find("a.permit-foldable").on("click", function(e) {
		
		e.preventDefault();

		var button = $(this)
		
		button.toggleClass("permit-open");
		
		var ul = button.parent().children(".permit-children"); 
		ul.toggle();
	});
	
	query.find("label.permit-foldable").on("click", function(e) {
		
		var button = $(this);
		var parentLI = button.parent();
		
		button.toggleClass("permit-open");
		
		var childrenUL = parentLI.children(".permit-children"); 
		childrenUL.toggle();
		
		var checkbox = parentLI.children("input"); 
		
		if (checkbox.prop("checked")) { // Is checked before click
			
			parentLI.find(".subselection-required-error").remove();
			childrenUL.find("input:checked").prop("checked", false).each(function(){
				
				constructionPermitToggle($(this), query, false);
			});
			
			runConstructionPermitQueryEvaluators(query, queryID);
		}
	});
	
	query.find("input[type='checkbox'].permit-toggler").on("change", function(e) {
		
		var button = $(this);
		
		constructionPermitToggle(button, query, true);
		
		runConstructionPermitQueryEvaluators(query, queryID);
	});	
}

function constructionPermitToggle(button, query, hideParent){
	
	$("#permit-form-" + button.data("id")).toggle();
	
	var selectPermitsButton = query.find("a.select-permits");
	
	if(button.prop("checked")){
		
		$("#permit-hidden-" + button.data("id")).removeAttr("disabled");
		
		selectPermitsButton.removeClass('hidden');
		
	}else{
		
		$("#permit-hidden-" + button.data("id")).attr("disabled","disabled");
		
		if(query.find("input[type='checkbox']:checked.permit-toggler").length == 0){
			
			selectPermitsButton.addClass('hidden');
			
			if(hideParent){
				
				query.find("input[type='checkbox']:checked.permit-foldable-checkbox").prop('checked',false).parent().children("ul").toggle();
			}
			
		}else if(hideParent){
			
			var ul = button.closest("ul");
			
			if(ul.find("input[type='checkbox']:checked.permit-toggler").length == 0){
				
				ul.parent().children("input[type='checkbox'].permit-foldable-checkbox").prop('checked',false);
				
				if(ul.parent().is("li")){
					
					ul.toggle();
				}
			}
		}
	}
}

function runConstructionPermitQueryEvaluators(query, queryID) {
	
	var parameters = {};
	var values = [];
	var hiddenFieldName;
	
	query.find("input[type='hidden']:not(:disabled)").each(function() {
		
		var $hiddenField = $(this);
		
		values.push($hiddenField.val());
		
		hiddenFieldName = $hiddenField.attr("name");
	});
	
	parameters[hiddenFieldName] = values;
	
	query.find("input[type='text']").each(function () {
		
		var $textField = $(this);
		
//		var $wrapper = $textField.parent();
//		
//		if($wrapper.hasClass("input-error")) {
//			
//			$textField.tooltip("destroy");
//			$wrapper.removeClass("invalid input-error").find("i[title]").remove();
//		}
		
		parameters[$textField.attr("name")] = $textField.val();		
	});
	
	runQueryEvaluators(queryID, parameters);
}

function makeConstructionPermitQuery(queryID) {

	$("#query_" + queryID).find(".heading-wrapper h2").addClass("required");
}