<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:template match="Document">
		
		<div class="contentitem" id="ContactDetailsVerification">
			<xsl:apply-templates select="Verify"/>
			<xsl:apply-templates select="Decline"/>
			<xsl:apply-templates select="VerifyEmail"/>
			<xsl:apply-templates select="VerifyPhone"/>
		</div>
		
	</xsl:template>
	
	<xsl:template match="Verify">
	
		<h1><xsl:value-of select="$i18n.VerifyContactDetails"/></h1>
		
		<xsl:choose>
			<xsl:when test="VerifyPhone or VerifyEmail">
				<xsl:value-of select="VerificationText" disable-output-escaping="yes"/>
				
				<xsl:if test="VerifyEmail">
					<div class="margintop"><a href="{/Document/requestinfo/contextpath}/{/Document/module/alias}/verifyemail"><xsl:value-of select="$i18n.VerifyEmail"/></a></div>
				</xsl:if>
				
				<xsl:if test="VerifyPhone">
					<div class="margintop"><a href="{/Document/requestinfo/contextpath}/{/Document/module/alias}/verifyphone"><xsl:value-of select="$i18n.VerifyPhone"/></a></div>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$i18n.NothingToVerify"/>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
	<xsl:template match="VerifyEmail">
	
		<h1><xsl:value-of select="$i18n.VerifyEmail"/></h1>
	
		<xsl:choose>
			<xsl:when test="EmailVerified">
				<p><xsl:value-of select="$i18n.EmailVerified"/></p>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="VerifyEmailText" disable-output-escaping="yes"/>
			
				<xsl:if test="EmailNotVerified">
					<p class="error"><xsl:value-of select="$i18n.InvalidCode"/></p>
				</xsl:if>
				
				<form method="post" action="{/Document/requestinfo/contextpath}/{/Document/module/alias}/verifyemail">
					<label for="verificationCode"><xsl:value-of select="$i18n.VerificationCode"/></label><br/>
					
					<input type="text" name="verificationCode" /><br/>
					
					<a href="{/Document/requestinfo/contextpath}/{/Document/module/alias}/verifyemail"><xsl:value-of select="$i18n.SendAgain"/></a>
					
					<div class="fifty bigmargintop clearfix">
						<input type="submit" class="btn btn-green floatright" value="{$i18n.Verify}"/>
					</div>
				</form>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
	<xsl:template match="VerifyPhone">
		
		<h1><xsl:value-of select="$i18n.VerifyPhone"/></h1>
		
		<xsl:choose>
			<xsl:when test="PhoneVerified">
				<p><xsl:value-of select="$i18n.PhoneVerified"/></p>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="VerifyPhoneText" disable-output-escaping="yes"/>
			
				<xsl:if test="PhoneNotVerified">
					<p class="error"><xsl:value-of select="$i18n.InvalidCode"/></p>
				</xsl:if>
				
				<form method="post" action="{/Document/requestinfo/contextpath}/{/Document/module/alias}/verifyphone">
					<label for="verificationCode"><xsl:value-of select="$i18n.VerificationCode"/></label><br/>
					
					<input type="text" name="verificationCode" /><br/>
					
					<a href="{/Document/requestinfo/contextpath}/{/Document/module/alias}/verifyphone"><xsl:value-of select="$i18n.SendAgain"/></a>
					
					<div class="fifty bigmargintop clearfix">
						<input type="submit" class="btn btn-green floatright" value="{$i18n.Verify}"/>
					</div>
				</form>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
	<xsl:template match="Decline">
		
		<h1><xsl:value-of select="$i18n.VerificationDeclined"/></h1>
		
		<xsl:value-of select="DeclineText" disable-output-escaping="yes"/>
		
	</xsl:template>
	
</xsl:stylesheet>