<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:import href="classpath://com/nordicpeak/flowengine/queries/common/xsl/QueryAdminCommon.sv.xsl"/>

	<xsl:output encoding="ISO-8859-1" method="html" version="4.0"/>

	<xsl:include href="DateTimeQueryAdminTemplates.xsl"/>
	
	<xsl:variable name="java.queryTypeName">Datum/Tid-frga</xsl:variable>
	<xsl:variable name="java.queryDescription">
Frgetypen Datum/Tid-frga anvnds nr anvndaren skall ange datum och tid. Anvndaren kan vlja frn en datum/tid-vljare och frgan kan konfigureras p olika stt fr att begrnsa vilka datum/datumintervall som accepteras.
	</xsl:variable>
	
	<xsl:variable name="java.mondayString">mndag</xsl:variable>
	<xsl:variable name="java.tuesdayString">tisdag</xsl:variable>
	<xsl:variable name="java.wednesdayString">onsdag</xsl:variable>
	<xsl:variable name="java.thursdayString">torsdag</xsl:variable>
	<xsl:variable name="java.fridayString">fredag</xsl:variable>
	<xsl:variable name="java.saturdayString">lrdag</xsl:variable>
	<xsl:variable name="java.sundayString">sndag</xsl:variable>
	
	<xsl:variable name="i18n.UpdateQuery">ndra frga</xsl:variable>
	<xsl:variable name="i18n.UseDateFields">Visa datumflt</xsl:variable>
	<xsl:variable name="i18n.UseTimeFields">Visa tidsflt</xsl:variable>
	<xsl:variable name="i18n.UseMultiDate">Visa frn-till flt fr datum</xsl:variable>
	<xsl:variable name="i18n.RestrictDateInterval">Begrnsa datumintervallet</xsl:variable>
	
	<xsl:variable name="i18n.DateFieldsetLegend">Datum</xsl:variable>
	<xsl:variable name="i18n.TimeFieldsetLegend">Tid</xsl:variable>
	<xsl:variable name="i18n.StartDateLegend">Startdatum</xsl:variable>
	<xsl:variable name="i18n.StartDateAllowedWeekdaysLegend">Vlj tilltna veckodagar</xsl:variable>
	<xsl:variable name="i18n.EndDateLegend">Slutdatum</xsl:variable>
	<xsl:variable name="i18n.DateIntervalRestrictionLegend">Restriktioner p datumintervallet</xsl:variable>
	
	<xsl:variable name="i18n.DateRestrictionIntervalHeading">Hur ska datumintervallet begrnsas?</xsl:variable>
	<xsl:variable name="i18n.DateRestrictionIntervalMinimum">Minimum (ange hur nra datumen fr ligga varandra som minst)</xsl:variable>
	<xsl:variable name="i18n.DateRestrictionIntervalMaximum">Maximum (ange hur lngt ifrn varandra datumen fr ligga som mest)</xsl:variable>
	<xsl:variable name="i18n.DateRestrictionIntervalUnitHeading">Ange enhet fr datumintervallbegrnsningen</xsl:variable>
	<xsl:variable name="i18n.DateRestrictionIntervalUnitDays">Dagar</xsl:variable>
	<xsl:variable name="i18n.DateRestrictionIntervalUnitMonths">Mnader</xsl:variable>
	<xsl:variable name="i18n.DateIntervalRestriction">Datumintervallbegrnsning</xsl:variable>
	
	<xsl:variable name="i18n.DateIntervalRestrictionTypeField">fr hur datumintervallet ska begrnsas, max eller min</xsl:variable>
	<xsl:variable name="i18n.DateIntervalRestrictionUnitField">fr vilken enhet som datumintervallbegrnsningen anges i, mnader eller dagar</xsl:variable>
	<xsl:variable name="i18n.DateIntervalRestrictionField">datumintervallbegrnsning</xsl:variable>
	<xsl:variable name="i18n.NumberOfUpcomingMonthsField">fr antalet efterfljande start-mnader som ska begrnsas</xsl:variable>
	<xsl:variable name="i18n.NumberOfUpcomingEndMonthsField">fr antalet efterfljande slut-mnader som ska begrnsas</xsl:variable>
	
	<xsl:variable name="i18n.RestrictTomorrowOnTimeLegend">Begrnsa datum baserat p klockslag</xsl:variable>
	<xsl:variable name="i18n.RestrictTomorrowOnTimeCheckbox">Begrnsa datum baserat p klockslag</xsl:variable>
	<xsl:variable name="i18n.TomorrowRestrictionModeToday">Begrnsa dagens datum</xsl:variable>
	<xsl:variable name="i18n.TomorrowRestrictionModeTomorrow">Begrnsa morgondagens datum</xsl:variable>
	<xsl:variable name="i18n.TomorrowRestrictionModeTodayInfo1">Begrnsa dagens datum om klockslaget nedan passerats</xsl:variable>
	<xsl:variable name="i18n.TomorrowRestrictionModeTodayInfo2">Detta innebr att valt startdatum ej fr vara tillbaka i tiden och att dagens datum endast fr vljas om klockslaget nedan ej passerats d rendet skickas in. Om det passerats mste ett datum efter dagens datum vljas.</xsl:variable>
	<xsl:variable name="i18n.TomorrowRestrictionModeTomorrowInfo1">Begrnsa morgondagens datum om klockslaget nedan passerats</xsl:variable>
	<xsl:variable name="i18n.TomorrowRestrictionModeTomorrowInfo2">Detta innebr att valt startdatum mste vara efter dagens datum och att morgondagens datum endast fr vljas om klockslaget nedan ej passerats d rendet skickas in. Om det passerats mste ett datum efter morgondagens datum vljas.</xsl:variable>
	<xsl:variable name="i18n.RestrictTomorrowTime">Ange ett klockslag</xsl:variable>	
	<xsl:variable name="i18n.WeekdayMonday">Mn</xsl:variable>
	<xsl:variable name="i18n.WeekdayTuesday">Tis</xsl:variable>
	<xsl:variable name="i18n.WeekdayWednesday">Ons</xsl:variable>
	<xsl:variable name="i18n.WeekdayThursday">Tor</xsl:variable>
	<xsl:variable name="i18n.WeekdayFriday">Fre</xsl:variable>
	<xsl:variable name="i18n.WeekdaySaturday">Lr</xsl:variable>
	<xsl:variable name="i18n.WeekdaySunday">Sn</xsl:variable>
	<xsl:variable name="i18n.RestrictUpcomingMonthsLegend">Begrnsa mnad</xsl:variable>
	<xsl:variable name="i18n.RestrictCurrentMonthCheckbox">Begrnsa innevarande mnad</xsl:variable>
	<xsl:variable name="i18n.RestrictUpcomingMonthsCheckbox">Begrnsa ven ett antal efterfljande mnader</xsl:variable>
	<xsl:variable name="i18n.RestrictCurrentMonthInfo">Denna restriktion sger inget om huruvida datumet ska vara strre eller mindre n innevarande mnad.</xsl:variable>
	<xsl:variable name="i18n.NumberOfUpcomingMonthsInfo">Ange det antal mnader som, utver innevarande mnad, ska begrnsas. Exempel: om nuvarande mnad r januari och 2 efterfljande mnader anges, d betyder det att anvndaren ej fr ange ett datum i januari, februari eller mars innevarande r.</xsl:variable>
	<xsl:variable name="i18n.NumberOfUpcomingMonths">Ange antalet efterfljande mnader som restriktionen ska glla fr</xsl:variable>
	
	<xsl:variable name="i18n.UseMultiTime">Visa frn-till flt fr tid</xsl:variable>
	<xsl:variable name="i18n.TimeInterval">Tidsintervall</xsl:variable>
	<xsl:variable name="i18n.TimeIntervalDescription">Vlj vilket intervall som skall anvndas i tid-vljaren</xsl:variable>
	<xsl:variable name="i18n.SaveChanges">Spara ndringar</xsl:variable>
	<xsl:variable name="i18n.StartDateRestrictionHeading">Ytterligare datumrestriktioner</xsl:variable>
	<xsl:variable name="i18n.EndDateRestrictionHeading">Ytterligare datumrestriktioner</xsl:variable>
	<xsl:variable name="i18n.DateRestrictionNone">Inga ytterligare restriktioner</xsl:variable>
	<xsl:variable name="i18n.RestrictPastStartDates">Krv ett startdatum som ligger BAKT i tiden</xsl:variable>
	<xsl:variable name="i18n.RestrictFutureStartDates">Krv ett startdatum som ligger FRAMT i tiden</xsl:variable>
	<xsl:variable name="i18n.RestrictPastEndDates">Krv ett slutdatum som ligger BAKT i tiden</xsl:variable>
	<xsl:variable name="i18n.RestrictFutureEndDates">Krv ett slutdatum som ligger FRAMT i tiden</xsl:variable>
	<xsl:variable name="i18n.MinStartDate">Tidigast tilltna startdatum (lmna tomt fr ingen grns)</xsl:variable>
	<xsl:variable name="i18n.MaxStartDate">Senaste tilltna startdatum (lmna tomt fr ingen grns)</xsl:variable>
	<xsl:variable name="i18n.MinStartDaysInPast">Ange det antal dagar tillbaka i tiden som angivet startdatum minst mste ligga</xsl:variable>
	<xsl:variable name="i18n.MinStartDaysInFuture">Ange det antal dagar framt i tiden som angivet startdatum minst mste ligga</xsl:variable>
	<xsl:variable name="i18n.MinDaysInPastInfo">Ange 0 fr att ven kunna ange dagens datum. Ange ett negativt vrde fr att stta den vre grnsen fr datumet till ett visst antal dagar framt i tiden till och med ondligt lngt tillbaka i tiden.</xsl:variable>
	<xsl:variable name="i18n.MinDaysInFutureInfo">Ange 0 fr att ven kunna ange dagens datum. Ange ett negativt vrde fr att kunna stta den undre grnsen fr datumet till ett visst antal dagar tillbaka i tiden till och med ondligt lngt in i framtiden.</xsl:variable>
	<xsl:variable name="i18n.RestrictedStartDays">Ange antalet dagar</xsl:variable>
	<xsl:variable name="i18n.MinEndDate">Tidigast tilltna slutdatum (lmna tomt fr ingen grns)</xsl:variable>
	<xsl:variable name="i18n.MaxEndDate">Senast tilltna slutdatum (lmna tomt fr ingen grns)</xsl:variable>
	<xsl:variable name="i18n.MinEndDaysInPast">Ange det antal dagar tillbaka i tiden som angivet slutdatum minst mste ligga</xsl:variable>
	<xsl:variable name="i18n.MinEndDaysInFuture">Ange det antal dagar framt i tiden som angivet slutdatum minst mste ligga</xsl:variable>
	<xsl:variable name="i18n.MinEndDaysInPastInfo">Ange 0 fr att ven kunna ange dagens datum. Ange ett negativt vrde fr att stta den vre grnsen fr datumet till ett visst antal dagar framt i tiden till och med ondligt lngt tillbaka i tiden.</xsl:variable>
	<xsl:variable name="i18n.MinStartDaysInFutureInfo">Ange 0 fr att ven kunna ange dagens datum. Ange ett negativt vrde fr att kunna stta den undre grnsen fr datumet till ett visst antal dagar tillbaka i tiden till och med ondligt lngt in i framtiden.</xsl:variable>
	<xsl:variable name="i18n.lockOnOwnershipTransfer">Ls frga vid verltelse</xsl:variable>
	
	<xsl:variable name="i18n.DateTimeQueryNotFound">Den begrda frgan hittades inte</xsl:variable>
	<xsl:variable name="i18n.NoChoosenFields">Du mste vlja antingen att visa datum eller tidsflt</xsl:variable>
	<xsl:variable name="i18n.LatestTimeMustBeAfterEarliestTime">Senast tid mste vara efter tidigast tid</xsl:variable>
	<xsl:variable name="i18n.RestrictedStartDaysMustBeSet">Antalet dagar startdatumrestriktionen skall glla fr mste anges</xsl:variable>
	<xsl:variable name="i18n.RestrictedEndDaysMustBeSet">Antalet dagar slutdatumrestriktionen skall glla fr mste anges</xsl:variable>
	<xsl:variable name="i18n.MinStartDateCannotBeAfterMinEndDate">Tidigast tilltna startdatum fr inte ligga efter tidigast tilltna slutdatum</xsl:variable>
	<xsl:variable name="i18n.EndDatePossiblyEarlierThanStartDate">Med denna konfiguration kan slutdatumet potentiellt ligga fre startdatumet, vilket inte r tilltet</xsl:variable>
	<xsl:variable name="i18n.MaxStartDateAfterMaxEndDate">Senast tilltna startdatum r strre n strsta tilltna slutdatum, vilket inte r tilltet</xsl:variable>
	<xsl:variable name="i18n.MinStartDateAfterMaxStartDate">Senast tilltna startdatum r strre n tidigast tilltna startdatum, vilket inte r tilltet</xsl:variable>
	<xsl:variable name="i18n.MinEndDateAfterMaxEndDate">Senast tilltna slutdatum r strre n tidigast tilltna slutdatum, vilket inte r tilltet</xsl:variable>
	<xsl:variable name="i18n.NoDayOfWeekChosen">Minst en veckodag mste tilltas</xsl:variable>
	<xsl:variable name="i18n.NoTimeInRestrictTomorrowTime">D datum ska begrnsas baserat p tid mste en tid anges</xsl:variable>
	<xsl:variable name="i18n.NoTomorrowRestrictionMode">D datum ska begrnsas p klockslag s mste frgan stllas in att antingen begrnsa dagens eller morgondagens datum</xsl:variable>
	<xsl:variable name="i18n.NumberOfRestrictedMonthsMustBeSet">Antalet efterfljande mnader som ska begrnsas fr startdatumet mste anges</xsl:variable>
	<xsl:variable name="i18n.NumberOfRestrictedEndMonthsMustBeSet">Antalet efterfljande mnader som ska begrnsas fr slutdatumet mste anges</xsl:variable>

	<xsl:variable name="i18n.AllowStartTimeAfterEndTime">Tillt att starttiden ligger efter sluttiden</xsl:variable>
	<xsl:variable name="i18n.EarliestTime">Tidigast tid (lmna tomt fr ingen grns)</xsl:variable>
	<xsl:variable name="i18n.LatestTime">Senast tid (lmna tomt fr ingen grns)</xsl:variable>
	
	<xsl:variable name="i18n.AdvancedSettings">Avancerade instllningar</xsl:variable>
	<xsl:variable name="i18n.HideTitle">Dlj rubrik</xsl:variable>
	<xsl:variable name="i18n.setAsAttribute">Spara fltets vrde som attribut</xsl:variable>
	<xsl:variable name="i18n.attributeName">Attributnamn</xsl:variable>
	<xsl:variable name="i18n.restrictedDays">Antalet dagar datumrestriktionen skall glla fr</xsl:variable>
	
</xsl:stylesheet>
