package com.nordicpeak.flowengine.queries.dynamictablequery;

import java.lang.reflect.Field;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.queries.basetablequery.BaseDropDownAlternative;

@Table(name = "dynamic_table_query_dropdown_alternatives")
@XMLElement
public class DropDownAlternative extends BaseDropDownAlternative {

	private static final long serialVersionUID = -3633714980939139207L;

	public static final Field COLUMN_RELATION = ReflectionUtils.getField(DropDownAlternative.class, "column");

	@DAOManaged(columnName = "columnID")
	@ManyToOne
	@XMLElement
	private DynamicTableColumn column;

	public DropDownAlternative() {}

	public DropDownAlternative(String name, Integer sortIndex) {

		super(name, sortIndex);
	}

	public DynamicTableColumn getColumn() {

		return column;
	}

	public void setColumn(DynamicTableColumn column) {

		this.column = column;
	}
}