package com.nordicpeak.flowengine.integration.easit.beans;

import java.lang.reflect.Field;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "easit_integration_settings")
@XMLElement
public class IntegrationSettings extends GeneratedElementable {

	public static final Field GROUPS_RELATION = ReflectionUtils.getField(IntegrationSettings.class, "parameterGroups");
	
	@Key
	@DAOManaged
	@XMLElement
	private Integer flowFamilyID;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean enabled;

	@DAOManaged(columnName = "endpointID")
	@ManyToOne(autoGet = true)
	@XMLElement
	private IntegrationEndpoint integrationEndpoint;

	@DAOManaged
	@OneToMany(autoGet = true)
	@XMLElement
	private List<IntegrationParameterGroup> parameterGroups;

	public Integer getFlowFamilyID() {

		return flowFamilyID;
	}

	public void setFlowFamilyID(Integer flowFamilyID) {

		this.flowFamilyID = flowFamilyID;
	}

	public boolean isEnabled() {

		return enabled;
	}

	public void setEnabled(boolean enabled) {

		this.enabled = enabled;
	}

	public IntegrationEndpoint getIntegrationEndpoint() {

		return integrationEndpoint;
	}

	public void setIntegrationEndpoint(IntegrationEndpoint integrationEndpoint) {

		this.integrationEndpoint = integrationEndpoint;
	}

	public List<IntegrationParameterGroup> getParameterGroups() {

		return parameterGroups;
	}

	public void setParameterGroups(List<IntegrationParameterGroup> parameterGroups) {

		this.parameterGroups = parameterGroups;
	}

	public boolean isPopulated() {

		if (enabled || integrationEndpoint != null || parameterGroups != null) {

			return true;
		}

		return false;
	}

}
