<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:variable name="globalscripts">
		/js/confirmpost.js
	</xsl:variable>	
	
	<xsl:variable name="scripts">
		/js/externalmessageoffer.js
	</xsl:variable>
	
	<xsl:variable name="links">
		/css/externalmessageoffer.css
	</xsl:variable>
	
	<xsl:template match="Document">
	
		<xsl:apply-templates select="UpdateOfferSettings"/>
		
		<xsl:apply-templates select="ShowActiveOffer"/>
		<xsl:apply-templates select="ShowAcceptedOffer"/>
		<xsl:apply-templates select="ShowDeclinedOffer"/>
		<xsl:apply-templates select="ShowWithdrawnOffer"/>
		<xsl:apply-templates select="ShowExpiredOffer"/>
			
	</xsl:template>
	
	<xsl:template match="UpdateOfferSettings">
	
		<div id="ExternalMessageSettingsForm" class="floatleft full bigmarginbottom margintop">
		
			<div class="floatleft full bigmarginbottom">
			
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="name" select="'offerEnabled'" />
					<xsl:with-param name="id" select="'offerEnabled'" />
					<xsl:with-param name="element" select="Settings" /> 
				</xsl:call-template>
				
				<label for="offerEnabled">
					<xsl:value-of select="$i18n.Status.offerEnabled" />
				</label>
				
			</div>
			
			<fieldset id="offerContainer">
			
				<xsl:if test="validationException/validationError">
					<div class="bigmarginbottom">
						<xsl:apply-templates select="validationException/validationError"/>
					</div>
				</xsl:if>
			
				<legend>
					<xsl:value-of select="$i18n.Status.offerSettings" />
				</legend>
			
				<div class="floatleft full bigmarginbottom">
				
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="name" select="'setOfferAsAttribute'" />
						<xsl:with-param name="id" select="'setOfferAsAttribute'" />
						<xsl:with-param name="element" select="Settings" /> 
					</xsl:call-template>
					
					<label for="setOfferAsAttribute">
						<xsl:value-of select="$i18n.Status.setOfferAsAttribute" />
					</label>
					
				</div>
			
				<div id="offerAttributeNameContainer" class="floatleft full bigmarginbottom">
					
					<label for="offerAttributeName">
						<xsl:value-of select="$i18n.Status.offerAttributeName" />
					</label>
					
					<div>
						<xsl:call-template name="createTextField">
							<xsl:with-param name="id" select="'offerAttributeName'"/>
							<xsl:with-param name="name" select="'offerAttributeName'"/>
							<xsl:with-param name="element" select="Settings" /> 
						</xsl:call-template>
					</div>
					
					<xsl:call-template name="addAttributeTable" />
					
				</div>
			
				<div class="floatleft full bigmarginbottom">
				
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="name" select="'setOfferTimeLimit'" />
						<xsl:with-param name="id" select="'setOfferTimeLimit'" />
						<xsl:with-param name="element" select="Settings" /> 
					</xsl:call-template>
					
					<label for="setOfferTimeLimit">
						<xsl:value-of select="$i18n.Status.setOfferTimeLimit" />
					</label>
					
				</div>
			
				<div id="offerTimeLimitSettingsContainer"  class="floatleft full bigmarginbottom">
				
					<h2>
						<xsl:value-of select="$i18n.Status.offerTimeLimit" />
					</h2>
						
					<div class="floatleft full">
						
						<label for="offerDurationDays">
							<xsl:value-of select="$i18n.Status.offerDurationDays" />
						</label>
						
						<div>
							<xsl:call-template name="createTextField">
								<xsl:with-param name="id" select="'offerDurationDays'"/>
								<xsl:with-param name="name" select="'offerDurationDays'"/>
								<xsl:with-param name="element" select="Settings" /> 
							</xsl:call-template>
						</div>
					</div>
				
					<div class="floatleft min-width-forty">
						
						<label for="offerExpiredStatus">
							<xsl:value-of select="$i18n.Status.offerExpiredStatus" />
						</label>
						
						<div>
							<xsl:call-template name="createDropdown">
									<xsl:with-param name="id" select="'offerExpiredStatus'"/>
									<xsl:with-param name="name" select="'offerExpiredStatus'"/>
									<xsl:with-param name="element" select="Statuses/Status" /> 
									<xsl:with-param name="labelElementName" select="'name'"/>
									<xsl:with-param name="valueElementName" select="'statusID'"/>
									<xsl:with-param name="selectedValue" select="Settings/offerExpiredStatus" /> 
									<xsl:with-param name="addEmptyOption" select="$i18n.Status.SelectStatus" /> 
							</xsl:call-template>
						</div>
					</div>
				
				</div>
			
				<div class="floatleft full bigmargintop bigmarginbottom">
				
					<h2>
						<xsl:value-of select="$i18n.Status.offerAccepted" />
					</h2>
				
					<div class="floatleft min-width-forty bigmarginright">
						
						<label for="offerAcceptedStatus">
							<xsl:value-of select="$i18n.Status.offerAcceptedStatus" />
						</label>
						
						<div>
							<xsl:call-template name="createDropdown">
									<xsl:with-param name="id" select="'offerAcceptedStatus'"/>
									<xsl:with-param name="name" select="'offerAcceptedStatus'"/>
									<xsl:with-param name="element" select="Statuses/Status" /> 
									<xsl:with-param name="labelElementName" select="'name'"/>
									<xsl:with-param name="valueElementName" select="'statusID'"/>
									<xsl:with-param name="selectedValue" select="Settings/offerAcceptedStatus" /> 
									<xsl:with-param name="addEmptyOption" select="$i18n.Status.SelectStatus" /> 
							</xsl:call-template>
						</div>
					</div>
				
					<div class="floatleft min-width-forty">
						
						<label for="offerAcceptedButtonText">
							<xsl:value-of select="$i18n.Status.offerAcceptedButtonText" />
						</label>
						
						<div>
							<xsl:call-template name="createTextField">
								<xsl:with-param name="id" select="'offerAcceptedButtonText'"/>
								<xsl:with-param name="name" select="'offerAcceptedButtonText'"/>
								<xsl:with-param name="element" select="Settings" /> 
								<xsl:with-param name="value" select="$i18n.Status.offerAcceptedButtonText.default" /> 
							</xsl:call-template>
						</div>
					</div>
				
					<div class="floatleft full">
						
						<label for="offerAcceptedMessage">
							<xsl:value-of select="$i18n.Status.offerAcceptedMessage" />
						</label>
						
						<div>
							<xsl:call-template name="createTextArea">
								<xsl:with-param name="id" select="'offerAcceptedMessage'"/>
								<xsl:with-param name="name" select="'offerAcceptedMessage'"/>
								<xsl:with-param name="rows" select="'4'"/>
								<xsl:with-param name="element" select="Settings" /> 
							</xsl:call-template>
						</div>
					</div>
				
				</div>
			
				<div class="floatleft full bigmargintop bigmarginbottom">
				
					<h2>
						<xsl:value-of select="$i18n.Status.offerDeclined" />
					</h2>
				
					<div class="floatleft min-width-forty bigmarginright">
						
						<label for="offerDeclinedStatus">
							<xsl:value-of select="$i18n.Status.offerDeclinedStatus" />
						</label>
						
						<div>
							<xsl:call-template name="createDropdown">
								<xsl:with-param name="id" select="'offerDeclinedStatus'"/>
								<xsl:with-param name="name" select="'offerDeclinedStatus'"/>
								<xsl:with-param name="element" select="Statuses/Status" /> 
								<xsl:with-param name="labelElementName" select="'name'"/>
								<xsl:with-param name="valueElementName" select="'statusID'"/>
								<xsl:with-param name="selectedValue" select="Settings/offerDeclinedStatus" /> 
								<xsl:with-param name="addEmptyOption" select="$i18n.Status.SelectStatus" /> 
							</xsl:call-template>
						</div>
					</div>
					
					<div class="floatleft min-width-forty">
						
						<label for="offerDeclinedButtonText">
							<xsl:value-of select="$i18n.Status.offerDeclinedButtonText" />
						</label>
						
						<div>
							<xsl:call-template name="createTextField">
								<xsl:with-param name="id" select="'offerDeclinedButtonText'"/>
								<xsl:with-param name="name" select="'offerDeclinedButtonText'"/>
								<xsl:with-param name="element" select="Settings" /> 
								<xsl:with-param name="value" select="$i18n.Status.offerDeclinedButtonText.default" /> 
							</xsl:call-template>
						</div>
					</div>
				
					<div class="floatleft full">
						
						<label for="offerDeclinedMessage">
							<xsl:value-of select="$i18n.Status.offerDeclinedMessage" />
						</label>
						
						<div>
							<xsl:call-template name="createTextArea">
								<xsl:with-param name="id" select="'offerDeclinedMessage'"/>
								<xsl:with-param name="name" select="'offerDeclinedMessage'"/>
								<xsl:with-param name="rows" select="'4'"/>
								<xsl:with-param name="element" select="Settings" /> 
							</xsl:call-template>
						</div>
					</div>
				
				</div>
			
			</fieldset>
			
		</div>
	
	</xsl:template>
	
	<xsl:template match="ShowActiveOffer">
	
		<div class="external-message-offer">

		<xsl:choose>
			<xsl:when test="Manager = 'true'">
			
				<span><xsl:value-of select="$i18n.offerActiveMessage"></xsl:value-of></span>
			
			</xsl:when>
			<xsl:otherwise>
			
				<a class="btn btn-green" onclick="return confirmHyperlinkPost(this)" title="{concat($i18n.ExternalMessage.Confirm, Offer/Settings/offerAcceptedButtonText)}" href="{OverviewExtensionURL}/accept/{Offer/offerID}">
					<xsl:value-of select="Offer/Settings/offerAcceptedButtonText" />
				</a>
			    <a class="btn btn-red" onclick="return confirmHyperlinkPost(this)" title="{concat($i18n.ExternalMessage.Confirm, Offer/Settings/offerDeclinedButtonText)}" href="{OverviewExtensionURL}/decline/{Offer/offerID}">
					<xsl:value-of select="Offer/Settings/offerDeclinedButtonText" />
				</a>

			</xsl:otherwise>
		</xsl:choose>
	
		</div>
	
	</xsl:template>
	
	<xsl:template match="ShowAcceptedOffer">
	
		<div class="external-message-offer">
			<span><xsl:value-of select="Offer/Settings/offerAcceptedMessage"></xsl:value-of></span>
		</div>
	
	</xsl:template>
	
	<xsl:template match="ShowDeclinedOffer">
	
		<div class="external-message-offer">
			<span><xsl:value-of select="Offer/Settings/offerDeclinedMessage"></xsl:value-of></span>
		</div>
	
	</xsl:template>
	
	<xsl:template match="ShowWithdrawnOffer">
	
		<div class="external-message-offer">
			<span><xsl:value-of select="$i18n.offerWithdrawnMessage"></xsl:value-of></span>
		</div>
	
	</xsl:template>
	
	<xsl:template match="ShowExpiredOffer">
	
		<div class="external-message-offer">
			<span><xsl:value-of select="$i18n.offerExpiredMessage"></xsl:value-of></span>
		</div>
	
	</xsl:template>
	
	<xsl:template name="addAttributeTable">
	
		<div class="floatleft margintop half">

			<p>
				<xsl:value-of select="$i18n.Status.AttributeTable.Description"/>
			</p>
		
			<table class="full border">
				<tr>
					<th>
						<xsl:value-of select="$i18n.Status.AttributeTable.Termination"/>
					</th>
					<th>
						<xsl:value-of select="$i18n.Status.AttributeTable.Value"/>
					</th>
				</tr>
				<tr>
					<td>
						<xsl:value-of select="$i18n.Status.AttributeTable.Accepted"/>
					</td>
					<td>
						<xsl:value-of select="$i18n.Status.AttributeTable.Accepted.Value"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:value-of select="$i18n.Status.AttributeTable.Declined"/>
					</td>
					<td>
						<xsl:value-of select="$i18n.Status.AttributeTable.Declined.Value"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:value-of select="$i18n.Status.AttributeTable.Withdrawn"/>
					</td>
					<td>
						<xsl:value-of select="$i18n.Status.AttributeTable.Withdrawn.Value"/>
					</td>
				</tr>
				<tr id="attributeTableExpiredRow">
					<td>
						<xsl:value-of select="$i18n.Status.AttributeTable.Expired"/>
					</td>
					<td>
						<xsl:value-of select="$i18n.Status.AttributeTable.Expired.Value"/>
					</td>
				</tr>
			</table>
		
		</div>
	
	</xsl:template>
		
	<xsl:template match="validationError">
		
		<xsl:if test="fieldName and validationErrorType">
			<p class="error">
				<span data-icon-before="!">
					<xsl:choose>
						<xsl:when test="validationErrorType='RequiredField'">
							<xsl:value-of select="$i18n.validationError.RequiredField" />
						</xsl:when>
						<xsl:when test="validationErrorType='InvalidFormat'">
							<xsl:value-of select="$i18n.validationError.InvalidFormat" />
						</xsl:when>
						<xsl:when test="validationErrorType='TooShort'">
							<xsl:value-of select="$i18n.validationError.TooShort" />
						</xsl:when>
						<xsl:when test="validationErrorType='TooLong'">
							<xsl:value-of select="$i18n.validationError.TooLong" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$i18n.validationError.Other" />
						</xsl:otherwise>
					</xsl:choose>
					<xsl:text>&#x20;</xsl:text>
					<xsl:choose>
						<xsl:when test="fieldName = 'offerAttributeName'">
							<xsl:value-of select="$i18n.Status.offerAttributeName" />
						</xsl:when>
						<xsl:when test="fieldName = 'offerDurationDays'">
							<xsl:value-of select="$i18n.Status.offerDurationDays" />
						</xsl:when>
						<xsl:when test="fieldName = 'offerExpiredStatus'">
							<xsl:value-of select="$i18n.Status.offerExpiredStatus" />
						</xsl:when>
						<xsl:when test="fieldName = 'offerAcceptedStatus'">
							<xsl:value-of select="$i18n.Status.offerAcceptedStatus" />
						</xsl:when>
						<xsl:when test="fieldName = 'offerAcceptedButtonText'">
							<xsl:value-of select="$i18n.Status.offerAcceptedButtonText" />
						</xsl:when>
						<xsl:when test="fieldName = 'offerAcceptedMessage'">
							<xsl:value-of select="$i18n.Status.offerAcceptedMessage" />
						</xsl:when>
						<xsl:when test="fieldName = 'offerDeclinedStatus'">
							<xsl:value-of select="$i18n.Status.offerDeclinedStatus" />
						</xsl:when>
						<xsl:when test="fieldName = 'offerDeclinedButtonText'">
							<xsl:value-of select="$i18n.Status.offerDeclinedButtonText" />
						</xsl:when>
						<xsl:when test="fieldName = 'offerDeclinedMessage'">
							<xsl:value-of select="$i18n.Status.offerDeclinedMessage" />
						</xsl:when>
						<!-- FlowAdminModule.sv.xsl -->
						<xsl:when test="fieldName = 'addExternalMessage'">
							<xsl:value-of select="$i18n.addExternalMessage" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="fieldName" />
						</xsl:otherwise>
					</xsl:choose>
					<xsl:text>!</xsl:text>
				</span>
			</p>
		</xsl:if>
		
	</xsl:template>
	
</xsl:stylesheet>