package com.nordicpeak.flowengine.externalmessageoffer.daos;

import java.sql.SQLException;

import javax.sql.DataSource;

import se.unlogic.standardutils.dao.AnnotatedDAO;
import se.unlogic.standardutils.dao.AnnotatedDAOFactory;
import se.unlogic.standardutils.dao.HighLevelQuery;
import se.unlogic.standardutils.dao.QueryParameterFactory;
import se.unlogic.standardutils.dao.TransactionHandler;

import com.nordicpeak.flowengine.externalmessageoffer.beans.ExternalMessageOfferSettings;

public class ExternalMessageOfferSettingsDAO extends AnnotatedDAO<ExternalMessageOfferSettings> {

	private final QueryParameterFactory<ExternalMessageOfferSettings, Integer> statusIDParamFactory;

	public ExternalMessageOfferSettingsDAO(DataSource dataSource, Class<ExternalMessageOfferSettings> beanClass, AnnotatedDAOFactory daoFactory) {

		super(dataSource, beanClass, daoFactory);

		statusIDParamFactory = this.getParamFactory(ExternalMessageOfferSettings.FIELD_STATUS_ID, Integer.class);
	}

	public ExternalMessageOfferSettings getByStatusID(Integer statusID) throws SQLException {

		HighLevelQuery<ExternalMessageOfferSettings> query = new HighLevelQuery<>();

		query.addParameter(statusIDParamFactory.getParameter(statusID));

		return this.get(query);
	}

	public Integer deleteByStatusID(Integer flowInstanceID, TransactionHandler transactionHandler) throws SQLException {

		HighLevelQuery<ExternalMessageOfferSettings> query = new HighLevelQuery<>();

		query.addParameter(statusIDParamFactory.getParameter(flowInstanceID));

		return this.delete(query, transactionHandler);
	}

}
