package com.nordicpeak.flowengine.externalmessageoffer.enums;

public enum ExternalMessageOfferStatus {

	ACCEPTED("accept"), 
	DECLINED("decline"), 
	ACTIVE, 
	WITHDRAWN, 
	EXPIRED;

	private String method;

	ExternalMessageOfferStatus() {}

	ExternalMessageOfferStatus(String method) {

		this.method = method;
	}

	public static ExternalMessageOfferStatus fromMethod(String method) {

		ExternalMessageOfferStatus[] statuses = ExternalMessageOfferStatus.values();

		for (ExternalMessageOfferStatus status : statuses) {

			if (status.method != null && status.method.equals(method)) {

				return status;
			}
		}

		return null;
	}

}
