package com.nordicpeak.flowengine.queries.fixedtablequery;

import java.lang.reflect.Field;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.queries.basetablequery.TableCellValue;

@Table(name = "fixed_table_query_instance_values")
@XMLElement(name = "CellValue")
public class FixedTableCellValue extends TableCellValue<DropDownAlternative, FixedTableQuery, FixedTableRow, FixedTableColumn> {

	private static final long serialVersionUID = 854568573886179411L;

	public static final Field QUERY_INSTANCE_RELATION = ReflectionUtils.getField(FixedTableCellValue.class, "instance");
	public static final Field COLUMN_RELATION = ReflectionUtils.getField(FixedTableCellValue.class, "column");
	public static final Field ROW_RELATION = ReflectionUtils.getField(FixedTableCellValue.class, "row");

	@DAOManaged(columnName = "queryInstanceID")
	@ManyToOne
	private FixedTableQueryInstance instance;

	@DAOManaged(columnName = "columnID")
	@ManyToOne
	@XMLElement
	private FixedTableColumn column;

	@DAOManaged(columnName = "rowID")
	@ManyToOne
	@XMLElement
	private FixedTableRow row;

	public FixedTableCellValue() {}

	public FixedTableCellValue(FixedTableRow row, FixedTableColumn column, String value) {

		super(value);

		this.row = row;
		this.column = column;
	}

	public FixedTableCellValue(FixedTableRow row, FixedTableColumn column, String value, String displayValue, String xmlValue) {

		super(value, displayValue, xmlValue);

		this.row = row;
		this.column = column;
	}

	public FixedTableQueryInstance getInstance() {

		return instance;
	}

	public void setInstance(FixedTableQueryInstance instance) {

		this.instance = instance;
	}

	@Override
	public FixedTableColumn getColumn() {

		return column;
	}

	public void setColumn(FixedTableColumn textField) {

		this.column = textField;
	}

	@Override
	public FixedTableRow getRow() {

		return row;
	}

	public void setRow(FixedTableRow tableRow) {

		this.row = tableRow;
	}
}
