package com.nordicpeak.flowengine.queries.fixedtablequery;

import java.lang.reflect.Field;

import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.populators.EnumPopulator;
import se.unlogic.webutils.http.BeanRequestPopulator;

import com.nordicpeak.flowengine.populators.AlternativesPopulator;
import com.nordicpeak.flowengine.queries.basetablequery.ColumnType;
import com.nordicpeak.flowengine.queries.basetablequery.TableColumnCRUD;

public class FixedTableColumnCRUD extends TableColumnCRUD<DropDownAlternative, FixedTableCellValue, FixedTableRow, FixedTableQueryInstance, FixedTableColumn, FixedTableQuery, FixedTableQueryProviderModule> {

	protected AnnotatedDAOWrapper<FixedTableColumn, Integer> tableColumnDAO;

	protected static EnumPopulator<ColumnType> COLUM_TYPE_POPULATOR = new EnumPopulator<>(ColumnType.class);
	protected static AlternativesPopulator<DropDownAlternative> ALTERNATIVES_POPLATOR = new AlternativesPopulator<>(DropDownAlternative.class, "DropDownAlternatives");

	public FixedTableColumnCRUD(AnnotatedDAOWrapper<FixedTableColumn, Integer> tableColumnDAO, BeanRequestPopulator<FixedTableColumn> populator, String typeElementName, String typeLogName, String listMethodAlias, FixedTableQueryProviderModule callback) {

		super(tableColumnDAO, populator, typeElementName, typeLogName, listMethodAlias, callback);
	}

	@Override
	protected AlternativesPopulator<DropDownAlternative> getAlternativesPopulator() {

		return ALTERNATIVES_POPLATOR;
	}

	@Override
	protected Field[] getColumnRelations() {

		return new Field[] { FixedTableColumn.QUERY_RELATION, FixedTableColumn.ROWSUM_ADD_COLUMNS_RELATION, FixedTableColumn.ROWSUM_SUBTRACT_COLUMNS_RELATION };
	}

}
