<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:template match="Document">	
		
		<div id="FixedTableQueryProvider" class="contentitem">
		
			<xsl:apply-templates select="validationError"/>
			<xsl:apply-templates select="ShowFixedTableQuery"/>
			<xsl:apply-templates select="UpdateFixedTableQuery"/>
			<xsl:apply-templates select="AddFixedTableRow"/>
			<xsl:apply-templates select="UpdateFixedTableRow"/>
			<xsl:apply-templates select="AddFixedTableColumn"/>
			<xsl:apply-templates select="UpdateFixedTableColumn"/>
			<xsl:apply-templates select="SortColumns"/>
			<xsl:apply-templates select="SortRows"/>
			
		</div>
		
	</xsl:template>
	
	<xsl:template match="AddFixedTableColumn">
		<xsl:call-template name="AddTableColumn"/>
	</xsl:template>
	
	<xsl:template match="UpdateFixedTableColumn">
		<xsl:call-template name="UpdateTableColumn"/>
	</xsl:template>
		
	<xsl:template match="ShowFixedTableQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateQuery" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="FixedTableQuery/QueryDescriptor/name" /></h1>
		
		<fieldset>
			<legend><xsl:value-of select="$i18n.BaseInfo"/></legend>
			
			<div class="floatright">
				<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/updatequery/{FixedTableQuery/queryID}" title="{$i18n.UpdateBaseInformation}">
					<img class="alignbottom" src="{$imagePath}/pen.png"/>
				</a>
			</div>
			
			<xsl:call-template name="createCommonShowFields">
				<xsl:with-param name="element" select="FixedTableQuery" />
			</xsl:call-template>
			
			<xsl:if test="not(FixedTableQuery/hideRowLabels = 'true')">
				<div class="clearboth floatleft bigmarginbottom">
					<label class="floatleft clearboth"><xsl:value-of select="$i18n.RowsLabel" /></label>
					<div class="floatleft full">
						<xsl:value-of select="FixedTableQuery/rowsLabel" disable-output-escaping="yes" />
					</div>
				</div>
			</xsl:if>
			
			<div class="clearboth floatleft bigmarginbottom">
				<label class="floatleft clearboth"><xsl:value-of select="$i18n.HideRowsLabels" /></label>
				<div class="floatleft full">
					<xsl:choose>
						<xsl:when test="FixedTableQuery/hideRowLabels = 'true'">
							<xsl:value-of select="$i18n.Yes" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$i18n.No" />
						</xsl:otherwise>
					</xsl:choose>
				</div>
			</div>
			
			<div class="clearboth floatleft bigmarginbottom">
				<label class="floatleft clearboth"><xsl:value-of select="$i18n.Query.decimalsToShow.show" /></label>
				<div class="floatleft full">
					<xsl:choose>
						<xsl:when test="FixedTableQuery/decimalsToShow">
							<xsl:value-of select="FixedTableQuery/decimalsToShow" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$i18n.Query.decimalsToShow.show.automatic" />
						</xsl:otherwise>
					</xsl:choose>
				</div>
			</div>
			
			<div class="clearboth floatleft bigmarginbottom">
				<label class="floatleft clearboth"><xsl:value-of select="$i18n.HideTitle" /></label>
				<div class="floatleft full">
					<xsl:choose>
						<xsl:when test="FixedTableQuery/hideTitle = 'true'">
							<xsl:value-of select="$i18n.Yes" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$i18n.No" />
						</xsl:otherwise>
					</xsl:choose>
				</div>
			</div>
			
		</fieldset>
		
		<fieldset>
			<legend><xsl:value-of select="$i18n.Columns"/></legend>
			
			<xsl:if test="FixedTableQuery/Columns/Column">
				
				<div class="floatleft full">
				
					<xsl:apply-templates select="FixedTableQuery/Columns/Column" mode="list" />
			
				</div>
			
				<div class="floatright">
					<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/sortcolumns/{FixedTableQuery/queryID}" title="{$i18n.SortColumns.Title}">
						<xsl:value-of select="$i18n.SortColumns.Title"/>
						<img class="alignbottom marginleft" src="{$commonImagePath}/move.png"/>
					</a>
				</div>
				
			</xsl:if>
			
			<div class="clearboth floatright">
				<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/addcolumn/{FixedTableQuery/queryID}" title="{$i18n.AddColumn}">
					<xsl:value-of select="$i18n.AddColumn"/>
					<img class="alignbottom marginleft" src="{$commonImagePath}/add.png"/>
				</a>
			</div>
			
		</fieldset>
		
		<fieldset>
			<legend><xsl:value-of select="$i18n.Rows"/></legend>
			
			<xsl:if test="FixedTableQuery/Rows/Row">
				
				<div class="floatleft full">
				
					<xsl:apply-templates select="FixedTableQuery/Rows/Row" mode="list" />
			
				</div>
			
				<div class="floatright">
					<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/sortrows/{FixedTableQuery/queryID}" title="{$i18n.SortRows.Title}">
						<xsl:value-of select="$i18n.SortRows.Title"/>
						<img class="alignbottom marginleft" src="{$commonImagePath}/move.png"/>
					</a>
				</div>
				
			</xsl:if>
			
			<div class="clearboth floatright">
				<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/addrow/{FixedTableQuery/queryID}" title="{$i18n.AddRow}">
					<xsl:value-of select="$i18n.AddRow"/>
					<img class="alignbottom marginleft" src="{$commonImagePath}/add.png"/>
				</a>
			</div>
			
		</fieldset>
		
		<div class="floatright margintop clearboth">
			<input type="button" value="{$i18n.Done}" onclick="window.location = '{showFlowURL}'" />
		</div>
		
	</xsl:template>
		
	<xsl:template match="Row" mode="list">
		
		<div class="floatleft hover border full marginbottom border-radius lightbackground">
			
			<div class="padding floatleft thirty">
				<div><xsl:value-of select="label" /></div>
			</div>
			<div class="padding floatleft" style="width: 100px;">
			</div>
			<div class="padding floatleft text-align-center" style="width: 80px;">
				<xsl:if test="required='true'">
					<div><xsl:value-of select="$i18n.Required" /></div>
				</xsl:if>
			</div>
			
			<div class="padding floatright">
				<div class="floatright marginleft marginright">
					<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/deleterow/{rowID}" onclick="return confirm('{$i18n.DeleteRow.Confirm}: {label}?');" title="{$i18n.DeleteRow}: {label}">
						<img src="{$imagePath}/delete.png"/>
					</a>
				</div>
				<div class="floatright">
					<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/updaterow/{rowID}" title="{$i18n.UpdateRow}: {label}">
						<img src="{$imagePath}/pen.png"/>
					</a>
				</div>
			</div>
			
		</div>
		
	</xsl:template>
	
	<xsl:template match="AddFixedTableRow">
	
		<h1><xsl:value-of select="$i18n.AddRow" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
	
		<form id="addRowForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
			
			<xsl:call-template name="showRowForm" />
		
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.Add}" />
			</div>
		
		</form>
	
	</xsl:template>
	
	<xsl:template match="UpdateFixedTableRow">
	
		<h1><xsl:value-of select="$i18n.UpdateRow" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="Row/label" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="udpateRowForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<xsl:call-template name="showRowForm">
				<xsl:with-param name="element" select="Row" />
			</xsl:call-template>
		
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
		
		</form>
	
	</xsl:template>
	
	<xsl:template name="showRowForm">
		
		<xsl:param name="element" select="null" />
		
		<div class="floatleft full bigmarginbottom">
			<label for="label" class="floatleft clearboth"><xsl:value-of select="$i18n.Label" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'label'"/>
					<xsl:with-param name="name" select="'label'"/>
					<xsl:with-param name="title" select="$i18n.Label"/>
					<xsl:with-param name="element" select="$element" />
				</xsl:call-template>
			</div>
		</div>
		
		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'required'" />
					<xsl:with-param name="name" select="'required'" />
					<xsl:with-param name="element" select="$element" /> 
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>
					
				<label for="required">
					<xsl:value-of select="$i18n.RequiredIfCellRequired" />
				</label>
			</div>
		</div>

		<div class="floatleft full bigmarginbottom">
			<label for="helpText" class="floatleft clearboth"><xsl:value-of select="$i18n.RowHelpText" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextArea">
					<xsl:with-param name="id" select="'helpText'"/>
					<xsl:with-param name="name" select="'helpText'"/>
					<xsl:with-param name="title" select="$i18n.RowHelpText"/>
					<xsl:with-param name="rows">3</xsl:with-param>
					<xsl:with-param name="element" select="$element" />
				</xsl:call-template>
			</div>
		</div>
		
	</xsl:template>
	
	<xsl:template match="UpdateFixedTableQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateBaseInformation" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="updateFixedTableQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="FixedTableQuery" />
				<xsl:with-param name="flowTypeID" select="FlowType/flowTypeID" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'hideRowLabels'"/>
					<xsl:with-param name="name" select="'hideRowLabels'"/>
					<xsl:with-param name="title" select="$i18n.HideRowsLabels"/>
					<xsl:with-param name="element" select="FixedTableQuery" />
					<xsl:with-param name="onclick">
						<xsl:text>$("#rowsLabel").prop('disabled', $(this).prop('checked'));</xsl:text>
					</xsl:with-param>
				</xsl:call-template>
				
				<label for="hideRowLabels"><xsl:value-of select="$i18n.HideRowsLabels" /></label>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="helpText" class="floatleft clearboth"><xsl:value-of select="$i18n.RowsLabel" /></label>
				
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'rowsLabel'"/>
						<xsl:with-param name="name" select="'rowsLabel'"/>
						<xsl:with-param name="title" select="$i18n.RowsLabel"/>
						<xsl:with-param name="element" select="FixedTableQuery" />
						<xsl:with-param name="disabled" select="FixedTableQuery/hideRowLabels = 'true'" />
					</xsl:call-template>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="decimalsToShow" class="floatleft clearboth"><xsl:value-of select="$i18n.Query.decimalsToShow.update" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'decimalsToShow'"/>
						<xsl:with-param name="name" select="'decimalsToShow'"/>
						<xsl:with-param name="title" select="$i18n.Query.decimalsToShow.update"/>
						<xsl:with-param name="element" select="FixedTableQuery" />
					</xsl:call-template>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'hideTitle'" />
						<xsl:with-param name="name" select="'hideTitle'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="FixedTableQuery" />
					</xsl:call-template>
					
					<label for="hideTitle">
						<xsl:value-of select="$i18n.HideTitle" />
					</label>
				</div>

			</div>
			
			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
		
		</form>
		
	</xsl:template>

	<xsl:template match="SortRows">
		
		<h1><xsl:value-of select="$i18n.SortRows" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="FixedTableQuery/QueryDescriptor/name" /></h1>
		
		<form id="sortRowsForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<div class="floatleft full sortable">
							
				<xsl:apply-templates select="FixedTableQuery/Rows/Row" mode="sort" />
							
			</div>
			
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>

		</form>
		
	</xsl:template>
	
	<xsl:template match="Row" mode="sort">
	
		<!-- TODO Use of //requestparameters below is very slow and needs to be replaced -->
	
		<div id="row_{rowID}" class="floatleft hover border full marginbottom lightbackground cursor-move border-radius">
			<div class="padding">
				<img class="vertical-align-middle marginright" src="{$commonImagePath}/move.png" title="{$i18n.MoveAlternative}"/>
				<xsl:value-of select="label" />
				<xsl:call-template name="createHiddenField">
					<xsl:with-param name="id" select="concat('sortorder_', rowID)" />
					<xsl:with-param name="name" select="concat('sortorder_', rowID)" />
					<xsl:with-param name="value" select="sortIndex" />
					<xsl:with-param name="class" select="'sortorder'" />
					<xsl:with-param name="requestparameters" select="//requestparameters" />
				</xsl:call-template>
			</div>
		</div>
	
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'UpdateFailedFixedTableQueryNotFound']">
		
		<p class="error">
			<xsl:value-of select="$i18n.TableQueryNotFound" />
		</p>
		
	</xsl:template>
	
	<xsl:template name="fieldName">
		<xsl:param name="fieldName"/>
	
		<xsl:choose>
			<xsl:when test="$fieldName = 'rowsLabel'">
				<xsl:value-of select="$i18n.RowsLabel" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>

</xsl:stylesheet>