package com.nordicpeak.flowengine.api.listeners;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.standardutils.xml.ElementableListener;
import se.unlogic.standardutils.xml.XMLUtils;

import com.nordicpeak.flowengine.beans.FlowInstance;


public class FlowInstanceTimestampMillisecondElementableListener implements ElementableListener<FlowInstance> {

	@Override
	public void elementGenerated(Document doc, Element element, FlowInstance flowInstance) {
		
		if (flowInstance.getAdded() != null) {
			
			XMLUtils.appendNewElement(doc, element, "addedInMilliseconds", flowInstance.getAdded().getTime());
		}
		
		if (flowInstance.getUpdated() != null) {
			
			XMLUtils.appendNewElement(doc, element, "updatedInMilliseconds", flowInstance.getUpdated().getTime());
		}
		
		if (flowInstance.getFirstSubmitted() != null) {
			
			XMLUtils.appendNewElement(doc, element, "firstSubmittedInMilliseconds", flowInstance.getFirstSubmitted().getTime());
		}
		
		if (flowInstance.getLastStatusChange() != null) {
			
			XMLUtils.appendNewElement(doc, element, "lastStatusChangeInMilliseconds", flowInstance.getLastStatusChange().getTime());
		}
	}

}
