package com.nordicpeak.flowengine.flowinstanceadmin2.interfaces;

import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.ScriptTag;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLUtils;

@XMLElement
public class ListOverviewButtonExtension extends GeneratedElementable {

	@XMLElement
	private final String name;

	@XMLElement
	private final String title;

	@XMLElement
	private final String extraClasses;

	private final Map<String, String> dataAttributes;

	private final List<ScriptTag> scripts;

	public ListOverviewButtonExtension(String name, String extraClasses, Map<String, String> dataAttributes, List<ScriptTag> scripts) {
		super();

		this.name = name;
		this.title = name;
		this.extraClasses = extraClasses;
		this.dataAttributes = dataAttributes;
		this.scripts = scripts;
	}

	public ListOverviewButtonExtension(String name, String title, String extraClasses, Map<String, String> dataAttributes, List<ScriptTag> scripts) {
		super();

		this.name = name;
		this.title = title;
		this.extraClasses = extraClasses;
		this.dataAttributes = dataAttributes;
		this.scripts = scripts;
	}

	@Override
	public Element toXML(Document doc) {

		Element element = super.toXML(doc);

		if (dataAttributes != null) {

			Element dataAttributesElement = XMLUtils.appendNewElement(doc, element, "DataAttributes");

			for (Entry<String, String> entry : dataAttributes.entrySet()) {

				Element entryEement = XMLUtils.appendNewElement(doc, dataAttributesElement, "Attribute");
				XMLUtils.appendNewElement(doc, entryEement, "Name", entry.getKey());
				XMLUtils.appendNewElement(doc, entryEement, "Value", entry.getValue());
			}
		}

		return element;
	}

	public String getName() {
		return name;
	}

	public String getTitle() {
		return title;
	}

	public String getExtraClasses() {
		return extraClasses;
	}

	public Map<String, String> getDataAttributes() {
		return dataAttributes;
	}

	public List<ScriptTag> getScripts() {
		return scripts;
	}

}
