$(function() {

	$("form[data-form-submit-progress-url]").on("submit", function(e) {

		var $form = $(this);
		var uuid = generateUUID();
		var url = this.dataset.formSubmitProgressUrl + "/" + uuid;

		$("<input />").attr("type", "hidden")
			.attr("name", "submitProgressUUID")
			.attr("value", uuid)
			.appendTo($form);

		var $modal;
		var progressCheckPaused = false;

		function progressCheckRequest() {

			if (progressCheckPaused) {

				return;
			}

			$.ajax({
				url: url,
				cache: false,
				dataType: "json",
				beforeSend: function(jqXHR, settings) {
					jqXHR.setRequestHeader('NoLoginRedirect', 'true');
				},
				success: function(data) {

					if (progressCheckPaused) {

						return;
					}

					var progress = data.progress;

					if (!progress) {

						clearInterval(progressCheckInterval);
					}

					if (!$modal) {

						var $progressContainer = $("<div />").addClass("progressContainer");

						var $progressHeading = $("<h2 />").text($form.data("form-submit-progress-heading")).appendTo($progressContainer);
						var $progressText = $("<p />").addClass("progressText").appendTo($progressContainer);

						var $progressBarContainer = $("<div />").addClass("progressBarContainer").appendTo($progressContainer);
						var $progressBar = $("<div />").addClass("progressBar").appendTo($progressBarContainer);

						$modal = $.featherlight($progressContainer, {
							"afterClose": function() {

								progressCheckPaused = true;
								$modal = undefined;
							}
						}).$content;
					}

					var progressText = $form.data("form-submit-progress-text")
						.replace("{current}", progress.current)
						.replace("{total}", progress.total);

					$modal.find('.progressText').text(progressText);
					$modal.find('.progressBar').css('width', progress.percentage + '%');
				},
				error: function() {

					clearInterval(progressCheckInterval);
				}
			});
		}

		var progressCheckInterval = setInterval(progressCheckRequest, 2000);

		$form.find("input[type='submit']").on("click", function(e) {

			e.preventDefault();

			progressCheckPaused = false;

			progressCheckRequest();

		});

	});

	function generateUUID() {
		var chars = '0123456789abcdef'.split('');
		var uuid = [],
			rnd = Math.random;
		var r;
		uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
		uuid[14] = '4';
		for (var i = 0; i < 36; i++) {
			if (!uuid[i]) {
				r = 0 | rnd() * 16;
				uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r & 0xf];
			}
		}
		return uuid.join('');
	}

});