package com.nordicpeak.flowengine.flowinstanceadmin2.sendmessages;

import java.io.IOException;
import java.lang.reflect.Field;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import javax.sql.rowset.serial.SerialBlob;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUploadBase.SizeLimitExceededException;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.io.FilenameUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.emailutils.framework.Attachment;
import se.unlogic.emailutils.framework.EmailUtils;
import se.unlogic.emailutils.framework.SimpleEmail;
import se.unlogic.emailutils.populators.EmailPopulator;
import se.unlogic.fileuploadutils.MultipartRequest;
import se.unlogic.hierarchy.core.annotations.CheckboxSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.GroupMultiListSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.InstanceManagerDependency;
import se.unlogic.hierarchy.core.annotations.ModuleSetting;
import se.unlogic.hierarchy.core.annotations.TextFieldSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.WebPublic;
import se.unlogic.hierarchy.core.annotations.XSLVariable;
import se.unlogic.hierarchy.core.beans.Group;
import se.unlogic.hierarchy.core.beans.ScriptTag;
import se.unlogic.hierarchy.core.beans.SimpleAccessInterface;
import se.unlogic.hierarchy.core.beans.SimpleForegroundModuleResponse;
import se.unlogic.hierarchy.core.beans.SimpleSMS;
import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.enums.CRUDAction;
import se.unlogic.hierarchy.core.enums.EventTarget;
import se.unlogic.hierarchy.core.events.CRUDEvent;
import se.unlogic.hierarchy.core.exceptions.AccessDeniedException;
import se.unlogic.hierarchy.core.exceptions.ModuleConfigurationException;
import se.unlogic.hierarchy.core.exceptions.URINotFoundException;
import se.unlogic.hierarchy.core.interfaces.AccessInterface;
import se.unlogic.hierarchy.core.interfaces.ForegroundModuleResponse;
import se.unlogic.hierarchy.core.interfaces.SectionInterface;
import se.unlogic.hierarchy.core.interfaces.modules.descriptors.ForegroundModuleDescriptor;
import se.unlogic.hierarchy.core.interfaces.sms.SMSSender;
import se.unlogic.hierarchy.core.utils.AccessUtils;
import se.unlogic.hierarchy.core.utils.FileItemAttachment;
import se.unlogic.hierarchy.core.utils.ModuleUtils;
import se.unlogic.hierarchy.core.validationerrors.FileSizeLimitExceededValidationError;
import se.unlogic.hierarchy.core.validationerrors.RequestSizeLimitExceededValidationError;
import se.unlogic.hierarchy.foregroundmodules.AnnotatedForegroundModule;
import se.unlogic.hierarchy.foregroundmodules.staticcontent.StaticContentModule;
import se.unlogic.standardutils.arrays.ArrayUtils;
import se.unlogic.standardutils.collections.CollectionUtils;
import se.unlogic.standardutils.dao.AnnotatedDAO;
import se.unlogic.standardutils.dao.LowLevelQuery;
import se.unlogic.standardutils.dao.QueryParameterFactory;
import se.unlogic.standardutils.dao.querys.ArrayListQuery;
import se.unlogic.standardutils.dao.querys.ObjectQuery;
import se.unlogic.standardutils.date.DateUtils;
import se.unlogic.standardutils.io.BinarySizeFormater;
import se.unlogic.standardutils.io.BinarySizes;
import se.unlogic.standardutils.numbers.NumberUtils;
import se.unlogic.standardutils.populators.IntegerPopulator;
import se.unlogic.standardutils.string.AnnotatedBeanTagSourceFactory;
import se.unlogic.standardutils.string.SingleTagSource;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.string.TagReplacer;
import se.unlogic.standardutils.time.TimeUtils;
import se.unlogic.standardutils.validation.PositiveStringIntegerValidator;
import se.unlogic.standardutils.validation.SwedishPhoneNumberValidator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationErrorType;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLGeneratorDocument;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.standardutils.xsl.XSLVariableReader;
import se.unlogic.standardutils.xsl.XSLVariableReaderRenamer;
import se.unlogic.webutils.http.RequestUtils;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.validation.ValidationUtils;

import com.nordicpeak.flowengine.FlowAdminModule;
import com.nordicpeak.flowengine.UserFlowInstanceModule;
import com.nordicpeak.flowengine.beans.Contact;
import com.nordicpeak.flowengine.beans.ExternalMessage;
import com.nordicpeak.flowengine.beans.ExternalMessageAttachment;
import com.nordicpeak.flowengine.beans.Flow;
import com.nordicpeak.flowengine.beans.FlowFamily;
import com.nordicpeak.flowengine.beans.FlowInstance;
import com.nordicpeak.flowengine.beans.FlowInstanceEvent;
import com.nordicpeak.flowengine.beans.FlowType;
import com.nordicpeak.flowengine.beans.QueryInstanceDescriptor;
import com.nordicpeak.flowengine.beans.Status;
import com.nordicpeak.flowengine.dao.FlowEngineDAOFactory;
import com.nordicpeak.flowengine.enums.ContentType;
import com.nordicpeak.flowengine.enums.EventType;
import com.nordicpeak.flowengine.enums.ManagerAccess;
import com.nordicpeak.flowengine.enums.SenderType;
import com.nordicpeak.flowengine.events.ExternalMessageAddedEvent;
import com.nordicpeak.flowengine.flowinstanceadmin2.FlowInstanceAdmin2Module;
import com.nordicpeak.flowengine.flowinstanceadmin2.interfaces.ListOverviewButtonExtension;
import com.nordicpeak.flowengine.flowinstanceadmin2.interfaces.ListOverviewButtonExtensionProvider;
import com.nordicpeak.flowengine.flowinstanceadmin2.sendmessages.validationerrors.ExternalMessagesDisabledValidationError;
import com.nordicpeak.flowengine.interfaces.QueryHandler;
import com.nordicpeak.flowengine.multisigninghandlers.MultiSigningHandler2Module;
import com.nordicpeak.flowengine.multisigninghandlers.SigningSession;
import com.nordicpeak.flowengine.multisigninghandlers.SigningSessionParty;
import com.nordicpeak.flowengine.notifications.StandardFlowNotificationHandler;
import com.nordicpeak.flowengine.utils.FlowInstanceEventGenerator;
import com.nordicpeak.flowengine.utils.FlowInstanceUtils;


public class FlowInstanceAdminSendMessagesModule extends AnnotatedForegroundModule implements ListOverviewButtonExtensionProvider {

	private static final List<Field> LIST_FLOW_FAMILIES_IGNORED_FIELDS = Arrays.asList(FlowType.ALLOWED_ADMIN_GROUPS_RELATION, FlowType.ALLOWED_QUERIES_RELATION, FlowType.ALLOWED_ADMIN_USERS_RELATION, FlowType.CATEGORIES_RELATION, Flow.STATUSES_RELATION, Flow.DEFAULT_FLOW_STATE_MAPPINGS_RELATION, Flow.STEPS_RELATION, Flow.TAGS_RELATION, FlowFamily.MANAGER_USERS_RELATION, FlowFamily.MANAGER_GROUPS_RELATION);
	private static final List<Field> LIST_FLOW_VERSIONS_IGNORED_FIELDS = Arrays.asList(FlowType.ALLOWED_ADMIN_GROUPS_RELATION, FlowType.ALLOWED_QUERIES_RELATION, FlowType.ALLOWED_ADMIN_USERS_RELATION, FlowType.CATEGORIES_RELATION, Flow.STATUSES_RELATION, Flow.DEFAULT_FLOW_STATE_MAPPINGS_RELATION, Flow.TAGS_RELATION, FlowFamily.MANAGER_USERS_RELATION, FlowFamily.MANAGER_GROUPS_RELATION, Flow.FLOW_TYPE_RELATION);
	
	protected static final List<ContentType> ALLOWED_CONTENT_TYPES = Arrays.asList(new ContentType[] { ContentType.NEW, ContentType.WAITING_FOR_MULTISIGN, ContentType.WAITING_FOR_PAYMENT, ContentType.SUBMITTED, ContentType.WAITING_FOR_COMPLETION, ContentType.IN_PROGRESS, ContentType.ARCHIVED });
	
	protected static final ValidationError FLOW_FAMILY_NOT_FOUND_VALIDATION_ERROR = new ValidationError("FlowFamilyNotFound");
	protected static final ValidationError FLOW_FAMILY_ACCESS_DENIED_VALIDATION_ERROR = new ValidationError("FlowFamilyAccessDenied");
	protected static final ValidationError NO_FLOW_VERSIONS_SELECTED_VALIDATION_ERROR = new ValidationError("NoFlowVersionsSelected");
	protected static final ValidationError NO_RECIPIENTS_VALIDATION_ERROR = new ValidationError("NoRecipients");
	protected static final ValidationError NO_STATUSES_VALIDATION_ERROR = new ValidationError("NoStatusesSelected");
	protected static final ValidationError NO_MESSAGE_PATH_VALIDATION_ERROR = new ValidationError("NoMessagePathSelected");
	protected static final ValidationError NO_MULTISIGN_TYPES_VALIDATION_ERROR = new ValidationError("NoMultiSignTypesSelected");
	
	private static final AnnotatedBeanTagSourceFactory<Flow> FLOW_TAG_SOURCE_FACTORY = new AnnotatedBeanTagSourceFactory<Flow>(Flow.class, "$flow.");
	private static final AnnotatedBeanTagSourceFactory<FlowInstance> FLOWINSTANCE_TAG_SOURCE_FACTORY = new AnnotatedBeanTagSourceFactory<FlowInstance>(FlowInstance.class, "$flowInstance.");
	private static final AnnotatedBeanTagSourceFactory<Contact> CONTACT_TAG_SOURCE_FACTORY = new AnnotatedBeanTagSourceFactory<Contact>(Contact.class, "$contact.");

	private static final EmailPopulator EMAIL_POPULATOR = new EmailPopulator();
	
	@XSLVariable(prefix = "java.")
	private String buttonName = "send messages";
	
	@XSLVariable(prefix = "java.")
	private String buttonTitle = "send messages";
	
	@XSLVariable(prefix = "java.")
	private String description = "Description";
	
	@XSLVariable(prefix = "java.")
	private String status = "Status";

	@XSLVariable(prefix = "java.")
	private String submitted = "Submitted";

	@XSLVariable(prefix = "java.")
	private String siteProfile = "Site profile";
	
	@XSLVariable(prefix = "java.")
	private String managers = "Managers";
	
	@XSLVariable(prefix = "java.")
	private String anonymousSubmitter = "Anonymous Submitter";
	
	@XSLVariable(prefix = "java.")
	private String eventSent = "Message sent via";
	
	@XSLVariable(prefix = "java.")
	private String eventEmailSent = "email";
	
	@XSLVariable(prefix = "java.")
	private String eventSMSSent = "SMS";
	
	@XSLVariable(prefix = "java.")
	private String eventMessageSent = "message";
	
	@ModuleSetting(allowsNull = true)
	@TextFieldSettingDescriptor(name = "Temp dir", description = "Directory for temporary files. Should be on the same filesystem as the file store for best performance. If not set system default temp directory will be used")
	protected String tempDir;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Max request size", description = "Maxmium allowed request size in megabytes", required = true, formatValidator = PositiveStringIntegerValidator.class)
	protected Integer maxRequestSize = 1000;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "RAM threshold", description = "Maximum size of files in KB to be buffered in RAM during file uploads. Files exceeding the threshold are written to disk instead.", required = true, formatValidator = PositiveStringIntegerValidator.class)
	protected Integer ramThreshold = 500;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Max e-mail file size", description = "Maxmium allowed file size in megabytes for e-mail attachments", required = true, formatValidator = PositiveStringIntegerValidator.class)
	protected Integer maxEmailFileSize = 50;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Max external message file size", description = "Maxmium allowed file size in megabytes for external message attachments", required = true, formatValidator = PositiveStringIntegerValidator.class)
	protected Integer maxExternalMessageFileSize = 50;

	@ModuleSetting
	@CheckboxSettingDescriptor(name = "Force email sender address from notification handler", description = "Controls if email sender adress from notification handler should be used when sending emails from this module.")
	protected boolean forceAutomaticEmailSenderAddress;

	@ModuleSetting(allowsNull = true)
	@GroupMultiListSettingDescriptor(name = "Global access groups", description = "Groups with access to export all flows")
	protected List<Integer> globalAccessGroups;
	
	@ModuleSetting
	@TextFieldSettingDescriptor(name="FlowAdminExtensionView priority", description="The priority of this provider", required=true)
	private Integer flowAdminExtensionViewPriority = 0;
	
	@ModuleSetting
	@CheckboxSettingDescriptor(name = "Enable fragment XML debug", description = "Enables debugging of fragment XML")
	private boolean debugFragmentXML;

	@InstanceManagerDependency(required = true)
	private FlowAdminModule flowAdminModule;
	private FlowInstanceAdmin2Module flowInstanceAdmin2Module;
	
	@InstanceManagerDependency
	protected UserFlowInstanceModule userFlowInstanceModule;
	
	@InstanceManagerDependency(required = true)
	protected StaticContentModule staticContentModule;
	
	@InstanceManagerDependency(required = true)
	private QueryHandler queryHandler;
	
	@InstanceManagerDependency(required = true)
	protected StandardFlowNotificationHandler flowNotificationHandler;
	
	@InstanceManagerDependency
	protected SMSSender smsSender;
	
	@InstanceManagerDependency
	protected MultiSigningHandler2Module multiSigningHandler;
	
	private AnnotatedDAO<FlowInstance> flowInstanceDAO;
	private AnnotatedDAO<ExternalMessage> externalMessageDAO;
	
	protected QueryParameterFactory<FlowInstance, Integer> flowInstanceIDParamFactory;
	protected QueryParameterFactory<QueryInstanceDescriptor, Integer> queryInstanceDescriptorFlowInstanceIDParamFactory;
	
	protected FlowInstanceEventGenerator flowInstanceEventGenerator;
	
	private AccessInterface globalAccess;
	private List<ScriptTag> buttonExtensionScripts;
	private Map<String, String> listOverviewButtonDataAttributes;
	
	@Override
	public void init(ForegroundModuleDescriptor moduleDescriptor, SectionInterface sectionInterface, DataSource dataSource) throws Exception {
	
		super.init(moduleDescriptor, sectionInterface, dataSource);
		
		if (!systemInterface.getInstanceHandler().addInstance(FlowInstanceAdminSendMessagesModule.class, this)) {
			
			throw new RuntimeException("Unable to register module in global instance handler using key " + FlowInstanceAdminSendMessagesModule.class.getSimpleName() + ", another instance is already registered using this key.");
		}
	}
	
	@Override
	protected void createDAOs(DataSource dataSource) throws Exception {
		
		FlowEngineDAOFactory daoFactory = new FlowEngineDAOFactory(dataSource, systemInterface.getUserHandler(), systemInterface.getGroupHandler());

		flowInstanceDAO = daoFactory.getFlowInstanceDAO();
		externalMessageDAO = daoFactory.getExternalMessageDAO();
		
		flowInstanceIDParamFactory = flowInstanceDAO.getParamFactory("flowInstanceID", Integer.class);
		
		queryInstanceDescriptorFlowInstanceIDParamFactory = daoFactory.getQueryInstanceDescriptorDAO().getParamFactory("flowInstanceID", Integer.class);
		
		flowInstanceEventGenerator = new FlowInstanceEventGenerator(daoFactory);
	}
	
	@Override
	protected void moduleConfigured() throws Exception {

		super.moduleConfigured();
		
		globalAccess = new SimpleAccessInterface(globalAccessGroups, null);
		
		XSLVariableReader variableReader = ModuleUtils.getXSLVariableReader(moduleDescriptor, sectionInterface.getSystemInterface());

		if (variableReader != null) {

			Map<String, String> map = new HashMap<String, String>();
			map.put("scripts", "scripts-buttonextension");
			
			XSLVariableReaderRenamer variableReaderRenamed = new XSLVariableReaderRenamer(variableReader, map);
			
			buttonExtensionScripts = ModuleUtils.getScripts(variableReaderRenamed, sectionInterface, "f", moduleDescriptor);
		}
		
		listOverviewButtonDataAttributes = new HashMap<String, String>(2);
		listOverviewButtonDataAttributes.put("url", systemInterface.getContextPath() + getFullAlias() + "/sendmessages");
		listOverviewButtonDataAttributes.put("baseurl", systemInterface.getContextPath() + getFullAlias());
	}
	
	@InstanceManagerDependency(required = true)
	public void setFlowInstanceAdmin2Module(FlowInstanceAdmin2Module flowInstanceAdmin2Module) {
		
		if (flowInstanceAdmin2Module != null) {
			
			flowInstanceAdmin2Module.addListOverviewButtonExtensionProvider(this);
			
		} else if (this.flowInstanceAdmin2Module != null){
			
			this.flowInstanceAdmin2Module.removeListOverviewButtonExtensionProvider(this);
		}
		
		this.flowInstanceAdmin2Module = flowInstanceAdmin2Module;
	}
	
	@Override
	public void unload() throws Exception {
		
		if (flowInstanceAdmin2Module != null) {
			
			flowInstanceAdmin2Module.removeListOverviewButtonExtensionProvider(this);
			
			flowInstanceAdmin2Module = null;
		}
		
		systemInterface.getInstanceHandler().removeInstance(FlowInstanceAdminSendMessagesModule.class, this);

		super.unload();
	}
	
	@Override
	public ForegroundModuleResponse defaultMethod(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		return listFlowFamilies(req, res, user, uriParser, null);
	}

	private ForegroundModuleResponse listFlowFamilies(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser, List<ValidationError> validationErrors) throws ModuleConfigurationException, SQLException {

		log.info("User " + user + " listing families");

		Document doc = this.createDocument(req, uriParser, user);

		Element listFamiliesElement = doc.createElement("ListFamilies");
		doc.getDocumentElement().appendChild(listFamiliesElement);

		XMLGeneratorDocument generatorDocument = new XMLGeneratorDocument(doc);
		generatorDocument.setIgnoredFields(LIST_FLOW_FAMILIES_IGNORED_FIELDS);

		Collection<Flow> flows = flowAdminModule.getCachedFlows();

		if (AccessUtils.checkAccess(user, globalAccess)) {

			for (Flow flow : flows) {
				
				if (flow.isLatestVersion() && flow.isInternal()) {
					
					Element flowElement = flow.toXML(generatorDocument);
					
					flowAdminModule.appendFamilyInformation(doc, flowElement, flow, flows);
					
					listFamiliesElement.appendChild(flowElement);
				}
			}

		} else {

			for (Flow flow : flows) {
				
				if (flow.isLatestVersion() && flow.isInternal() && flow.getFlowFamily().getManagerAccess(user) != null) {
					
					Element flowElement = flow.toXML(generatorDocument);
					
					flowAdminModule.appendFamilyInformation(doc, flowElement, flow, flows);
					
					listFamiliesElement.appendChild(flowElement);
				}
			}
		}
		
		XMLUtils.appendNewElement(doc, listFamiliesElement, "FlowInstanceAdmin2ModuleFullAlias", flowInstanceAdmin2Module.getFullAlias());

		if (validationErrors != null) {

			XMLUtils.append(doc, listFamiliesElement, validationErrors);
		}

		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}

	@WebPublic(alias = "family")
	public ForegroundModuleResponse listFlowVersions(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		return listFlowVersions(req, res, user, uriParser, null);
	}

	private ForegroundModuleResponse listFlowVersions(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser, List<ValidationError> validationErrors) throws Throwable {

		Integer flowFamilyID = uriParser.getInt(2);

		FlowFamily flowFamily;

		if (flowFamilyID == null || (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) == null) {

			return listFlowFamilies(req, res, user, uriParser, Collections.singletonList(FLOW_FAMILY_NOT_FOUND_VALIDATION_ERROR));

		} else if (!hasFlowFamilyAccess(user, flowFamily)) {

			return listFlowFamilies(req, res, user, uriParser, Collections.singletonList(FLOW_FAMILY_ACCESS_DENIED_VALIDATION_ERROR));
		}

		log.info("User " + user + " listing flow versions in flow family " + flowFamily);

		XMLGeneratorDocument doc = new XMLGeneratorDocument(createDocument(req, uriParser, user));
		doc.setIgnoredFields(LIST_FLOW_VERSIONS_IGNORED_FIELDS);

		Element listVersionsElement = doc.createElement("ListFlowVersions");

		doc.getDocumentElement().appendChild(listVersionsElement);

		listVersionsElement.appendChild(flowFamily.toXML(doc));

		List<Flow> flowVersions = flowAdminModule.getFlowVersions(flowFamily);

		XMLUtils.append(doc, listVersionsElement, flowVersions);
		
		if (validationErrors != null) {

			XMLUtils.append(doc, listVersionsElement, validationErrors);
			listVersionsElement.appendChild(RequestUtils.getRequestParameters(req, doc, "flowID"));
		}

		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}
	
	private boolean hasFlowFamilyAccess(User user, FlowFamily flowFamily) {

		return AccessUtils.checkAccess(user, globalAccess) || flowFamily.getManagerAccess(user) != null;
	}
	
	@WebPublic(toLowerCase = true)
	public ForegroundModuleResponse sendMessages(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		List<ValidationError> validationErrors = new ArrayList<ValidationError>();
		
		try {
			if (MultipartRequest.isMultipartRequest(req)) {
				req = MultipartRequest.getMultipartRequest(this.ramThreshold * BinarySizes.KiloByte, this.maxRequestSize * BinarySizes.MegaByte, tempDir, req);
			}

		} catch (SizeLimitExceededException e) {

			validationErrors.add(new RequestSizeLimitExceededValidationError(e.getActualSize(), e.getPermittedSize()));

		} catch (FileUploadException e) {

			validationErrors.add(new ValidationError("UnableToParseRequest"));
		}
		
		try {
			FlowSelection flowSelection = null;
			Integer flowFamilyID = uriParser.getInt(2);
			
			if (flowFamilyID != null) {
				
				try {
					flowSelection = getFlowSelection(req, res, user, uriParser);
					
				} catch (ValidationException e) {
					
					List<ValidationError> errors = e.getErrors();
					
					if (errors.size() == 1 && errors.get(0) == FLOW_FAMILY_NOT_FOUND_VALIDATION_ERROR || errors.get(0) == FLOW_FAMILY_ACCESS_DENIED_VALIDATION_ERROR) {
						return listFlowFamilies(req, res, user, uriParser, errors);
					}
					
					return listFlowVersions(req, res, user, uriParser, errors);
				}
				
			} else {
			
				List<FlowInstance> flowInstances = flowInstanceAdmin2Module.getFlowInstanceSelection(true, false, req, res, user, uriParser, validationErrors, FlowInstance.FLOW_RELATION, Flow.FLOW_FAMILY_RELATION, FlowFamily.MESSAGE_TEMPLATES_RELATION, FlowInstance.ATTRIBUTES_RELATION, FlowInstance.OWNERS_RELATION, Flow.STATUSES_RELATION);
		
				if (!validationErrors.isEmpty()) {
		
					return listFlowFamilies(req, res, user, uriParser, validationErrors);
		
				} else if (flowInstances == null) {
		
					flowInstanceAdmin2Module.redirectToDefaultMethod(req, res);
					return null;
				}
		
				flowSelection = new FlowSelection(flowInstances.get(0).getFlow(), flowInstances);
			}
	
			List<Status> statuses = null;
			Set<Integer> statusIDs = new HashSet<>();
			
			Document doc = createDocument(req, uriParser, user);
			Element sendMessageElement = XMLUtils.appendNewElement(doc, doc.getDocumentElement(), "SendMessageForm");
	
			if (req.getMethod().equals("POST") && req.getParameter("fromform") != null) {
				
				Set<String> toMultiSignOwnerSet = new HashSet<>();
				Set<String> toMultiSignSignedSet = new HashSet<>();
				Set<String> toMultiSignNotSignedSet = new HashSet<>();
				
				if (flowSelection.getFlowInstances() == null) {
					
					String[] statusNameParams = req.getParameterValues("status");
			
					if (ArrayUtils.isEmpty(statusNameParams)) {
			
						validationErrors.add(NO_STATUSES_VALIDATION_ERROR);
						
					} else {
						
						statuses = new ArrayList<Status>(statusNameParams.length * flowSelection.getFlows().size());
						boolean usesMultiSignStatus = false;
						
						for (String statusName : statusNameParams) {
							boolean statusFound = false;
							
							for (Flow flow : flowSelection.getFlows()) {
								for (Status status : flow.getStatuses()) {
									
									if (status.getName().equalsIgnoreCase(statusName)) {
										
										if (status.getContentType() == ContentType.WAITING_FOR_MULTISIGN) {
											usesMultiSignStatus = true;
										}
										
										statuses.add(status);
										statusIDs.add(status.getStatusID());
										
										statusFound = true;
										break;
									}
								}
							}
							
							if (!statusFound) {
								validationErrors.add(new ValidationError("status", statusName, ValidationErrorType.InvalidFormat));
							}
						}
						
						if (usesMultiSignStatus && multiSigningHandler != null) {
							
							String[] ownerParams = req.getParameterValues("status-multisign-owner");
							String[] signedParams = req.getParameterValues("status-multisign-signed");
							String[] notSignedParams = req.getParameterValues("status-multisign-notsigned");
							
							if (ownerParams != null) {
								for (String statusName : ownerParams) {
									toMultiSignOwnerSet.add(statusName.toLowerCase());
								}
							}
							
							if (signedParams != null) {
								for (String statusName : signedParams) {
									toMultiSignSignedSet.add(statusName.toLowerCase());
								}
							}
							
							if (notSignedParams != null) {
								for (String statusName : notSignedParams) {
									toMultiSignNotSignedSet.add(statusName.toLowerCase());
								}
							}
							
							if (toMultiSignOwnerSet.isEmpty() && toMultiSignSignedSet.isEmpty() && toMultiSignNotSignedSet.isEmpty()) {
								
								validationErrors.add(NO_MULTISIGN_TYPES_VALIDATION_ERROR);
							}
						}
					}
				}
				
				boolean sendEmail = !StringUtils.isEmpty(req.getParameter("send-email"));
				boolean sendSMS = !StringUtils.isEmpty(req.getParameter("send-sms"));
				boolean sendExternalMessage = !StringUtils.isEmpty(req.getParameter("send-external-message"));
	
				if (!sendEmail && !sendSMS && !sendExternalMessage) {
					validationErrors.add(NO_MESSAGE_PATH_VALIDATION_ERROR);
				}
	
				String emailSenderName = ValidationUtils.validateParameter("emailSenderName", req, sendEmail, 1, 255, validationErrors);
	
				String emailSenderAddress = null;
	
				if (!forceAutomaticEmailSenderAddress) {
					emailSenderAddress = ValidationUtils.validateParameter("emailSenderAddress", req, false, EMAIL_POPULATOR, validationErrors);
				}
	
				String emailSubject = ValidationUtils.validateParameter("emailSubject", req, sendEmail, 1, 255, validationErrors);
				String emailMessage = ValidationUtils.validateParameter("emailMessage", req, sendEmail, 1, 65535, validationErrors);
	
				String smsMessage = ValidationUtils.validateParameter("smsMessage", req, sendSMS, 1, null, validationErrors);
	
				String externalMessage = ValidationUtils.validateParameter("externalMessage", req, sendExternalMessage, 1, null, validationErrors);
				
				Collection<FileItem> attachedFileItemsEmail = null;
				Collection<FileItem> attachedFileItemsExternalMessage = null;
	
				attachedFileItemsEmail = ((MultipartRequest) req).getFiles("email-attachments");
				attachedFileItemsExternalMessage = ((MultipartRequest) req).getFiles("external-message-attachments");

				Iterator<FileItem> fileIteratorEmail = attachedFileItemsEmail.iterator();

				while (fileIteratorEmail.hasNext()) {

					FileItem fileItem = fileIteratorEmail.next();

					if (StringUtils.isEmpty(fileItem.getName()) || fileItem.getSize() == 0) {

						fileIteratorEmail.remove();
						continue;
					}

					if (fileItem.getSize() > (this.maxEmailFileSize * BinarySizes.MegaByte)) {

						validationErrors.add(new FileSizeLimitExceededValidationError(FilenameUtils.getName(fileItem.getName()), fileItem.getSize(), this.maxEmailFileSize * BinarySizes.MegaByte));

						continue;
					}
				}

				Iterator<FileItem> fileIteratorExternalMessage = attachedFileItemsExternalMessage.iterator();

				while (fileIteratorExternalMessage.hasNext()) {

					FileItem fileItem = fileIteratorExternalMessage.next();

					if (StringUtils.isEmpty(fileItem.getName()) || fileItem.getSize() == 0) {

						fileIteratorExternalMessage.remove();
						continue;
					}

					if (fileItem.getSize() > (this.maxExternalMessageFileSize * BinarySizes.MegaByte)) {

						validationErrors.add(new FileSizeLimitExceededValidationError(FilenameUtils.getName(fileItem.getName()), fileItem.getSize(), this.maxExternalMessageFileSize * BinarySizes.MegaByte));

						continue;
					}
				}

				if (validationErrors.isEmpty()) {

					List<Attachment> attachmentsEmail = new ArrayList<Attachment>(CollectionUtils.getSize(attachedFileItemsEmail));
					List<ExternalMessageAttachment> attachmentsExternalMessage = new ArrayList<ExternalMessageAttachment>(CollectionUtils.getSize(attachedFileItemsExternalMessage));

					if (sendEmail && attachedFileItemsEmail != null) {

						for (FileItem file : attachedFileItemsEmail) {

							FileItemAttachment attachment = new FileItemAttachment(file);

							attachmentsEmail.add(attachment);
						}
					}

					if (sendExternalMessage && attachedFileItemsExternalMessage != null) {

						for (FileItem file : attachedFileItemsExternalMessage) {

							ExternalMessageAttachment attachmentExternalMessage = new ExternalMessageAttachment();

							String fileName = FilenameUtils.getName(file.getName());

							attachmentExternalMessage.setFilename(fileName);
							attachmentExternalMessage.setSize(file.getSize());
							attachmentExternalMessage.setData(new SerialBlob(file.get()));

							attachmentsExternalMessage.add(attachmentExternalMessage);
						}
					}

					int sentEmails = 0;
					int sentSMSs = 0;
					int sentExternalMessages = 0;
					int flowInstanceCount = 0;
					
					for (Flow flow : flowSelection.getFlows()) {
						
						List<FlowInstance> flowInstances = flowSelection.getFlowInstances();
						
						if (flowInstances == null) {
							
							List<Status> flowStatuses = new ArrayList<>();
		
							for (Status flowStatus : flow.getStatuses()) {
								if (statusIDs.contains(flowStatus.getStatusID())) {
									
									flowStatuses.add(flowStatus);
								}
							}
							
							if (flowStatuses.size() > 0) {
								
								ManagerAccess managerAccess = flowSelection.getFlowFamily().getManagerAccess(user);
								boolean hasGlobalAccess = AccessUtils.checkAccess(user, globalAccess);
								boolean restricted = !hasGlobalAccess && managerAccess == ManagerAccess.RESTRICTED;
								
								StringBuilder sql = new StringBuilder();
								sql.append("SELECT flowInstance.*");
		
								getFlowInstancesSQL(sql, flowSelection.getFlowFamily(), flow, flowSelection.getFromDate(), flowSelection.getToDate(), flowStatuses, user, restricted, true);
					
								LowLevelQuery<FlowInstance> getQuery = new LowLevelQuery<FlowInstance>(sql.toString());
								getQuery.addRelations(FlowInstance.ATTRIBUTES_RELATION, FlowInstance.STATUS_RELATION, FlowInstance.OWNERS_RELATION);
								getQuery.addCachedRelations(FlowInstance.STATUS_RELATION, FlowInstance.OWNERS_RELATION);
					
								if (flowSelection.getFromDate() != null) {
									getQuery.addParameter(flowSelection.getFromDate());
									getQuery.addParameter(flowSelection.getFromDate());
								}
					
								if (flowSelection.getToDate() != null) {
									getQuery.addParameter(flowSelection.getToDate());
									getQuery.addParameter(flowSelection.getToDate());
								}
								
								flowInstances = flowInstanceDAO.getAll(getQuery);
								
								if (flowInstances != null) {
									for (FlowInstance flowInstance : flowInstances) {
										flowInstance.setFlow(flow);
									}
								}
							}
						}
						
						if (!CollectionUtils.isEmpty(flowInstances)) {

							int failedToSendExternalMessagesDisabled = 0;
							
							for (FlowInstance flowInstance : flowInstances) {

								flowInstanceCount++;

								List<Contact> contacts = flowNotificationHandler.getContacts(flowInstance);
								
								SigningSession signingSession = null;
								
								if (flowInstance.getStatus().getContentType() == ContentType.WAITING_FOR_MULTISIGN && multiSigningHandler != null) {

									signingSession = multiSigningHandler.getSigningSession(flowInstance.getFlowInstanceID());
									
									if (signingSession != null) {
										
										if (contacts == null) {
											contacts = new ArrayList<>();
										}
										
										for (SigningSessionParty signingParty : signingSession.getSigningSessionParties()) {
											
											ContactWithSigningParty contact = new ContactWithSigningParty();
	
											contact.setSigningParty(signingParty);
											contact.setFirstname(signingParty.getFirstname());
											contact.setLastname(signingParty.getLastname());
											contact.setEmail(signingParty.getEmail());
											contact.setMobilePhone(signingParty.getMobilePhone());
											contact.setCitizenIdentifier(signingParty.getIdentifier());
	
											contact.setContactBySMS(true);
											contact.setContactByEmail(true);
	
											Contact uniqueContact = FlowInstanceUtils.addUniqueContact(contacts, contact);
											
											// Replace existing contact with ContactWithSigningParty
											if (contact != uniqueContact && !(uniqueContact instanceof ContactWithSigningParty)) {
												
												contact = new ContactWithSigningParty(uniqueContact);
												contact.setSigningParty(signingParty);
												
												int index = contacts.indexOf(uniqueContact);
												contacts.set(index, contact);
											}
										}
									}
								}

								SingleTagSource urlTag;

								if (userFlowInstanceModule != null) {

									urlTag = new SingleTagSource("$flowInstance.url", RequestUtils.getFullContextPathURL(req) + userFlowInstanceModule.getFullAlias() + "/overview/" + flow.getFlowID() + "/" + flowInstance.getFlowInstanceID());

								} else {

									urlTag = null;
								}

								if (contacts != null) {
									
									String statusLowName = flowInstance.getStatus().getName().toLowerCase();
									boolean toMultiSignOwner = toMultiSignOwnerSet.contains(statusLowName);
									boolean toMultiSignSigned = toMultiSignSignedSet.contains(statusLowName);
									boolean toMultiSignNotSigned = toMultiSignNotSignedSet.contains(statusLowName);
									
									boolean smsSent = false;
									boolean emailSent = false;

									for (Contact contact : contacts) {

										if (flowInstance.getStatus().getContentType() == ContentType.WAITING_FOR_MULTISIGN && signingSession != null) {

											if (contact instanceof ContactWithSigningParty) {
												
												SigningSessionParty signingParty = ((ContactWithSigningParty) contact).getSigningParty();
											
												if (signingParty.getSignedDate() != null) {
	
													if (!toMultiSignSigned) {
														continue;
													}
	
												} else if (!toMultiSignNotSigned) {
													continue;
												}
												
											} else { // Contact is owner or at least contact person for not logged in submitter

												if (!toMultiSignOwner) {
													continue;
												}
											}
										}
										
										if (sendEmail && !StringUtils.isEmpty(contact.getEmail()) && EmailUtils.isValidEmailAddress(contact.getEmail())) {

											TagReplacer tagReplacer = new TagReplacer(FLOWINSTANCE_TAG_SOURCE_FACTORY.getTagSource(flowInstance), FLOW_TAG_SOURCE_FACTORY.getTagSource(flow), CONTACT_TAG_SOURCE_FACTORY.getTagSource(contact));

											if (urlTag != null) {
												tagReplacer.addTagSource(urlTag);
											}

											String message = tagReplacer.replace(emailMessage);
											String subject = tagReplacer.replace(emailSubject);

											try {
												SimpleEmail email = new SimpleEmail(systemInterface.getEncoding());
												
												String emailSenderAddress2 = emailSenderAddress;
												
												if (emailSenderAddress2 == null || forceAutomaticEmailSenderAddress) {
													emailSenderAddress2 = flowNotificationHandler.getEmailSenderAddress(flowInstance);
												}

												email.setMessageContentType(SimpleEmail.HTML);
												email.setSenderAddress(emailSenderAddress2);
												email.setSenderName(emailSenderName);
												email.setSubject(subject);
												email.setMessage(message);
												email.addRecipient(contact.getEmail());

												if (!CollectionUtils.isEmpty(attachmentsEmail)) {

													for (Attachment attachment : attachmentsEmail) {

														email.add(attachment);
													}
												}

												log.info("User " + user + " sending email " + email + " regarding flow instance " + flowInstance);

												systemInterface.getEmailHandler().send(email);
												sentEmails++;
												emailSent = true;

											} catch (Exception e) {

												log.error("Error sending email regarding flow instance " + flowInstance, e);
											}
										}

										if (sendSMS && smsSender != null && !StringUtils.isEmpty(contact.getMobilePhone()) && SwedishPhoneNumberValidator.getValidator().validateFormat(contact.getMobilePhone())) {

											TagReplacer tagReplacer = new TagReplacer(FLOWINSTANCE_TAG_SOURCE_FACTORY.getTagSource(flowInstance), FLOW_TAG_SOURCE_FACTORY.getTagSource(flow), CONTACT_TAG_SOURCE_FACTORY.getTagSource(contact));

											if (urlTag != null) {
												tagReplacer.addTagSource(urlTag);
											}

											String message = tagReplacer.replace(smsMessage);

											SimpleSMS sms = new SimpleSMS();

											sms.setSenderName(flowNotificationHandler.getSMSSenderName(flowInstance));
											sms.setMessage(message);
											sms.setRecipients(Collections.singletonList(contact.getMobilePhone()));

											log.info("User " + user + " sending sms " + sms + " regarding flow instance " + flowInstance);

											if (smsSender.send(sms)) {

												sentSMSs++;
												smsSent = true;

											} else {

												log.warn("Error sending sms message to " + contact.getMobilePhone());
											}
										}
									}
									
									ExternalMessage message = null;
									
									if (sendExternalMessage && flowInstance.getOwners() != null && flowInstance.getFirstSubmitted() != null) {

										if (!flow.isHideExternalMessages()) {

											TagReplacer tagReplacer = new TagReplacer(FLOWINSTANCE_TAG_SOURCE_FACTORY.getTagSource(flowInstance), FLOW_TAG_SOURCE_FACTORY.getTagSource(flow));

											if (urlTag != null) {
												tagReplacer.addTagSource(urlTag);
											}

											message = new ExternalMessage();
											message.setAdded(TimeUtils.getCurrentTimestamp());
											message.setFlowInstance(flowInstance);
											message.setMessage(tagReplacer.replace(externalMessage));
											message.setPostedByManager(true);
											message.setPoster(user);

											if (!CollectionUtils.isEmpty(attachmentsExternalMessage)) {

												List<ExternalMessageAttachment> attachementCopy = new ArrayList<ExternalMessageAttachment>(attachmentsExternalMessage.size());

												for (ExternalMessageAttachment attachement : attachmentsExternalMessage) {

													attachementCopy.add(new ExternalMessageAttachment(attachement));
												}

												message.setAttachments(attachementCopy);
											}

											externalMessageDAO.add(message);

											sentExternalMessages += flowInstance.getOwners().size();
											
										} else {
											
											failedToSendExternalMessagesDisabled++;
										}
									}
									
									if (smsSent || emailSent || message != null) {
										
										StringBuilder eventDescription = new StringBuilder(eventSent);
										
										if (emailSent) {
											eventDescription.append(" " + eventEmailSent);
										}
										
										if (smsSent) {
											if (emailSent) {
												eventDescription.append(", ");
											}

											eventDescription.append(" " + eventSMSSent);
										}
										
										if (message != null) {
											if (emailSent || smsSent) {
												eventDescription.append(", ");
											}

											eventDescription.append(" " + eventMessageSent);
										}
										
										FlowInstanceEvent flowInstanceEvent = flowInstanceEventGenerator.addFlowInstanceEvent(flowInstance, EventType.OTHER_EVENT, eventDescription.toString(), user, null, null);

										if (message != null) {
											systemInterface.getEventHandler().sendEvent(FlowInstance.class, new ExternalMessageAddedEvent(flowInstance, flowInstanceEvent, flowAdminModule.getSiteProfile(flowInstance), message, SenderType.MANAGER), EventTarget.ALL);
											systemInterface.getEventHandler().sendEvent(ExternalMessage.class, new CRUDEvent<ExternalMessage>(CRUDAction.ADD, message), EventTarget.ALL);
										}
									}
								}
							}
							
							if (failedToSendExternalMessagesDisabled > 0) {
								
								validationErrors.add(new ExternalMessagesDisabledValidationError(flow, failedToSendExternalMessagesDisabled));
							}
						}
					}
					
					if (sendEmail) {
						XMLUtils.appendNewElement(doc, sendMessageElement, "SentEmails", sentEmails);
					}

					if (sendSMS) {
						XMLUtils.appendNewElement(doc, sendMessageElement, "SentSMSs", sentSMSs);
					}

					if (sendExternalMessage) {
						XMLUtils.appendNewElement(doc, sendMessageElement, "SentExternalMessages", sentExternalMessages);
					}

					XMLUtils.appendNewElement(doc, sendMessageElement, "FlowInstanceCount", flowInstanceCount);
				}
			}
			
			log.info("User " + user + " viewing send messages form for " + flowSelection);
	
			XMLUtils.appendNewElement(doc, sendMessageElement, "FormatedMaxEmailFileSize", BinarySizeFormater.getFormatedSize(maxEmailFileSize * BinarySizes.MegaByte));
			XMLUtils.appendNewElement(doc, sendMessageElement, "FormatedMaxExternalMessageFileSize", BinarySizeFormater.getFormatedSize(maxExternalMessageFileSize * BinarySizes.MegaByte));
	
			sendMessageElement.appendChild(flowSelection.toXML(doc));
	
			XMLUtils.appendNewElement(doc, sendMessageElement, "FlowFamilyName", flowSelection.getFlows().get(flowSelection.getFlows().size() - 1).getName());
	
			if (forceAutomaticEmailSenderAddress) {
				XMLUtils.appendNewElement(doc, sendMessageElement, "ForceAutomaticEmailSenderAddress", "true");
			}
			
			XMLUtils.appendNewElement(doc, sendMessageElement, "DefaultEmailSenderAddress", flowNotificationHandler.getEmailSenderAddress());
			
			XMLUtils.appendNewElement(doc, sendMessageElement, "FlowInstanceAdmin2ModuleFullAlias", flowInstanceAdmin2Module.getFullAlias());
	
			Element statusesElement = XMLUtils.appendNewElement(doc, sendMessageElement, "Statuses");
	
			List<StatusCounts> flowInstanceCounts = new ArrayList<>();
			Map<String, StatusCounts> flowInstanceCountsByStatus = new HashMap<>();
			List<Flow> flowsWithDisabledExternalMessages = new ArrayList<>();
	
			for (int i = flowSelection.getFlows().size() - 1; i >= 0; i--) {
				Flow flow = flowSelection.getFlows().get(i);
				
				if (flow.isHideExternalMessages()) {
					flowsWithDisabledExternalMessages.add(flow);
				}
				
				for (Status status : flow.getStatuses()) {
					
					String lowName = status.getName().toLowerCase();
					StatusCounts counts = flowInstanceCountsByStatus.get(lowName);
					
					if (counts == null) {
						
						counts = new StatusCounts();
						counts.name = status.getName();
						counts.sortIndex = status.getSortIndex();
						
						flowInstanceCounts.add(counts);
						flowInstanceCountsByStatus.put(lowName, counts);
					}
					
					counts.flowInstanceCount += getFlowInstanceCount(flow, flowSelection.getFromDate(), flowSelection.getToDate(), status, user);
					
					if (multiSigningHandler != null && status.getContentType() == ContentType.WAITING_FOR_MULTISIGN) {
						
						List<Integer> flowInstanceIDs = getFlowInstanceIDs(flow, flowSelection.getFromDate(), flowSelection.getToDate(), status, user);
						
						List<SigningSession> signingSessions = multiSigningHandler.getSigningSessions(flowInstanceIDs);
						
						if (signingSessions != null) {
							
							Integer notSignedCount = counts.flowInstanceCountMultiSignNotSigned;
							Integer signedCount = counts.flowInstanceCountMultiSignSigned;
						
							if (notSignedCount == null) {
								notSignedCount = 0;
							}
							
							if (signedCount == null) {
								signedCount = 0;
							}
							
							for (SigningSession signingSession : signingSessions) {
								for (SigningSessionParty signingParty : signingSession.getSigningSessionParties()) {
									
									if (signingParty.getSignedDate() != null) {
										signedCount++;
										
									} else {
										notSignedCount++;
									}
								}
							}
							
							counts.flowInstanceCountMultiSignNotSigned = notSignedCount;
							counts.flowInstanceCountMultiSignSigned = signedCount;
						}
					}
				}
			}
	
			Collections.sort(flowInstanceCounts);
			int totalFlowInstanceCount = 0;
			
			for (StatusCounts counts : flowInstanceCounts) {
				statusesElement.appendChild(counts.toXML(doc));
				totalFlowInstanceCount += counts.flowInstanceCount;
			}
			
			XMLUtils.append(doc, sendMessageElement, "FlowsWithDisabledExternalMessages", flowsWithDisabledExternalMessages);
			
			if (totalFlowInstanceCount == 0) {
				validationErrors.add(NO_RECIPIENTS_VALIDATION_ERROR);
			}
			
			if (multiSigningHandler != null) {
				XMLUtils.appendNewElement(doc, sendMessageElement, "MultiSigningHandler");
			}
			
			if (!validationErrors.isEmpty()) {
				XMLUtils.append(doc, sendMessageElement, "ValidationErrors", validationErrors);
			}
	
			sendMessageElement.appendChild(RequestUtils.getRequestParameters(req, doc));
			return new SimpleForegroundModuleResponse(doc, moduleDescriptor.getName(), getDefaultBreadcrumb());
			
		} finally {
			
			if (req instanceof MultipartRequest) {
				((MultipartRequest) req).deleteFiles();
			}
		}
	}
	
	private FlowSelection getFlowSelection(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		Integer flowFamilyID = uriParser.getInt(2);
		FlowFamily flowFamily = null;

		if (flowFamilyID == null || (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) == null) {
			throw new ValidationException(FLOW_FAMILY_NOT_FOUND_VALIDATION_ERROR);
		}
		
		ManagerAccess managerAccess = flowFamily.getManagerAccess(user);
		boolean hasGlobalAccess = AccessUtils.checkAccess(user, globalAccess);
		
		if (!hasGlobalAccess && managerAccess == null) {
			throw new ValidationException(FLOW_FAMILY_ACCESS_DENIED_VALIDATION_ERROR);
		}

		List<ValidationError> validationErrors = new ArrayList<ValidationError>(4);
		
		List<Integer> flowIDs = NumberUtils.toInt(req.getParameterValues("flowID"));

		List<Flow> flows = null;
		Timestamp fromDate = null;
		Timestamp toDate = null;

		if (flowIDs == null) {

				validationErrors.add(NO_FLOW_VERSIONS_SELECTED_VALIDATION_ERROR);
				
		} else {

			flows = getFlowVersions(flowFamily, flowIDs);

			if (CollectionUtils.isEmpty(flows)) {

				validationErrors.add(NO_FLOW_VERSIONS_SELECTED_VALIDATION_ERROR);
			}
		}
		
		if (!StringUtils.isEmpty(req.getParameter("fromDate"))) {

			Date fromDate2 = DateUtils.getDate(DateUtils.DATE_FORMATTER, req.getParameter("fromDate"));

			if (fromDate2 == null) {

				validationErrors.add(new ValidationError("fromDate", ValidationErrorType.InvalidFormat));

			} else {

				fromDate = new Timestamp(DateUtils.setTimeToMidnight(fromDate2).getTime());
			}
		}

		if (!StringUtils.isEmpty(req.getParameter("toDate"))) {

			Date toDate2 = DateUtils.getDate(DateUtils.DATE_FORMATTER, req.getParameter("toDate"));

			if (toDate2 == null) {

				validationErrors.add(new ValidationError("toDate", ValidationErrorType.InvalidFormat));

			} else {

				toDate = new Timestamp(DateUtils.setTimeToMaximum(toDate2).getTime());
			}
		}
		
		if (!validationErrors.isEmpty()) {
			throw new ValidationException(validationErrors);
		}
		
		return new FlowSelection(flowFamily, flows, fromDate, toDate, null);
	}
	
	private List<Integer> getFlowInstanceIDs(Flow flow, Timestamp fromDate, Timestamp toDate, Status status, User user) throws SQLException {

		ManagerAccess managerAccess = flow.getFlowFamily().getManagerAccess(user);
		boolean hasGlobalAccess = AccessUtils.checkAccess(user, globalAccess);
		boolean restricted = !hasGlobalAccess && managerAccess == ManagerAccess.RESTRICTED;
		
		StringBuilder sql = new StringBuilder();
		sql.append("SELECT DISTINCT flowInstance.flowInstanceID");

		getFlowInstancesSQL(sql, flow.getFlowFamily(), flow, fromDate, toDate, Collections.singletonList(status), user, restricted, false);
		
		ArrayListQuery<Integer> query = new ArrayListQuery<Integer>(dataSource, sql.toString(), IntegerPopulator.getPopulator());

		int paramIndex = 1;

		if (fromDate != null) {
			query.setTimestamp(paramIndex++, fromDate);
			query.setTimestamp(paramIndex++, fromDate);
		}

		if (toDate != null) {
			query.setTimestamp(paramIndex++, toDate);
			query.setTimestamp(paramIndex++, toDate);
		}

		return query.executeQuery();
	}
	
	private int getFlowInstanceCount(Flow flow, Timestamp fromDate, Timestamp toDate, Status status, User user) throws SQLException {

		ManagerAccess managerAccess = flow.getFlowFamily().getManagerAccess(user);
		boolean hasGlobalAccess = AccessUtils.checkAccess(user, globalAccess);
		boolean restricted = !hasGlobalAccess && managerAccess == ManagerAccess.RESTRICTED;
		
		StringBuilder sql = new StringBuilder();
		sql.append("SELECT COUNT(DISTINCT flowInstance.flowInstanceID)");

		getFlowInstancesSQL(sql, flow.getFlowFamily(), flow, fromDate, toDate, Collections.singletonList(status), user, restricted, false);

		ObjectQuery<Integer> countQuery = new ObjectQuery<Integer>(dataSource, sql.toString(), IntegerPopulator.getPopulator());

		int paramIndex = 1;

		if (fromDate != null) {
			countQuery.setTimestamp(paramIndex++, fromDate);
			countQuery.setTimestamp(paramIndex++, fromDate);
		}

		if (toDate != null) {
			countQuery.setTimestamp(paramIndex++, toDate);
			countQuery.setTimestamp(paramIndex++, toDate);
		}

		return countQuery.executeQuery();
	}
	
	private void getFlowInstancesSQL(StringBuilder sql, FlowFamily flowFamily, Flow flow, Date fromDate, Date toDate, List<Status> statuses, User user, boolean userHasRestrictedAccess, boolean groupBy) {
			
			sql.append(" FROM flowengine_flow_instances flowInstance");
			sql.append(" INNER JOIN flowengine_flows flow ON flow.flowID = flowInstance.flowID");
			sql.append(" INNER JOIN flowengine_flow_statuses flowStatus ON flowStatus.statusID = flowInstance.statusID");

			if (userHasRestrictedAccess) {
				sql.append(" LEFT JOIN flowengine_flow_instance_managers flowInstanceManager ON flowInstance.flowInstanceID = flowInstanceManager.flowInstanceID");
				sql.append(" LEFT JOIN flowengine_flow_instance_manager_groups flowInstanceManagerGroups ON flowInstance.flowInstanceID = flowInstanceManagerGroups.flowInstanceID");
			}

			sql.append(" WHERE flow.flowFamilyID = " + flowFamily.getFlowFamilyID() + " AND flow.flowID = " + flow.getFlowID());
			
			if (statuses != null) {
				
				sql.append(" AND flowStatus.statusID IN (");
				
				for (Iterator<Status> it =  statuses.iterator(); it.hasNext();) {
					Status status = it.next();
					sql.append(status.getStatusID());
					
					if (it.hasNext()) {
						sql.append(",");
					}
				}
				
				sql.append(")");
			}

			if (fromDate != null) {
				sql.append(" AND (flowInstance.firstSubmitted >= ? OR (flowInstance.firstSubmitted IS NULL AND flowInstance.added >= ?))");
			}

			if (toDate != null) {
				sql.append(" AND (flowInstance.firstSubmitted <= ? OR (flowInstance.firstSubmitted IS NULL AND flowInstance.added >= ?))");
			}
			
			if (userHasRestrictedAccess) {
				
				sql.append(" AND (");

				sql.append("flowInstanceManager.userID = ");
				sql.append(user.getUserID());

				if (user.getGroups() != null) {
					
					sql.append(" OR ");

					sql.append("flowInstanceManagerGroups.groupID IN (");
					flowInstanceAdmin2Module.appendGroupIDs(sql, (List<Group>) user.getGroups());
					sql.append(")");
				}

				sql.append(")");
				
				if (groupBy) {
					
					sql.append(" GROUP BY flowInstance.flowInstanceID ASC");
				}
			}

			sql.append(" ORDER BY flowInstance.flowInstanceID ASC");
	}
	
	private List<Flow> getFlowVersions(FlowFamily flowFamily, List<Integer> flowIDs) {

		List<Flow> flows = flowAdminModule.getFlowVersions(flowFamily);

		Iterator<Flow> iterator = flows.iterator();

		while (iterator.hasNext()) {

			Flow flow = iterator.next();

			if (!flow.isEnabled() || !flowIDs.contains(flow.getFlowID())) {

				iterator.remove();
			}
		}

		return flows;
	}
	
	private Document createDocument(HttpServletRequest req, URIParser uriParser, User user) {

		Document doc = XMLUtils.createDomDocument();
		Element documentElement = doc.createElement("Document");
		documentElement.appendChild(RequestUtils.getRequestInfoAsXML(doc, req, uriParser));
		documentElement.appendChild(this.moduleDescriptor.toXML(doc));

		XMLUtils.appendNewElement(doc, documentElement, "fullAlias", getFullAlias());

		doc.appendChild(documentElement);
		return doc;
	}
	
	@WebPublic(alias = "icon")
	public ForegroundModuleResponse getFlowIcon(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws URINotFoundException, AccessDeniedException, ModuleConfigurationException, SQLException, IOException {
		
		return flowAdminModule.getFlowIcon(req, res, user, uriParser);
	}
	
	@Override
	public AccessInterface getAccessInterface() {
		return moduleDescriptor;
	}

	@Override
	public ListOverviewButtonExtension getListOverviewButtonExtension(HttpServletRequest req, User user) {
		
		return new ListOverviewButtonExtension(buttonName, buttonTitle, "send-messages", listOverviewButtonDataAttributes, buttonExtensionScripts);
	}
	
}
