package com.nordicpeak.flowengine.flowinstanceadmin2.export.excel;

import java.sql.SQLException;
import java.util.List;

import se.unlogic.standardutils.dao.AnnotatedDAO;
import se.unlogic.standardutils.dao.LowLevelQuery;

import com.nordicpeak.flowengine.beans.Flow;
import com.nordicpeak.flowengine.beans.FlowInstance;

public class DeferedFlowInstances {

	private final Flow flow;
	private final int flowInstanceCount;

	private final List<FlowInstance> flowInstances;

	private final AnnotatedDAO<FlowInstance> dao;
	private final LowLevelQuery<FlowInstance> query;

	public DeferedFlowInstances(Flow flow, List<FlowInstance> flowInstances) {
		super();

		this.flow = flow;
		this.flowInstanceCount = flowInstances.size();
		this.flowInstances = flowInstances;
		query = null;
		dao = null;
	}

	public DeferedFlowInstances(Flow flow, int flowInstanceCount, AnnotatedDAO<FlowInstance> dao, LowLevelQuery<FlowInstance> query) {
		super();

		this.flow = flow;
		this.flowInstanceCount = flowInstanceCount;
		this.dao = dao;
		this.query = query;
		flowInstances = null;
	}

	public List<FlowInstance> getFlowInstances() throws SQLException {

		if (flowInstances != null) {
			return flowInstances;
		}

		return dao.getAll(query);
	}

	public Flow getFlow() {
		return flow;
	}

	public int getFlowInstanceCount() {
		return flowInstanceCount;
	}

}
