package com.nordicpeak.flowengine.flowinstanceadmin2.export.excel;

import java.awt.Color;
import java.lang.reflect.Field;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import javax.xml.transform.TransformerException;

import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.FillPatternType;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.ss.util.CellReference;
import org.apache.poi.ss.util.WorkbookUtil;
import org.apache.poi.xssf.usermodel.DefaultIndexedColorMap;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFColor;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.annotations.CheckboxSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.EventListener;
import se.unlogic.hierarchy.core.annotations.GroupMultiListSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.InstanceManagerDependency;
import se.unlogic.hierarchy.core.annotations.ModuleSetting;
import se.unlogic.hierarchy.core.annotations.TextFieldSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.WebPublic;
import se.unlogic.hierarchy.core.annotations.XSLVariable;
import se.unlogic.hierarchy.core.beans.Group;
import se.unlogic.hierarchy.core.beans.LinkTag;
import se.unlogic.hierarchy.core.beans.ScriptTag;
import se.unlogic.hierarchy.core.beans.SimpleAccessInterface;
import se.unlogic.hierarchy.core.beans.SimpleForegroundModuleResponse;
import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.enums.CRUDAction;
import se.unlogic.hierarchy.core.enums.EventSource;
import se.unlogic.hierarchy.core.events.CRUDEvent;
import se.unlogic.hierarchy.core.exceptions.AccessDeniedException;
import se.unlogic.hierarchy.core.exceptions.URINotFoundException;
import se.unlogic.hierarchy.core.interfaces.AccessInterface;
import se.unlogic.hierarchy.core.interfaces.ForegroundModuleResponse;
import se.unlogic.hierarchy.core.interfaces.SectionInterface;
import se.unlogic.hierarchy.core.interfaces.modules.descriptors.ForegroundModuleDescriptor;
import se.unlogic.hierarchy.core.utils.AccessUtils;
import se.unlogic.hierarchy.core.utils.ModuleUtils;
import se.unlogic.hierarchy.core.utils.ModuleViewFragmentTransformer;
import se.unlogic.hierarchy.core.utils.ViewFragmentModule;
import se.unlogic.hierarchy.foregroundmodules.AnnotatedForegroundModule;
import se.unlogic.hierarchy.foregroundmodules.staticcontent.StaticContentModule;
import se.unlogic.openhierarchy.foregroundmodules.siteprofile.interfaces.SiteProfile;
import se.unlogic.openhierarchy.foregroundmodules.siteprofile.interfaces.SiteProfileHandler;
import se.unlogic.standardutils.collections.CollectionUtils;
import se.unlogic.standardutils.dao.AnnotatedDAO;
import se.unlogic.standardutils.dao.HighLevelQuery;
import se.unlogic.standardutils.dao.LowLevelQuery;
import se.unlogic.standardutils.dao.QueryParameterFactory;
import se.unlogic.standardutils.dao.SimpleAnnotatedDAOFactory;
import se.unlogic.standardutils.dao.querys.ObjectQuery;
import se.unlogic.standardutils.date.DateUtils;
import se.unlogic.standardutils.db.DBUtils;
import se.unlogic.standardutils.db.tableversionhandler.TableVersionHandler;
import se.unlogic.standardutils.db.tableversionhandler.UpgradeResult;
import se.unlogic.standardutils.db.tableversionhandler.XMLDBScriptProvider;
import se.unlogic.standardutils.io.CloseUtils;
import se.unlogic.standardutils.io.FileUtils;
import se.unlogic.standardutils.json.JsonObject;
import se.unlogic.standardutils.json.JsonUtils;
import se.unlogic.standardutils.numbers.NumberUtils;
import se.unlogic.standardutils.populators.IntegerPopulator;
import se.unlogic.standardutils.string.SingleTagSource;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.string.TagReplacer;
import se.unlogic.standardutils.threads.ExeptionHandlingRunnable;
import se.unlogic.standardutils.threads.ThreadUtils;
import se.unlogic.standardutils.time.MillisecondTimeUnits;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationErrorType;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLGeneratorDocument;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.standardutils.xsl.XSLVariableReader;
import se.unlogic.standardutils.xsl.XSLVariableReaderRenamer;
import se.unlogic.webutils.http.HTTPUtils;
import se.unlogic.webutils.http.RequestUtils;
import se.unlogic.webutils.http.SessionUtils;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.Constants;
import com.nordicpeak.flowengine.FlowAdminModule;
import com.nordicpeak.flowengine.beans.DefaultInstanceMetadata;
import com.nordicpeak.flowengine.beans.Flow;
import com.nordicpeak.flowengine.beans.FlowAdminExtensionShowView;
import com.nordicpeak.flowengine.beans.FlowFamily;
import com.nordicpeak.flowengine.beans.FlowInstance;
import com.nordicpeak.flowengine.beans.FlowType;
import com.nordicpeak.flowengine.beans.QueryDescriptor;
import com.nordicpeak.flowengine.beans.QueryInstanceDescriptor;
import com.nordicpeak.flowengine.beans.QueryTypeDescriptor;
import com.nordicpeak.flowengine.beans.Step;
import com.nordicpeak.flowengine.dao.FlowEngineDAOFactory;
import com.nordicpeak.flowengine.enums.ManagerAccess;
import com.nordicpeak.flowengine.flowinstanceadmin2.FlowInstanceAdmin2Module;
import com.nordicpeak.flowengine.flowinstanceadmin2.export.excel.beans.FlowFamilyExportSettings;
import com.nordicpeak.flowengine.flowinstanceadmin2.interfaces.ColoredTagProvider;
import com.nordicpeak.flowengine.flowinstanceadmin2.interfaces.ListOverviewButtonExtension;
import com.nordicpeak.flowengine.flowinstanceadmin2.interfaces.ListOverviewButtonExtensionProvider;
import com.nordicpeak.flowengine.interfaces.ColumnExportableQueryInstance;
import com.nordicpeak.flowengine.interfaces.FlowAdminExtensionViewProvider;
import com.nordicpeak.flowengine.interfaces.ImmutableQueryInstance;
import com.nordicpeak.flowengine.interfaces.InstanceMetadata;
import com.nordicpeak.flowengine.interfaces.NonColumnExportableQueryInstance;
import com.nordicpeak.flowengine.interfaces.QueryHandler;
import com.nordicpeak.flowengine.interfaces.QueryInstance;
import com.nordicpeak.flowengine.interfaces.StringValueQueryInstance;
import com.nordicpeak.flowengine.utils.FlowInstanceUtils;

public class FlowInstanceExcelExporterModule extends AnnotatedForegroundModule implements ListOverviewButtonExtensionProvider, FlowAdminExtensionViewProvider, ViewFragmentModule<ForegroundModuleDescriptor> {

	private static final AnnotatedRequestPopulator<FlowFamilyExportSettings> EXPORT_SETTINGS_POPULATOR = new AnnotatedRequestPopulator<>(FlowFamilyExportSettings.class);

	private static final List<Field> LIST_FLOW_FAMILIES_IGNORED_FIELDS = Arrays.asList(FlowType.ALLOWED_ADMIN_GROUPS_RELATION, FlowType.ALLOWED_QUERIES_RELATION, FlowType.ALLOWED_ADMIN_USERS_RELATION, FlowType.CATEGORIES_RELATION, Flow.STATUSES_RELATION, Flow.DEFAULT_FLOW_STATE_MAPPINGS_RELATION, Flow.STEPS_RELATION, Flow.TAGS_RELATION, FlowFamily.MANAGER_USERS_RELATION, FlowFamily.MANAGER_GROUPS_RELATION);
	private static final List<Field> LIST_FLOW_VERSIONS_IGNORED_FIELDS = Arrays.asList(FlowType.ALLOWED_ADMIN_GROUPS_RELATION, FlowType.ALLOWED_QUERIES_RELATION, FlowType.ALLOWED_ADMIN_USERS_RELATION, FlowType.CATEGORIES_RELATION, Flow.STATUSES_RELATION, Flow.DEFAULT_FLOW_STATE_MAPPINGS_RELATION, Flow.TAGS_RELATION, FlowFamily.MANAGER_USERS_RELATION, FlowFamily.MANAGER_GROUPS_RELATION, Flow.FLOW_TYPE_RELATION);

	protected static final ValidationError FLOW_FAMILY_NOT_FOUND_VALIDATION_ERROR = new ValidationError("FlowFamilyNotFound");
	protected static final ValidationError FLOW_FAMILY_ACCESS_DENIED_VALIDATION_ERROR = new ValidationError("FlowFamilyAccessDenied");
	protected static final ValidationError NO_FLOW_VERSIONS_SELECTED_VALIDATION_ERROR = new ValidationError("NoFlowVersionsSelected");

	@XSLVariable(prefix = "java.")
	private String buttonName = "export";

	@XSLVariable(prefix = "java.")
	private String buttonTitle = "export";

	@XSLVariable(prefix = "java.")
	private String queryNotSupported = "Query not supported";

	@XSLVariable(prefix = "java.")
	private String description = "Description";

	@XSLVariable(prefix = "java.")
	private String status = "Status";

	@XSLVariable(prefix = "java.")
	private String lastStatusChange = "Senaste statusndring";

	@XSLVariable(prefix = "java.")
	private String externalFlowID = "Externt rende-ID";

	@XSLVariable(prefix = "java.")
	private String submitted = "Submitted";

	@XSLVariable(prefix = "java.")
	private String siteProfile = "Site profile";

	@XSLVariable(prefix = "java.")
	private String managers = "Managers";

	@XSLVariable(prefix = "java.")
	private String anonymousSubmitter = "Anonymous Submitter";

	@XSLVariable(prefix = "java.")
	private String queryTypeMissing = "Query type missing";

	@XSLVariable(prefix = "java.")
	private String flowAdminExtensionViewTitle = "unset";

	@XSLVariable(prefix = "java.")
	private String exportedFileName = "unset";

	@ModuleSetting(allowsNull = true)
	@GroupMultiListSettingDescriptor(name = "Global access groups", description = "Groups with access to export all flows")
	protected List<Integer> globalAccessGroups;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "export timeout (ms)", description = "Abort export if user has not polled status in this time", required = true)
	protected Integer exportTimeout = 10 * MillisecondTimeUnits.SECOND;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "FlowAdminExtensionView priority", description = "The priority of this provider", required = true)
	private Integer flowAdminExtensionViewPriority = 0;

	@ModuleSetting
	@CheckboxSettingDescriptor(name = "Enable fragment XML debug", description = "Enables debugging of fragment XML")
	private boolean debugFragmentXML;

	private FlowAdminModule flowAdminModule;
	private FlowInstanceAdmin2Module flowInstanceAdmin2Module;

	@InstanceManagerDependency(required = true)
	protected StaticContentModule staticContentModule;

	@InstanceManagerDependency(required = true)
	private QueryHandler queryHandler;

	@InstanceManagerDependency
	private SiteProfileHandler siteProfileHandler;

	@InstanceManagerDependency(required = false)
	protected ColoredTagProvider coloredTagProvider;
	
	private AnnotatedDAO<FlowInstance> flowInstanceDAO;
	private AnnotatedDAO<QueryInstanceDescriptor> queryInstanceDescriptorDAO;
	private AnnotatedDAO<FlowFamilyExportSettings> exportSettingsDAO;

	private QueryParameterFactory<QueryInstanceDescriptor, Integer> queryInstanceDescriptorFlowInstanceIDParamFactory;
	private QueryParameterFactory<QueryInstanceDescriptor, QueryDescriptor> queryInstanceDescriptorQueryDescriptorParamFactory;

	protected QueryParameterFactory<FlowFamilyExportSettings, Integer> exportSettingsFlowFamilyIDParamFactory;

	private AccessInterface globalAccess;
	private List<ScriptTag> buttonExtensionScripts;
	private Map<String, String> listOverviewButtonDataAttributes;

	private ModuleViewFragmentTransformer<ForegroundModuleDescriptor> viewFragmentTransformer;

	@Override
	public void init(ForegroundModuleDescriptor moduleDescriptor, SectionInterface sectionInterface, DataSource dataSource) throws Exception {

		super.init(moduleDescriptor, sectionInterface, dataSource);

		if (!systemInterface.getInstanceHandler().addInstance(FlowInstanceExcelExporterModule.class, this)) {

			throw new RuntimeException("Unable to register module in global instance handler using key " + FlowInstanceExcelExporterModule.class.getSimpleName() + ", another instance is already registered using this key.");
		}
		
		
	}

	@Override
	protected void createDAOs(DataSource dataSource) throws Exception {

		//Automatic table version handling
		UpgradeResult upgradeResult = TableVersionHandler.upgradeDBTables(dataSource, FlowInstanceExcelExporterModule.class.getName(), new XMLDBScriptProvider(FlowInstanceExcelExporterModule.class.getResourceAsStream("DB script.xml")));

		if (upgradeResult.isUpgrade()) {

			log.info(upgradeResult.toString());
		}

		FlowEngineDAOFactory daoFactory = new FlowEngineDAOFactory(dataSource, systemInterface.getUserHandler(), systemInterface.getGroupHandler());

		flowInstanceDAO = daoFactory.getFlowInstanceDAO();
		queryInstanceDescriptorDAO = daoFactory.getQueryInstanceDescriptorDAO();

		queryInstanceDescriptorFlowInstanceIDParamFactory = daoFactory.getQueryInstanceDescriptorDAO().getParamFactory("flowInstanceID", Integer.class);
		queryInstanceDescriptorQueryDescriptorParamFactory = daoFactory.getQueryInstanceDescriptorDAO().getParamFactory("queryDescriptor", QueryDescriptor.class);

		exportSettingsDAO = new AnnotatedDAO<>(dataSource, FlowFamilyExportSettings.class, new SimpleAnnotatedDAOFactory(dataSource));
		exportSettingsFlowFamilyIDParamFactory = exportSettingsDAO.getParamFactory("flowFamilyID", Integer.class);
	}

	@Override
	protected void moduleConfigured() throws Exception {

		super.moduleConfigured();

		globalAccess = new SimpleAccessInterface(globalAccessGroups, null);

		XSLVariableReader variableReader = ModuleUtils.getXSLVariableReader(moduleDescriptor, sectionInterface.getSystemInterface());

		if (variableReader != null) {

			Map<String, String> map = new HashMap<>();
			map.put("scripts", "scripts-buttonextension");

			XSLVariableReaderRenamer variableReaderRenamed = new XSLVariableReaderRenamer(variableReader, map);

			buttonExtensionScripts = ModuleUtils.getScripts(variableReaderRenamed, sectionInterface, "f", moduleDescriptor);
		}

		listOverviewButtonDataAttributes = new HashMap<>(2);
		listOverviewButtonDataAttributes.put("url", systemInterface.getContextPath() + getFullAlias() + "/exportflowinstancestoexcel");
		listOverviewButtonDataAttributes.put("baseurl", systemInterface.getContextPath() + getFullAlias());

		viewFragmentTransformer = new ModuleViewFragmentTransformer<>(sectionInterface.getForegroundModuleXSLTCache(), this, systemInterface.getEncoding());
		viewFragmentTransformer.setDebugXML(debugFragmentXML);
	}

	@InstanceManagerDependency(required = true)
	public void setFlowInstanceAdmin2Module(FlowInstanceAdmin2Module flowInstanceAdmin2Module) {

		if (flowInstanceAdmin2Module != null) {

			flowInstanceAdmin2Module.addListOverviewButtonExtensionProvider(this);

		} else if (this.flowInstanceAdmin2Module != null) {

			this.flowInstanceAdmin2Module.removeListOverviewButtonExtensionProvider(this);
		}

		this.flowInstanceAdmin2Module = flowInstanceAdmin2Module;
	}

	@Override
	public void unload() throws Exception {

		if (flowInstanceAdmin2Module != null) {

			flowInstanceAdmin2Module.removeListOverviewButtonExtensionProvider(this);

			flowInstanceAdmin2Module = null;
		}

		if (flowAdminModule != null) {
			setFlowAdminModule(null);
		}

		systemInterface.getInstanceHandler().removeInstance(FlowInstanceExcelExporterModule.class, this);

		super.unload();
	}

	@Override
	public ForegroundModuleResponse defaultMethod(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		return listFlowFamilies(req, user, uriParser, null);
	}

	private ForegroundModuleResponse listFlowFamilies(HttpServletRequest req, User user, URIParser uriParser, ValidationError validationError) {

		log.info("User " + user + " listing families");

		Document doc = this.createDocument(req, uriParser);

		Element listFamiliesElement = doc.createElement("ListFamilies");
		doc.getDocumentElement().appendChild(listFamiliesElement);

		XMLGeneratorDocument generatorDocument = new XMLGeneratorDocument(doc);
		generatorDocument.setIgnoredFields(LIST_FLOW_FAMILIES_IGNORED_FIELDS);

		Collection<Flow> flows = flowAdminModule.getCachedFlows();

		for (Flow flow : flows) {

			if (flow.isLatestVersion() && flow.isInternal() && hasFlowFamilyAccess(user, flow.getFlowFamily())) {

				Element flowElement = flow.toXML(generatorDocument);

				flowAdminModule.appendFamilyInformation(doc, flowElement, flow, flows);

				listFamiliesElement.appendChild(flowElement);
			}
		}

		XMLUtils.appendNewElement(doc, listFamiliesElement, "FlowInstanceAdmin2ModuleFullAlias", flowInstanceAdmin2Module.getFullAlias());

		if (validationError != null) {

			XMLUtils.append(doc, listFamiliesElement, validationError);
		}

		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}

	@WebPublic(alias = "family")
	public ForegroundModuleResponse listFlowVersions(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		return listFlowVersions(req, res, user, uriParser, null);
	}

	private ForegroundModuleResponse listFlowVersions(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser, List<ValidationError> validationErrors) throws Throwable {

		Integer flowFamilyID = uriParser.getInt(2);

		FlowFamily flowFamily;

		if (flowFamilyID == null || (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) == null) {

			return listFlowFamilies(req, user, uriParser, FLOW_FAMILY_NOT_FOUND_VALIDATION_ERROR);

		} else if (!hasFlowFamilyAccess(user, flowFamily)) {

			return listFlowFamilies(req, user, uriParser, FLOW_FAMILY_ACCESS_DENIED_VALIDATION_ERROR);
		}

		log.info("User " + user + " listing flow versions in flow family " + flowFamily);

		XMLGeneratorDocument doc = new XMLGeneratorDocument(createDocument(req, uriParser));
		doc.setIgnoredFields(LIST_FLOW_VERSIONS_IGNORED_FIELDS);

		Element listVersionsElement = doc.createElement("ListFlowVersions");

		doc.getDocumentElement().appendChild(listVersionsElement);

		listVersionsElement.appendChild(flowFamily.toXML(doc));

		List<Flow> flowVersions = flowAdminModule.getFlowVersions(flowFamily);

		XMLUtils.append(doc, listVersionsElement, flowVersions);

		if (validationErrors != null) {

			XMLUtils.append(doc, listVersionsElement, validationErrors);
			listVersionsElement.appendChild(RequestUtils.getRequestParameters(req, doc, "flowID"));
		}

		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}

	protected final boolean hasFlowFamilyAccess(User user, FlowFamily flowFamily) {

		return hasFlowFamilyAccessBase(user, flowFamily) || hasFlowFamilyAccessExtended(user, flowFamily);
	}

	protected final boolean hasFlowFamilyAccessBase(User user, FlowFamily flowFamily) {

		return AccessUtils.checkAccess(user, globalAccess) || flowFamily.getManagerAccess(user) != null;
	}

	protected boolean hasFlowFamilyAccessExtended(User user, FlowFamily flowFamily) {

		return false;
	}

	private List<Flow> getFlowVersions(FlowFamily flowFamily, List<Integer> flowIDs) {

		List<Flow> flows = flowAdminModule.getFlowVersions(flowFamily);

		Iterator<Flow> iterator = flows.iterator();

		while (iterator.hasNext()) {

			Flow flow = iterator.next();

			if (!flow.isEnabled() || !flowIDs.contains(flow.getFlowID())) {

				iterator.remove();
			}
		}

		return flows;
	}

	@WebPublic(toLowerCase = true)
	public ForegroundModuleResponse exportFlowVersionsToExcel(final HttpServletRequest req, final HttpServletResponse res, final User user, final URIParser uriParser) throws Throwable {

		Integer flowFamilyID = uriParser.getInt(2);
		FlowFamily flowFamily = null;

		if (flowFamilyID == null || (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) == null) {

			return listFlowFamilies(req, user, uriParser, FLOW_FAMILY_NOT_FOUND_VALIDATION_ERROR);
		}

		ManagerAccess managerAccess = flowFamily.getManagerAccess(user);
		boolean hasGlobalAccess = AccessUtils.checkAccess(user, globalAccess);
		boolean hasExtendedAccess = hasFlowFamilyAccessExtended(user, flowFamily);
		boolean restricted = !hasGlobalAccess && !hasExtendedAccess && managerAccess == ManagerAccess.RESTRICTED;

		if (!hasGlobalAccess && managerAccess == null && !hasExtendedAccess) {

			return listFlowFamilies(req, user, uriParser, FLOW_FAMILY_ACCESS_DENIED_VALIDATION_ERROR);
		}

		List<Integer> flowIDs = NumberUtils.toInt(req.getParameterValues("flowID"));

		List<ValidationError> validationErrors = new ArrayList<>(4);
		List<Flow> flows = null;

		if (flowIDs == null) {

			validationErrors.add(NO_FLOW_VERSIONS_SELECTED_VALIDATION_ERROR);

		} else {

			flows = getFlowVersions(flowFamily, flowIDs);

			if (CollectionUtils.isEmpty(flows)) {
				validationErrors.add(NO_FLOW_VERSIONS_SELECTED_VALIDATION_ERROR);
			}
		}

		Timestamp fromDate = null;
		Timestamp toDate = null;

		if (!StringUtils.isEmpty(req.getParameter("fromDate"))) {

			Date fromDateUtil = DateUtils.getDate(DateUtils.DATE_FORMATTER, req.getParameter("fromDate"));

			if (fromDateUtil == null) {

				validationErrors.add(new ValidationError("fromDate", ValidationErrorType.InvalidFormat));

			} else {

				fromDate = new Timestamp(DateUtils.setTimeToMidnight(fromDateUtil).getTime());
			}
		}

		if (!StringUtils.isEmpty(req.getParameter("toDate"))) {

			Date toDateUtil = DateUtils.getDate(DateUtils.DATE_FORMATTER, req.getParameter("toDate"));

			if (toDateUtil == null) {

				validationErrors.add(new ValidationError("toDate", ValidationErrorType.InvalidFormat));

			} else {

				toDate = new Timestamp(DateUtils.setTimeToMaximum(toDateUtil).getTime());
			}
		}

		if (!validationErrors.isEmpty()) {
			return listFlowVersions(req, res, user, uriParser, validationErrors);
		}

		log.info("User " + user + " exporting flow family " + flowFamily + " from date " + fromDate + "  to date " + toDate);

		List<DeferedFlowInstances> deferedFlowInstances = new ArrayList<>();

		Connection connection = dataSource.getConnection();

		try {
			for (Flow flow : flows) {

				StringBuilder sql = new StringBuilder();
				sql.append("SELECT COUNT(DISTINCT flowInstance.flowInstanceID)");

				getExportSQL(sql, flowFamily, flow, fromDate, toDate, restricted, user, false);

				ObjectQuery<Integer> countQuery = new ObjectQuery<>(connection, false, sql.toString(), IntegerPopulator.getPopulator());

				int paramIndex = 1;

				if (fromDate != null) {
					countQuery.setTimestamp(paramIndex++, fromDate);
				}

				if (toDate != null) {
					countQuery.setTimestamp(paramIndex++, toDate);
				}

				sql.setLength(0);
				sql.append("SELECT flowInstance.*");

				getExportSQL(sql, flowFamily, flow, fromDate, toDate, restricted, user, true);

				LowLevelQuery<FlowInstance> getQuery = new LowLevelQuery<>(sql.toString());
				getQuery.addRelations(FlowInstance.STATUS_RELATION, FlowInstance.ATTRIBUTES_RELATION, FlowInstance.MANAGERS_RELATION, FlowInstance.MANAGER_GROUPS_RELATION);
				getQuery.addCachedRelations(FlowInstance.STATUS_RELATION, FlowInstance.MANAGERS_RELATION, FlowInstance.MANAGER_GROUPS_RELATION);

				if (fromDate != null) {
					getQuery.addParameter(fromDate);
				}

				if (toDate != null) {
					getQuery.addParameter(toDate);
				}

				deferedFlowInstances.add(new DeferedFlowInstances(flow, countQuery.executeQuery(), flowInstanceDAO, getQuery));

				// Requires high level query with and or parameters
				//				QueryResultsStreamer<FlowInstance, Integer> resultsStreamer = new QueryResultsStreamer<FlowInstance, Integer>(flowInstanceDAO, FlowInstance.ID_FIELD, Integer.class, Order.ASC, getQuery);
			}

		} finally {
			DBUtils.closeConnection(connection);
		}

		return exportFlowInstancesToExcel(deferedFlowInstances, req, res, user, uriParser);
	}

	private void getExportSQL(StringBuilder sql, FlowFamily flowFamily, Flow flow, Date fromDate, Date toDate, boolean userHasRestrictedAccess, User user, boolean groupBy) {

		sql.append("FROM flowengine_flow_instances flowInstance");
		sql.append(" INNER JOIN flowengine_flows flow ON flow.flowID = flowInstance.flowID");
		sql.append(" INNER JOIN flowengine_flow_statuses flowStatus ON flowStatus.statusID = flowInstance.statusID");

		if (userHasRestrictedAccess) {
			sql.append(" LEFT JOIN flowengine_flow_instance_managers flowInstanceManager ON flowInstance.flowInstanceID = flowInstanceManager.flowInstanceID");
			sql.append(" LEFT JOIN flowengine_flow_instance_manager_groups flowInstanceManagerGroups ON flowInstance.flowInstanceID = flowInstanceManagerGroups.flowInstanceID");
		}

		sql.append(" WHERE flowInstance.firstSubmitted IS NOT NULL AND flowStatus.contentType != 'NEW'");
		sql.append(" AND flow.flowFamilyID = " + flowFamily.getFlowFamilyID() + " AND flow.flowID = " + flow.getFlowID());

		if (fromDate != null) {
			sql.append(" AND (flowInstance.firstSubmitted >= ?)");
		}

		if (toDate != null) {
			sql.append(" AND (flowInstance.firstSubmitted <= ?)");
		}

		if (userHasRestrictedAccess) {

			sql.append(" AND (");

			sql.append("flowInstanceManager.userID = ");
			sql.append(user.getUserID());

			if (user.getGroups() != null) {

				sql.append(" OR ");

				sql.append("flowInstanceManagerGroups.groupID IN (");
				flowInstanceAdmin2Module.appendGroupIDs(sql, (List<Group>) user.getGroups());
				sql.append(")");
			}

			sql.append(")");
		}

		getExportSQLExtended(sql, flowFamily, flow, fromDate, toDate, userHasRestrictedAccess, user, groupBy);

		if (userHasRestrictedAccess && groupBy) {

			sql.append(" GROUP BY flowInstance.flowInstanceID ASC");
		}

		sql.append(" ORDER BY flowInstance.flowInstanceID ASC");
	}

	protected void getExportSQLExtended(StringBuilder sql, FlowFamily flowFamily, Flow flow, Date fromDate, Date toDate, boolean userHasRestrictedAccess, User user, boolean groupBy) {

	}

	@WebPublic(toLowerCase = true)
	public ForegroundModuleResponse exportFlowInstancesToExcel(final HttpServletRequest req, final HttpServletResponse res, final User user, final URIParser uriParser) throws Throwable {

		List<ValidationError> validationErrors = new ArrayList<>();

		List<FlowInstance> flowInstances = flowInstanceAdmin2Module.getFlowInstanceSelection(false, false, req, res, user, uriParser, validationErrors, FlowInstance.ATTRIBUTES_RELATION, Flow.STEPS_RELATION, Step.QUERY_DESCRIPTORS_RELATION, QueryDescriptor.EVALUATOR_DESCRIPTORS_RELATION);

		if (!validationErrors.isEmpty()) {

			return flowInstanceAdmin2Module.list(req, res, user, uriParser, validationErrors);

		} else if (flowInstances == null) {

			flowInstanceAdmin2Module.redirectToDefaultMethod(req, res);
			return null;
		}

		log.info("User " + user + " exporting flow instances with IDs: " + StringUtils.toCommaSeparatedString(NumberUtils.toInt(req.getParameterValues("flowInstanceID"))));

		Map<Flow, List<FlowInstance>> flowMap = new HashMap<>();

		for (FlowInstance flowInstance : flowInstances) {

			List<FlowInstance> mappedInstances = flowMap.get(flowInstance.getFlow());

			if (mappedInstances == null) {
				mappedInstances = new ArrayList<>();
				flowMap.put(flowInstance.getFlow(), mappedInstances);
			}

			mappedInstances.add(flowInstance);
		}

		List<DeferedFlowInstances> deferedFlowInstances = new ArrayList<>();

		for (Entry<Flow, List<FlowInstance>> entry : flowMap.entrySet()) {
			deferedFlowInstances.add(new DeferedFlowInstances(entry.getKey(), entry.getValue()));
		}

		return exportFlowInstancesToExcel(deferedFlowInstances, req, res, user, uriParser);
	}

	public ForegroundModuleResponse exportFlowInstancesToExcel(final List<DeferedFlowInstances> deferedFlowInstanceList, final HttpServletRequest req, final HttpServletResponse res, final User user, final URIParser uriParser) throws Throwable {

		final long exportStart = System.currentTimeMillis();
		final String requestTimestamp = req.getParameter("timestamp");

		if (requestTimestamp != null) {

			int total = 0;

			for (DeferedFlowInstances deferedFlowInstances : deferedFlowInstanceList) {
				total += deferedFlowInstances.getFlowInstanceCount();
			}

			setExportStartSessionString(requestTimestamp, total, req);
		}
		
		
		

		final InstanceMetadata metadata = new DefaultInstanceMetadata(getCurrentSiteProfile(req, user, uriParser));

		//Workaround for thread local usage in XMLBeans used by XSSF
		ExeptionHandlingRunnable runnable = new ExeptionHandlingRunnable() {

			private Exception exception;

			@Override
			public void run() {

				try {
					Workbook workbook = new XSSFWorkbook();

					try {
						int totalProgress = 0;

						Map<String, Integer> duplicateSheetNameCounter = new HashMap<>();

						boolean appendDateToFileName = false;
						
						flowLoop: for (DeferedFlowInstances deferedFlowInstances : deferedFlowInstanceList) {

							Flow flow = deferedFlowInstances.getFlow();
							Integer versionTotal = deferedFlowInstances.getFlowInstanceCount();

							if (requestTimestamp != null) {
								setExportProgressSessionString(requestTimestamp, flow, 0, versionTotal, totalProgress, req);
							}

							int allowedNameLength = 31;

							String versionName = " (ver. " + flow.getVersion() + ")";
							String sheetName;

							sheetName = StringUtils.substring(flow.getName(), allowedNameLength - versionName.length(), "...") + versionName;
							sheetName = WorkbookUtil.createSafeSheetName(sheetName);

							Integer duplicateSheetNameCount = duplicateSheetNameCounter.putIfAbsent(sheetName, 1);

							if (duplicateSheetNameCount != null) {

								duplicateSheetNameCounter.put(sheetName, ++duplicateSheetNameCount);

								String duplicateString = " " + duplicateSheetNameCount.toString();

								sheetName = StringUtils.substring(flow.getName(), allowedNameLength - versionName.length() - duplicateString.length(), "...") + versionName + duplicateString;
								sheetName = WorkbookUtil.createSafeSheetName(sheetName);
							}

							Sheet sheet = workbook.createSheet(sheetName);

							sheet.setColumnWidth(0, 1500);

							Row row = null;

							int rowIndex = 0;
							int cellIndex = 0;

							row = sheet.createRow(rowIndex++);

							Font titleFont = workbook.createFont();
							titleFont.setBold(true);
							titleFont.setFontHeightInPoints((short) 16);

							CellStyle titleStyle = workbook.createCellStyle();
							titleStyle.setFont(titleFont);

							Font subTitleFont = workbook.createFont();
							subTitleFont.setBold(true);
							CellStyle subTitleStyle = workbook.createCellStyle();
							subTitleStyle.setFont(subTitleFont);

							createCell(row, 0, flow.getName(), titleStyle);

							if (flow.getSteps() != null) {

								row = sheet.createRow(rowIndex++);
								createCell(row, cellIndex++, "ID", subTitleStyle);

								boolean exportExternalFlowID = false;
								FlowFamilyExportSettings exportSettings = getExportSettings(flow);

								if (exportSettings != null && !appendDateToFileName) {
									
									appendDateToFileName = exportSettings.addDateToFileName();
								}

								if (exportSettings != null && exportSettings.isEnabled() && exportSettings.isExportExternalFlowID()) {

									exportExternalFlowID = true;

									sheet.setColumnWidth(cellIndex, 5000);
									createCell(row, cellIndex++, externalFlowID, subTitleStyle);
								}

								if (flowInstanceAdmin2Module.isEnableDescriptionColumn()) {

									createCell(row, cellIndex++, description, subTitleStyle);
								}

								createCell(row, cellIndex++, status, subTitleStyle);

								sheet.setColumnWidth(cellIndex, 6000);
								createCell(row, cellIndex++, submitted, subTitleStyle);

								boolean exportLastStatusChange = false;

								if (exportSettings != null && exportSettings.isEnabled() && exportSettings.isExportLastStatusChange()) {

									exportLastStatusChange = true;

									sheet.setColumnWidth(cellIndex, 6000);
									createCell(row, cellIndex++, lastStatusChange, subTitleStyle);
								}

								if (flowInstanceAdmin2Module.isEnableSiteProfileSupport()) {

									sheet.setColumnWidth(cellIndex, 6000);
									createCell(row, cellIndex++, siteProfile, subTitleStyle);
								}

								createCell(row, cellIndex++, managers, subTitleStyle);

								List<String> exportAttributes = null;
								boolean hideQueryColumns = false;

								if (exportSettings != null && exportSettings.isEnabled()) {

									exportAttributes = exportSettings.getExportAttributes();
									hideQueryColumns = exportSettings.isHideQueryColumns();
								}

								List<FlowInstance> flowInstances = deferedFlowInstances.getFlowInstances();
								
								if (flowInstances != null) {
									
									Map<Integer, String> flowInstanceIDAndColor = null;
									
									if(coloredTagProvider != null && exportSettings != null && exportSettings.isEnabled() && exportSettings.isExportColoredTags()) {
										
										flowInstanceIDAndColor = coloredTagProvider.getFlowInstanceIDAndHexColorByFlowInstance(flowInstances);
									}
									
									List<Integer> queryColumnCounts = new ArrayList<>();

									if (!hideQueryColumns) {

										// Create header row
										for (Step step : flow.getSteps()) {

											if (step.getQueryDescriptors() != null) {

												for (QueryDescriptor queryDescriptor : step.getQueryDescriptors()) {

													QueryTypeDescriptor queryTypeDescriptor = queryHandler.getQueryType(queryDescriptor.getQueryTypeID());

													if (queryTypeDescriptor == null) {

														log.warn("Unable to export flow " + flow + ", query type missing " + queryDescriptor.getQueryTypeID());
														createCell(sheet.createRow(rowIndex), 0, queryTypeMissing + " " + queryDescriptor + ", " + queryDescriptor.getQueryTypeID(), subTitleStyle);

														continue flowLoop;
													}

													Class<? extends QueryInstance> queryInstanceClass = queryTypeDescriptor.getQueryInstanceClass();

													if (NonColumnExportableQueryInstance.class.isAssignableFrom(queryInstanceClass)) {

														continue;

													} else if (ColumnExportableQueryInstance.class.isAssignableFrom(queryInstanceClass)) {

														FlowInstance flowInstance = flowInstances.get(0);

														QueryInstanceDescriptor instanceDescriptor = getQueryInstanceDescriptor(flowInstance.getFlowInstanceID(), queryDescriptor);

														instanceDescriptor.setQueryDescriptor(queryDescriptor);

														ImmutableQueryInstance queryInstance = queryHandler.getImmutableQueryInstance(instanceDescriptor, req, metadata);

														List<String> labels = ((ColumnExportableQueryInstance) queryInstance).getColumnLabels(queryHandler);

														for (String label : labels) {

															sheet.setColumnWidth(cellIndex, 6000);

															createCell(row, cellIndex++, label, subTitleStyle);
														}

														queryColumnCounts.add(labels.size());

													} else {

														sheet.setColumnWidth(cellIndex, 6000);

														createCell(row, cellIndex++, queryDescriptor.getName(), subTitleStyle);
														queryColumnCounts.add(1);
													}
												}
											}
										}
									}

									if (!CollectionUtils.isEmpty(exportAttributes)) {

										for (String attribute : exportAttributes) {

											sheet.setColumnWidth(cellIndex, 6000);

											if (attribute.contains(":") && !attribute.endsWith(":")) {

												attribute = attribute.split(":")[1];
											}

											createCell(row, cellIndex++, StringUtils.toFirstLetterUppercase(attribute), subTitleStyle);
										}
									}

									sheet.setAutoFilter(CellRangeAddress.valueOf("A2:" + CellReference.convertNumToColString(cellIndex < 0 ? 0 : cellIndex - 1) + "2"));

									StringBuilder managersBuilder = new StringBuilder();
									
									// Create data rows
									for (FlowInstance flowInstance : flowInstances) {
											
										row = sheet.createRow(rowIndex++);
										cellIndex = 0;
										
										XSSFCellStyle cellStyle = null;
										
										if(coloredTagProvider != null && exportSettings != null && exportSettings.isEnabled() && exportSettings.isExportColoredTags()) {
											
											cellStyle = createCellStyle(workbook, flowInstanceIDAndColor.get(flowInstance.getFlowInstanceID()));
										}
										
										createCell(row, cellIndex++, flowInstance.getFlowInstanceID(), cellStyle);										
										
										if (exportExternalFlowID) {

											String externalID = flowInstance.getAttributeHandler().getString(Constants.FLOW_INSTANCE_EXTERNAL_ID_ATTRIBUTE);

											if (externalID != null) {
												
												createCell(row, cellIndex++, externalID, cellStyle);
										
											} else {
												
												createCell(row, cellIndex++, "", cellStyle);
											}
										}

										if (flowInstanceAdmin2Module.isEnableDescriptionColumn()) {

											if (flowInstance.getManagerDescription() != null) {
												
												createCell(row, cellIndex++, flowInstance.getManagerDescription(), cellStyle);
										
											} else {
												
												createCell(row, cellIndex++, "", cellStyle);
											}
										}
										
										createCell(row, cellIndex++, flowInstance.getStatus().getName(), cellStyle);

										if (flowInstance.getFirstSubmitted() != null) {
											
											createCell(row, cellIndex++, DateUtils.DATE_TIME_SECONDS_FORMATTER.format(flowInstance.getFirstSubmitted()), cellStyle);

										} else {
											
											createCell(row, cellIndex++, "", cellStyle);
										}

										if (exportLastStatusChange) {

											if (flowInstance.getLastStatusChange() != null) {
												
												createCell(row, cellIndex++, DateUtils.DATE_TIME_SECONDS_FORMATTER.format(flowInstance.getLastStatusChange()), cellStyle);

											} else {
												
												createCell(row, cellIndex++, "", cellStyle);
											}
										}

										if (flowInstanceAdmin2Module.isEnableSiteProfileSupport()) {

											SiteProfile profile = siteProfileHandler.getProfile(flowInstance.getProfileID());

											if (profile != null) {
												
												createCell(row, cellIndex++, profile.getName(), cellStyle);

											} else {
												
												createCell(row, cellIndex++, "", cellStyle);
											}
										}
										
										createCell(row, cellIndex++, FlowInstanceUtils.getManagersString(managersBuilder, flowInstance.getManagers(), flowInstance.getManagerGroups(), true, true).toString(), cellStyle);
										managersBuilder.setLength(0);

										if (!hideQueryColumns) {

											int nextQueryIndex = 0;

											for (Step step : flow.getSteps()) {

												step.setFlow(flow);

												if (step.getQueryDescriptors() != null) {

													for (QueryDescriptor queryDescriptor : step.getQueryDescriptors()) {

														queryDescriptor.setStep(step);
														int queryIndex = nextQueryIndex++;

														QueryInstanceDescriptor instanceDescriptor = getQueryInstanceDescriptor(flowInstance.getFlowInstanceID(), queryDescriptor);

														if (instanceDescriptor == null) {

															log.warn("Unable to find instance descriptor for flow instance ID " + flowInstance.getFlowInstanceID() + " and query " + queryDescriptor);
															cellIndex += queryColumnCounts.get(queryIndex);
															continue;
														}

														instanceDescriptor.setQueryDescriptor(queryDescriptor);

														ImmutableQueryInstance queryInstance = queryHandler.getImmutableQueryInstance(instanceDescriptor, req, metadata);

														if (NonColumnExportableQueryInstance.class.isAssignableFrom(queryInstance.getClass())) {

															nextQueryIndex--;
															continue;
														}

														if (instanceDescriptor.isPopulated()) {

															if (queryInstance instanceof ColumnExportableQueryInstance) {

																List<String> values = ((ColumnExportableQueryInstance) queryInstance).getColumnValues();

																if (values.size() != queryColumnCounts.get(queryIndex)) {

																	workbook.close();

																	throw new RuntimeException("Column count mismatch between header (" + queryColumnCounts.get(queryIndex) + ") and row (" + values.size() + ") for " + queryInstance + " in queryDescriptor " + queryDescriptor);
																}

																for (String value : values) {

																	if (value == null) {

																		createCell(row, cellIndex++, "", cellStyle);

																	} else {
																		
																		createCell(row, cellIndex++, value, cellStyle);
																	}
																}

															} else if (queryInstance instanceof StringValueQueryInstance) {

																String value = ((StringValueQueryInstance) queryInstance).getStringValue();

																if (value == null) {

																	createCell(row, cellIndex++, "", cellStyle);

																} else {
																	
																	createCell(row, cellIndex++, value, cellStyle);
																}

															} else {
																
																createCell(row, cellIndex++, queryNotSupported, cellStyle);
															}

														} else {
															
															//Create empty cells to set their cellStyle
															for(int i = 0; i < queryColumnCounts.get(queryIndex); i++) {
																
																createCell(row, cellIndex++, "", cellStyle);
															}
														}
													}
												}
											}
										}

										if (!CollectionUtils.isEmpty(exportAttributes)) {

											for (String attribute : exportAttributes) {

												if (attribute.contains(":")) {

													attribute = attribute.split(":")[0];
												}

												String attributeValue = flowInstance.getAttributeHandler().getString(attribute);
												createCell(row, cellIndex++, attributeValue, cellStyle);
											}
										}

										if (requestTimestamp != null) {

											Long lastPoll = (Long) SessionUtils.getAttribute(getExportProgressSessionString(requestTimestamp) + "-lastPoll", req);

											if (lastPoll == null) {
												lastPoll = exportStart;
											}

											if (System.currentTimeMillis() - lastPoll > exportTimeout) {

												log.warn("Aborting export " + requestTimestamp + ", user has not polled status in the last " + exportTimeout / MillisecondTimeUnits.SECOND + " seconds");
												return;
											}

											totalProgress++;
											setExportProgressSessionString(requestTimestamp, flow, (rowIndex - 2), versionTotal, totalProgress, req);
										}
									}
								}
							}
						}

						try {
							if (requestTimestamp != null) {
								setExportCompleteSessionString(requestTimestamp, true, req);
							}

							String date = "";

							if (appendDateToFileName) {
								date = " - " + LocalDate.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
							}

							Map<FlowFamily, Long> map = deferedFlowInstanceList.stream().map(DeferedFlowInstances::getFlow).collect(Collectors.groupingBy(Flow::getFlowFamily, Collectors.counting()));

							String fileName = deferedFlowInstanceList.get(0).getFlow().getName() + date + ".xlsx";

							if (map.keySet().size() > 1) {
								
								TagReplacer tagReplacer = new TagReplacer();

								tagReplacer.addTagSource(new SingleTagSource("$numberOfExportedFlows", String.valueOf(map.keySet().size())));

								fileName = tagReplacer.replace(exportedFileName) + date + ".xlsx";

							}

							res.setHeader("Content-Disposition", "attachment;" + FileUtils.toContentDispositionFilename(fileName));
							res.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");

							workbook.write(res.getOutputStream());

							res.getOutputStream().flush();

						} catch (Exception e) {

							log.info("Unable to send excel file to user " + user + ", " + e);

							if (requestTimestamp != null) {
								setExportCompleteSessionString(requestTimestamp, false, req);
							}
						}

					} finally {

						CloseUtils.close(workbook);

						if (requestTimestamp != null) {
							removeExportSessionStrings(requestTimestamp, req);
						}
					}

				} catch (Exception e) {

					exception = e;
				}
			}

			

			@Override
			public Exception getException() {

				return exception;
			}
		};

		ThreadUtils.runAndWait(runnable, "Flow instance POI export thread for user " + user + " and export " + requestTimestamp, true);

		if (runnable.getException() != null) {
			throw runnable.getException();
		}

		return null;
	}
	
	private XSSFCellStyle createCellStyle(Workbook workbook, String hexColor) {

		if(hexColor == null) {
			return null;
		}
		
		try {
		
			XSSFCellStyle style = (XSSFCellStyle) workbook.createCellStyle();
			Color backgroundColor = Color.decode(hexColor);
			
			// we need to use rgb-constructor to make it work
			byte[] rgb = new byte[3];			
			rgb[0] = (byte) backgroundColor.getRed();
			rgb[1] = (byte) backgroundColor.getGreen();
			rgb[2] = (byte) backgroundColor.getBlue();
			  
	        // Setting Background color  
			style.setFillForegroundColor(new XSSFColor(rgb, new DefaultIndexedColorMap()));
			style.setFillPattern(FillPatternType.SOLID_FOREGROUND);
			
			return style;
			
		} catch(Exception ex) {
			
			log.error("Could not parse hexColor " + hexColor, ex);
		}
		
		return null;
	}

	private String getExportProgressSessionString(String timestamp) {

		return moduleDescriptor.getModuleID() + "-ExportProgress-" + timestamp;
	}

	private void setExportStartSessionString(String timestamp, int flowInstanceCount, HttpServletRequest req) {

		SessionUtils.removeAttribute(getExportProgressSessionString(timestamp) + "-done", req);
		SessionUtils.setAttribute(getExportProgressSessionString(timestamp) + "-total", flowInstanceCount, req);
	}

	private void setExportProgressSessionString(String timestamp, Flow flow, int versionProgress, int versionTotal, int totalProgress, HttpServletRequest req) {

		SessionUtils.setAttribute(getExportProgressSessionString(timestamp) + "-version", flow.getVersion(), req);
		SessionUtils.setAttribute(getExportProgressSessionString(timestamp) + "-versionProgress", versionProgress, req);
		SessionUtils.setAttribute(getExportProgressSessionString(timestamp) + "-versionTotal", versionTotal, req);
		SessionUtils.setAttribute(getExportProgressSessionString(timestamp) + "-totalProgress", totalProgress, req);
	}

	private void setExportCompleteSessionString(String timestamp, boolean ok, HttpServletRequest req) {

		SessionUtils.setAttribute(getExportProgressSessionString(timestamp) + "-done", ok, req);
		removeExportSessionStrings(timestamp, req);
	}

	private void removeExportSessionStrings(String timestamp, HttpServletRequest req) {

		SessionUtils.removeAttribute(getExportProgressSessionString(timestamp) + "-version", req);
		SessionUtils.removeAttribute(getExportProgressSessionString(timestamp) + "-versionProgress", req);
		SessionUtils.removeAttribute(getExportProgressSessionString(timestamp) + "-versionTotal", req);
		SessionUtils.removeAttribute(getExportProgressSessionString(timestamp) + "-totalProgress", req);
		SessionUtils.removeAttribute(getExportProgressSessionString(timestamp) + "-total", req);
		SessionUtils.removeAttribute(getExportProgressSessionString(timestamp) + "-lastPoll", req);
	}

	@WebPublic(alias = "exportprogress")
	public ForegroundModuleResponse getExportProgress(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Exception {

		String timestamp = uriParser.get(2);

		if (timestamp != null) {

			try {
				log.info("User " + user + " getting export progress for export " + timestamp);

				Boolean done = (Boolean) SessionUtils.getAttribute(getExportProgressSessionString(timestamp) + "-done", req);

				if (done != null) {
					SessionUtils.removeAttribute(getExportProgressSessionString(timestamp) + "-done", req);

				} else {
					SessionUtils.setAttribute(getExportProgressSessionString(timestamp) + "-lastPoll", System.currentTimeMillis(), req);
				}

				JsonObject json = new JsonObject(6);
				json.putField("done", done);
				json.putField("version", SessionUtils.getAttribute(getExportProgressSessionString(timestamp) + "-version", req));
				json.putField("versionProgress", SessionUtils.getAttribute(getExportProgressSessionString(timestamp) + "-versionProgress", req));
				json.putField("versionTotal", SessionUtils.getAttribute(getExportProgressSessionString(timestamp) + "-versionTotal", req));
				json.putField("totalProgress", SessionUtils.getAttribute(getExportProgressSessionString(timestamp) + "-totalProgress", req));
				json.putField("total", SessionUtils.getAttribute(getExportProgressSessionString(timestamp) + "-total", req));

				HTTPUtils.sendReponse(json.toJson(), JsonUtils.getContentType(), res);

			} catch (Exception e) {

				log.error("Error getting export progress for export " + timestamp, e);
			}
		}

		return null;
	}

	private static Cell createCell(Row row, int cellPos, Object value, CellStyle style) {

		Cell cell = row.createCell(cellPos);
		cell.setCellValue(value.toString());
		
		if(style != null) {
			
			cell.setCellStyle(style);
		}
		
		return cell;
	}

	private Document createDocument(HttpServletRequest req, URIParser uriParser) {

		Document doc = XMLUtils.createDomDocument();
		Element documentElement = doc.createElement("Document");
		documentElement.appendChild(RequestUtils.getRequestInfoAsXML(doc, req, uriParser));
		documentElement.appendChild(this.moduleDescriptor.toXML(doc));

		XMLUtils.appendNewElement(doc, documentElement, "fullAlias", getFullAlias());

		doc.appendChild(documentElement);
		return doc;
	}

	private SiteProfile getCurrentSiteProfile(HttpServletRequest req, User user, URIParser uriParser) {

		if (this.siteProfileHandler != null) {

			return siteProfileHandler.getCurrentProfile(user, req, uriParser);
		}

		return null;
	}

	private QueryInstanceDescriptor getQueryInstanceDescriptor(Integer flowInstanceID, QueryDescriptor queryDescriptor) throws SQLException {

		HighLevelQuery<QueryInstanceDescriptor> query = new HighLevelQuery<>();

		query.addParameter(queryInstanceDescriptorFlowInstanceIDParamFactory.getParameter(flowInstanceID));
		query.addParameter(queryInstanceDescriptorQueryDescriptorParamFactory.getParameter(queryDescriptor));

		return queryInstanceDescriptorDAO.get(query);
	}

	@WebPublic(alias = "icon")
	public ForegroundModuleResponse getFlowIcon(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws URINotFoundException, SQLException {

		return flowAdminModule.getFlowIcon(req, res, user, uriParser);
	}

	@Override
	public AccessInterface getAccessInterface() {

		return moduleDescriptor;
	}

	@Override
	public ListOverviewButtonExtension getListOverviewButtonExtension(HttpServletRequest req, User user) {

		return new ListOverviewButtonExtension(buttonName, buttonTitle, "excel-export", listOverviewButtonDataAttributes, buttonExtensionScripts);
	}

	@InstanceManagerDependency(required = true)
	public void setFlowAdminModule(FlowAdminModule flowAdminModule) {

		if (flowAdminModule == null && this.flowAdminModule != null) {

			this.flowAdminModule.removeExtensionViewProvider(this);
		}

		this.flowAdminModule = flowAdminModule;

		if (this.flowAdminModule != null) {

			this.flowAdminModule.addExtensionViewProvider(this);
		}
	}

	@Override
	public int getPriority() {

		return flowAdminExtensionViewPriority;
	}

	@Override
	public String getExtensionViewTitle() {

		return flowAdminExtensionViewTitle;
	}

	@Override
	public ForegroundModuleDescriptor getModuleDescriptor() {

		return moduleDescriptor;
	}

	@Override
	public List<LinkTag> getLinkTags() {

		return null;
	}

	@Override
	public List<ScriptTag> getScriptTags() {

		return null;
	}

	@Override
	public int getModuleID() {

		return moduleDescriptor.getModuleID();
	}

	@Override
	public FlowAdminExtensionShowView getShowView(Flow flow, HttpServletRequest req, User user, URIParser uriParser) throws TransformerException, SQLException {

		if (!AccessUtils.checkAccess(user, this.moduleDescriptor)) {

			return null;
		}

		Document doc = createDocument(req, uriParser);

		XMLUtils.appendNewElement(doc, doc.getDocumentElement(), "ModuleURI", req.getContextPath() + getFullAlias());
		XMLUtils.appendNewElement(doc, doc.getDocumentElement(), "StaticContentURL", staticContentModule.getModuleContentURL(moduleDescriptor));
		
		Element showViewElement = doc.createElement("ShowExportSettings");
		doc.getDocumentElement().appendChild(showViewElement);

		if(coloredTagProvider != null) {
			
			XMLUtils.appendNewElement(doc, showViewElement, "ColoredTagProvider");
		}
		
		boolean enabled = false;

		if (flow != null) {

			FlowFamilyExportSettings settings = getExportSettings(flow);

			if (settings != null) {

				XMLUtils.append(doc, showViewElement, settings);
				enabled = settings.isEnabled();
			}

			showViewElement.appendChild(flow.toXML(doc));

		}

		return new FlowAdminExtensionShowView(viewFragmentTransformer.createViewFragment(doc, true), enabled);
	}

	@WebPublic(toLowerCase = true)
	public ForegroundModuleResponse updateExportSettings(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		Flow flow = flowAdminModule.getRequestedFlow(req, user, uriParser);

		if (flow == null) {

			return flowAdminModule.list(req, res, user, uriParser, new ValidationError("FlowNotFound"));

		} else if (!flowAdminModule.hasFlowAccess(user, flow)) {

			throw new AccessDeniedException("User does not have access to flow type " + flow.getFlowType());
		}

		Document doc = createDocument(req, uriParser);

		Element updateElement = XMLUtils.appendNewElement(doc, doc.getDocumentElement(), "UpdateExportSettings");

		if(coloredTagProvider != null) {
			
			XMLUtils.appendNewElement(doc, updateElement, "ColoredTagProvider");
		}

		FlowFamilyExportSettings settings = getExportSettings(flow);

		if (req.getMethod().equalsIgnoreCase("POST")) {

			if (settings == null) {

				settings = new FlowFamilyExportSettings();
				settings.setFlowFamilyID(flow.getFlowFamily().getFlowFamilyID());
			}

			try {

				settings = EXPORT_SETTINGS_POPULATOR.populate(settings, req);

				exportSettingsDAO.addOrUpdate(settings, null);

				flowAdminModule.redirectToMethod(req, res, "/showflow/" + flow.getFlowID() + "#exportsettings");

			} catch (ValidationException e) {

				updateElement.appendChild(e.toXML(doc));
				updateElement.appendChild(RequestUtils.getRequestParameters(req, doc));
			}
		}

		XMLUtils.append(doc, updateElement, flow);
		XMLUtils.append(doc, updateElement, settings);

		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}

	public FlowFamilyExportSettings getExportSettings(Flow flow) throws SQLException {

		HighLevelQuery<FlowFamilyExportSettings> query = new HighLevelQuery<>();

		query.addParameter(exportSettingsFlowFamilyIDParamFactory.getParameter(flow.getFlowFamily().getFlowFamilyID()));

		return exportSettingsDAO.get(query);
	}

	@WebPublic(toLowerCase = true)
	public ForegroundModuleResponse deleteExportSettings(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		if (!HTTPUtils.isPost(req)) {

			throw new AccessDeniedException("Delete requests using method " + req.getMethod() + " are not allowed.");
		}

		Flow flow = flowAdminModule.getRequestedFlow(req, user, uriParser);

		if (flow == null) {

			return flowAdminModule.list(req, res, user, uriParser, new ValidationError("FlowNotFound"));

		} else if (!flowAdminModule.hasFlowAccess(user, flow)) {

			throw new AccessDeniedException("User does not have access to flow type " + flow.getFlowType());
		}

		HighLevelQuery<FlowFamilyExportSettings> query = new HighLevelQuery<>();

		query.addParameter(exportSettingsFlowFamilyIDParamFactory.getParameter(flow.getFlowFamily().getFlowFamilyID()));

		exportSettingsDAO.delete(query);

		flowAdminModule.redirectToMethod(req, res, "/showflow/" + flow.getFlowID() + "#exportsettings");

		return null;
	}

	@EventListener(channel = FlowFamily.class)
	public void processEvent(CRUDEvent<FlowFamily> event, EventSource eventSource) {

		if (event.getAction() == CRUDAction.DELETE) {

			for (FlowFamily flowFamily : event.getBeans()) {

				log.info("Deleting export settings settings for flowFamilyID: " + flowFamily.getFlowFamilyID());

				try {

					HighLevelQuery<FlowFamilyExportSettings> query = new HighLevelQuery<>();

					query.addParameter(exportSettingsFlowFamilyIDParamFactory.getParameter(flowFamily.getFlowFamilyID()));

					exportSettingsDAO.delete(query);

				} catch (SQLException e) {

					log.error("Error deleting export settings settings for flowFamilyID: " + flowFamily.getFlowFamilyID(), e);
				}
			}
		}
	}

}
