<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:import href="classpath://com/nordicpeak/flowengine/BaseFlowModule.sv.xsl"/>
	
	<xsl:output encoding="ISO-8859-1" method="html" version="4.0"/>
	
	<xsl:include href="FlowVoteModuleTemplates.xsl"/>
	
	<xsl:variable name="java.adminExtensionViewTitle">Frslagshantering / Rstning</xsl:variable>
	<xsl:variable name="java.votingEndedEventDetails">Rstning avslutad, antal rster: </xsl:variable>
	
	<xsl:variable name="java.votedSMS">Vi har tagit emot din rst fr e-frslaget $attribute{description}</xsl:variable>		
	<xsl:variable name="java.voteReceivedSMS">En rst har lagts p ditt e-frslag $attribute{description}</xsl:variable>		
	<xsl:variable name="java.votingCompletedSMS">Rstningsperiod fr e-frslaget $attribute{description} (rende nr. $flowInstance.flowInstanceID) r avslutad och har ftt status $status.name</xsl:variable>		
	
	<xsl:variable name="java.votedEmailSubject">Vi har tagit emot din rst fr e-frslaget $attribute{description}</xsl:variable>
	<xsl:variable name="java.votedEmailMessage">
		
		&lt;p&gt;Hej $contact.firstname,&lt;/p&gt;
		
		&lt;p&gt;Vi har tagit emot din rst fr e-frslaget $attribute{description}.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa e-frslaget:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$votingURL"&gt;$votingURL&lt;/a&gt;
		&lt;/p&gt;
		
	</xsl:variable>
	
	<xsl:variable name="java.voteReceivedEmailSubject">En rst har lagts p ditt e-frslag $attribute{description}</xsl:variable>
	<xsl:variable name="java.voteReceivedEmailMessage">
		
		&lt;p&gt;Hej $contact.firstname,&lt;/p&gt;
		
		&lt;p&gt;Du har ftt en rst p ditt e-frslag $attribute{description}.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa e-frslaget:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$votingURL"&gt;$votingURL&lt;/a&gt;
		&lt;/p&gt;
		&lt;/p&gt;Om du vill stnga av dessa notiser s kan du gra det via knappen "Stng av prenumeration" som visas p frslagets sida nr du r inloggad.&lt;/p&gt;
		
	</xsl:variable>
	
	<xsl:variable name="java.votingCompletedEmailSubject">Rstningsperiod fr e-frslaget $attribute{description} (rende nr. $flowInstance.flowInstanceID) avslutad </xsl:variable>
	<xsl:variable name="java.votingCompletedEmailMessage">
		
		&lt;p&gt;Hej $contact.firstname,&lt;/p&gt;
		
		&lt;p&gt;Rstningsperiod fr e-frslaget $attribute{description} (rende nr. $flowInstance.flowInstanceID) r avslutad och har ftt status $status.name.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa rendet:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$flowInstance.url"&gt;$flowInstance.url&lt;/a&gt;
		&lt;/p&gt;
		
	</xsl:variable>
	
	<xsl:variable name="i18n.ActiveVotings">Aktiva frslag</xsl:variable>
	<xsl:variable name="i18n.ArchivedVotings">Arkiverade frslag</xsl:variable>
	
	
	
	
	
	
	
	
	<xsl:variable name="i18n.validation.unknownFault" select="'Ett oknt valideringsfel har uppsttt.'"/>
	<xsl:variable name="i18n.validation.unknownError" select="'Oknt fel p fltet:'"/>
	<xsl:variable name="i18n.validation.requiredField" select="'Du mste fylla i fltet:'"/>
	<xsl:variable name="i18n.validation.invalidFormat" select="'Felaktigt format p fltet:'"/>
	<xsl:variable name="i18n.validation.tooShort" select="'Fr kort innehll i fltet:'"/>
	<xsl:variable name="i18n.validation.tooLong" select="'Fr lngt innehll i fltet:'"/>
	
	<xsl:variable name="i18n.Validation.FlowFamilyNotFound">Den begrda e-tjnsten hittades inte</xsl:variable>
	<xsl:variable name="i18n.Validation.UnkownStatus.1">Statusen</xsl:variable>
	<xsl:variable name="i18n.Validation.UnkownStatus.2">du angav finns inte i ngon version av e-tjnsten!</xsl:variable>
	<xsl:variable name="i18n.Validation.VotingDisabled">Det gr inte att rsta p frslaget d rstningen redan har avslutats.</xsl:variable>
	<xsl:variable name="i18n.Validation.WrongMunicipalCode">Du kan inte rsta p frslaget eftersom du r folkbokfrd i en annan kommun.</xsl:variable>
	<xsl:variable name="i18n.Validation.DuplicateAlias.1">Det alias du valt, </xsl:variable>
	<xsl:variable name="i18n.Validation.DuplicateAlias.2">r redan upptaget. Vlj ett annat alias.</xsl:variable>
	
	
	<xsl:variable name="i18n.ShowArchived">Visa arkiverade frslag</xsl:variable>
	<xsl:variable name="i18n.Back">Tillbaka</xsl:variable>
	
	<xsl:variable name="i18n.Columns.Title">Rubrik</xsl:variable>
	<xsl:variable name="i18n.Columns.Status">Status</xsl:variable>
	<xsl:variable name="i18n.Columns.VotingEnding">Rstning pgr till</xsl:variable>
	<xsl:variable name="i18n.Columns.VotingEnded">Rstning avslutad</xsl:variable>
	<xsl:variable name="i18n.Columns.Votes">Antal rster</xsl:variable>
	<xsl:variable name="i18n.Columns.Voted">Rstat</xsl:variable>
	<xsl:variable name="i18n.Columns.Voted.True">Du har redan rstat p detta frslag</xsl:variable>
	<xsl:variable name="i18n.Columns.PropositionDate">Frslaget inskickat</xsl:variable>
	<xsl:variable name="i18n.Columns.Description">Beskrivning</xsl:variable>
	
	<xsl:variable name="i18n.VoteForm.title">E-Frslag</xsl:variable>
	<xsl:variable name="i18n.VoteForm.DecisionDescription">Information om beslut</xsl:variable>
	<xsl:variable name="i18n.VoteForm.Rejected">Motivering till avslag</xsl:variable>
	<xsl:variable name="i18n.VoteForm.Files">Bifogade filer</xsl:variable>
	<xsl:variable name="i18n.VoteForm.VotingEnds">Rstning avslutas</xsl:variable>
	<xsl:variable name="i18n.VoteForm.VotingEnded">Rstning avslutad</xsl:variable>
	
	<xsl:variable name="i18n.Voting.Vote">Rsta</xsl:variable>
	<xsl:variable name="i18n.Voting.RemoveVote">Ta bort min rst</xsl:variable>
	<xsl:variable name="i18n.Voting.PauseVoteReceivedPrenumeration">Stng av prenumeration</xsl:variable>
	<xsl:variable name="i18n.Voting.ActivateVoteReceivedPrenumeration">Aktivera prenumeration</xsl:variable>
	<xsl:variable name="i18n.Voting.Voted">Rst lagt</xsl:variable>
	<xsl:variable name="i18n.Voting.VotedOn">du rstade p detta frslag</xsl:variable>
	<xsl:variable name="i18n.Voting.VoteRemoved">Rst borttagen</xsl:variable>
	<xsl:variable name="i18n.Voting.ConfirmVote">Bekrfta rst</xsl:variable>
	<xsl:variable name="i18n.Voting.description.1">Klicka p "Bekrfta rst" fr att lgga din rst p detta frslag.</xsl:variable>
	<xsl:variable name="i18n.Voting.description.2">Kommunen kommer att lagra din rst s lnge rstningen pgr. Efter avslutad rstningsperiod raderas alla individuella rster fr detta frslag, endast det totala antalet rster kommer att sparas.</xsl:variable>
	
	<xsl:variable name="i18n.PauseVotePrenumerationForm.title">Stng av prenumeration</xsl:variable>
	<xsl:variable name="i18n.PauseVotingPrenumeration.description">r du sker p att du vill stnga av prenumerationen/notiser av inskickade rster p det hr frslaget?</xsl:variable>
	<xsl:variable name="i18n.VotingPrenumeration.description">D prenumerationen r aktiv s fr du en notis varje gng ngon lgger en rst p ditt frslag. D prenumerationen r avstngd fr du ingen notis d ngon lgger en rst. Om du stnger av den kan du nr som helst aktivera prenumerationen igen.</xsl:variable>
	<xsl:variable name="i18n.Voting.ConfirmPauseVotePrenumeration">Bekrfta avslut av prenumeration</xsl:variable>
	<xsl:variable name="i18n.ActivateVotePrenumerationForm.title">Aktivera prenumeration</xsl:variable>
	<xsl:variable name="i18n.ActivateVotingPrenumeration.description">r du sker p att du vill aktivera prenumerationen/notiser av inskickade rster p det hr frslaget?</xsl:variable>
	<xsl:variable name="i18n.Voting.ConfirmActivateVotePrenumeration">Bekrfta aktivering av prenumeration</xsl:variable>
	
	<xsl:variable name="i18n.UpdateSettings.Title">Rstningsinstllningar fr e-tjnsten</xsl:variable>
	<xsl:variable name="i18n.UpdateSettings.description1">I formulret nedan fyller du i instllningarna fr frslagshanteringen. Tnk p att skapa rtt statusar i frvg s de gr att vlja via formulret nedan.</xsl:variable>
	<xsl:variable name="i18n.UpdateSettings.description2">Frslagens rubrik hmtas frn renden via attributet "description".</xsl:variable>
	<xsl:variable name="i18n.UpdateSettings.description3">Frslagens beskrivningstext hmtas frn renden via attributet "longdescription".</xsl:variable>
	<xsl:variable name="i18n.UpdateSettings.description4">Om en eller flera filuppladdningsfrgor finns i e-tjnsten s kommer alla bifogade filer i ett frslag att finnas tillgngliga p den publika sidan (kan stngas av nedan).</xsl:variable>
	<xsl:variable name="i18n.UpdateSettings">ndra instllningar</xsl:variable>
	<xsl:variable name="i18n.DeleteSettings">Ta bort instllningar</xsl:variable>
	<xsl:variable name="i18n.DeleteSettings.Confirm">r du sker p att du vill ta bort rstningsinstllningarna fr den hr e-tjnsten?</xsl:variable>
	<xsl:variable name="i18n.SaveChanges">Spara ndringar</xsl:variable>
	<xsl:variable name="i18n.NoSettings">Frslagshantering avstngd</xsl:variable>
	<xsl:variable name="i18n.VotingEnabled">Frslagshantering aktiverad med rstning</xsl:variable>
	<xsl:variable name="i18n.PropositionEnabledNoVoting">Frslagshantering aktiverad utan rstning</xsl:variable>
	<xsl:variable name="i18n.PublishedStatuses.SearchPlaceholder">Lgg till publicerad-status</xsl:variable>
	<xsl:variable name="i18n.DeletePublishedStatus">Visa inte frslag med status</xsl:variable>
	<xsl:variable name="i18n.DeletePublishedStatus.Confirm">r du sker p att du inte vill visa frslag med status</xsl:variable>
	<xsl:variable name="i18n.ArchivedStatuses.SearchPlaceholder">Lgg till arkiverad-status</xsl:variable>
	<xsl:variable name="i18n.DeleteArchivedStatus">Visa inte frslag med status</xsl:variable>
	<xsl:variable name="i18n.DeleteArchivedStatus.Confirm">r du sker p att du inte vill visa frslag med status</xsl:variable>
	
	<xsl:variable name="i18n.Settings.title">Titel</xsl:variable>
	<xsl:variable name="i18n.Settings.description">Beskrivning</xsl:variable>
	<xsl:variable name="i18n.Settings.alias">Alias</xsl:variable>
	<xsl:variable name="i18n.Settings.municipalCode">Kommunkod (fyra siffror)</xsl:variable>
	<xsl:variable name="i18n.Settings.siteProfileID">Profil</xsl:variable>
	<xsl:variable name="i18n.Settings.publicpage">Publika sidan:</xsl:variable>
	<xsl:variable name="i18n.Settings.rssFeedActive">RSS-flde aktiverat:</xsl:variable>
	<xsl:variable name="i18n.Settings.siteProfileID.choose">Vlj profil...</xsl:variable>
	<xsl:variable name="i18n.VotingActivated">Aktivera rstning</xsl:variable>
	<xsl:variable name="i18n.Settings.votingDays">Rstningsperiod (i dagar)</xsl:variable>
	<xsl:variable name="i18n.Settings.requiredVotes">Minsta antal rster fr att frslaget ska g vidare</xsl:variable>
	<xsl:variable name="i18n.Settings.votingStatus">Status fr frslag under pgende omrstning</xsl:variable>
	<xsl:variable name="i18n.Settings.votingStatusPublishStatus">Status fr frslag under pgende omrstning/publicerade frslag</xsl:variable>
	<xsl:variable name="i18n.Settings.publishStatus">Status fr publicerade frslag</xsl:variable>
	<xsl:variable name="i18n.Settings.votingStatusInfo">Status fr inskickat rende fr ej vljas hr p grund av att ett rende alltid mste granskas och genomg ett statusbyte innan det kan publiceras.</xsl:variable>
	<xsl:variable name="i18n.Settings.votePassedStatus">Status fr frslag som gtt vidare</xsl:variable>
	<xsl:variable name="i18n.Settings.voteFailedStatus">Status fr frslag som ej gtt vidare</xsl:variable>
	<xsl:variable name="i18n.Settings.archivedStatuses">Statusar fr frslag som r synliga under arkiverat</xsl:variable>
	<xsl:variable name="i18n.Settings.extraInfoName1">Kolumnnamn p frsta raden</xsl:variable>
	<xsl:variable name="i18n.Settings.extraInfoAttribute1">Attributnamn p frsta raden</xsl:variable>
	<xsl:variable name="i18n.Settings.extraInfoName2">Kolumnnamn p andra raden</xsl:variable>
	<xsl:variable name="i18n.Settings.extraInfoAttribute2">Attributnamn p andra raden</xsl:variable>
	<xsl:variable name="i18n.Settings.extraInfoName3">Kolumnnamn p tredje raden</xsl:variable>
	<xsl:variable name="i18n.Settings.extraInfoAttribute3">Attributnamn p tredje raden</xsl:variable>
	<xsl:variable name="i18n.ShowStatusInList">Visa de aktiva frslagens status i frslagslistan (arkiverade frslags status visas alltid)</xsl:variable>
	
	<xsl:variable name="i18n.BaseInfoLegend">Grundinformation</xsl:variable>
	<xsl:variable name="i18n.HideAttachedFiles">Ta ej med bifogade filer frn rende till frslag</xsl:variable>
	<xsl:variable name="i18n.PageSize">Antal frslag som ska visas per sida</xsl:variable>
	<xsl:variable name="i18n.StatusSettingsLegend">Statusinstllningar</xsl:variable>
	<xsl:variable name="i18n.AdvancedSettingsLegend">Avancerade instllningar</xsl:variable>
	<xsl:variable name="i18n.ActivateAdditionalAttributes">Aktivera fler kolumner/attribut</xsl:variable>
	<xsl:variable name="i18n.AdditionalAttributesInfo">Om fler kolumner aktiveras kan mer information frn varje frslag visas genom att ange en rubrik och en attributstrng. Attributstrngen kan best av bde fast text och attribut-taggar, $attribute{}. Upp till tre extra kolumner kan aktiveras. Endast de ifyllda raderna nedan kommer att visas i frslagslistan och p enskilda frslags detaljvy. Det gr ven vlja att extrainformationen inte ska visas i frslagslistan (listan har begrnsat utrymme) utan bara visas i frslagens detaljvy.</xsl:variable>
	<xsl:variable name="i18n.ExtraInfoName1">Rubrik</xsl:variable>
	<xsl:variable name="i18n.ExtraInfoAttribute1">Attributstrng</xsl:variable>
	<xsl:variable name="i18n.ExtraInfoHideInList1">Dlj i lista</xsl:variable>
	<xsl:variable name="i18n.ExtraInfoName2">Rubrik</xsl:variable>
	<xsl:variable name="i18n.ExtraInfoAttribute2">Attributstrng</xsl:variable>
	<xsl:variable name="i18n.ExtraInfoName3">Rubrik</xsl:variable>
	<xsl:variable name="i18n.ExtraInfoAttribute3">Attributstrng</xsl:variable>
	<xsl:variable name="i18n.ActivateRSSFeed">Aktivera RSS-flde fr aktiva frslag</xsl:variable>
	<xsl:variable name="i18n.ActivateRSSFeed.Info">RSS-fldet innehller alla aktiva frslag fr just denna e-tjnst.</xsl:variable>
	
	<xsl:variable name="i18n.DataTable.decimal">,</xsl:variable>
	<xsl:variable name="i18n.DataTable.emptyTable">Det finns inga frslag att visa</xsl:variable>
	<xsl:variable name="i18n.DataTable.info">Visar _START_ till _END_ av _TOTAL_ frslag</xsl:variable>
	<xsl:variable name="i18n.DataTable.infoEmpty">Visar 0 till 0 av 0 frslag</xsl:variable>
	<xsl:variable name="i18n.DataTable.infoFiltered">(filtrerat frn totalt _MAX_ frslag)</xsl:variable>
	<xsl:variable name="i18n.DataTable.infoPostFix"/>
	<xsl:variable name="i18n.DataTable.thousands"/>
	<xsl:variable name="i18n.DataTable.lengthMenu">Visa _MENU_ frslag</xsl:variable>
	<xsl:variable name="i18n.DataTable.loadingRecords">Hmtar frslag...</xsl:variable>
	<xsl:variable name="i18n.DataTable.processing">Bearbetar...</xsl:variable>
	<xsl:variable name="i18n.DataTable.search">Sk:</xsl:variable>
	<xsl:variable name="i18n.DataTable.zeroRecords">Inga matchande frslag hittades</xsl:variable>
	<xsl:variable name="i18n.DataTable.paginate.first">Frsta</xsl:variable>
	<xsl:variable name="i18n.DataTable.paginate.last">Sista</xsl:variable>
	<xsl:variable name="i18n.DataTable.paginate.next">Nsta</xsl:variable>
	<xsl:variable name="i18n.DataTable.paginate.previous">Fregende</xsl:variable>
	<xsl:variable name="i18n.DataTable.aria.sortAscending">: aktivera fr att sortera kolumnen stigande</xsl:variable>
	<xsl:variable name="i18n.DataTable.aria.sortDescending">: aktivera fr att sortera kolumnen fallande</xsl:variable>
		
	<xsl:variable name="i18n.Share.Facebook">Dela p Facebook</xsl:variable>
	<xsl:variable name="i18n.Share.Twitter">Dela p Twitter</xsl:variable>
	<xsl:variable name="i18n.RssFlow">Flj RSS-fldet av aktiva frslag</xsl:variable>
	<xsl:variable name="i18n.VoteForm.LongDescription">Beskrivning</xsl:variable>
</xsl:stylesheet>
