package com.nordicpeak.flowengine.tags.httpsharing;

import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.tags.TagSharingTarget;

@XMLElement(name="TagSharingTarget")
public class HTTPTagSharingTarget extends GeneratedElementable implements TagSharingTarget {

	@XMLElement
	private String name;

	private String url;
	private String username;
	private String password;

	public HTTPTagSharingTarget(String url, String username, String password) {
		super();

		this.url = url;
		this.username = username;
		this.password = password;
		
		this.name = StringUtils.substringBefore(StringUtils.substringAfter(url, "//"), "/");
	}

	public String getUrl() {

		return url;
	}

	public void setUrl(String url) {

		this.url = url;
	}

	public String getUsername() {

		return username;
	}

	public void setUsername(String username) {

		this.username = username;
	}

	public String getPassword() {

		return password;
	}

	public void setPassword(String password) {

		this.password = password;
	}

	@Override
	public String toString() {

		return name;
	}

	public String getName() {

		return name;
	}

	public void setName(String cachedName) {

		this.name = cachedName;
	}
}
