<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
	
		<xsl:variable name="queryInstance" select="IconMapQueryInstance" />
	
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="$queryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
	
			<a name="query{$queryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
				
			<h2>
				<xsl:value-of select="$queryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
		
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>				
			</xsl:if>
		
			<div class="marginbottom">
				<img src="query://{$queryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}/map/{$queryInstance/queryInstanceID}" width="100%" />
			</div>
		
			<div class="bigmarginbottom">
				
				<xsl:if test="$queryInstance/propertyUnitDesignation">
					<div class="marginbottom">
						<strong><xsl:value-of select="$i18n.PropertyUnitDesignation" /><xsl:text>:&#160;</xsl:text></strong>
						<xsl:value-of select="$queryInstance/propertyUnitDesignation" />
					</div>
				</xsl:if>
				
				<xsl:if test="$queryInstance/IconMapQuery/useDetailedIconInfo = 'true' and $queryInstance/geometries/Geometry">
				
					<table class="geometry-table">
						<thead>
							<tr>
								<th width="20px">#</th>
								<th width="100px"><xsl:value-of select="$i18n.MapIcon" /></th>
								<th width="200px"><xsl:value-of select="$i18n.Coordinates" /></th>
								<xsl:if test="$queryInstance/IconMapQuery/showIconPUDInfo = 'true'">
									<th width="300px"><xsl:value-of select="$i18n.PropertyUnitDesignation" /></th>
								</xsl:if>
								<th width="300px"><xsl:value-of select="$i18n.Comment" /></th>
								<th width="16px" />
							</tr>
						</thead>
						<tbody>
							<xsl:apply-templates select="$queryInstance/geometries/Geometry" mode="table" />
						</tbody>
					</table>
					
					<div class="margintop">
						<xsl:value-of select="$i18n.CoordinatesDescription" />
					</div>
					
				</xsl:if>
				
				<xsl:if test="$queryInstance/IconMapQuery/useSelectableGeometries = 'true' and $queryInstance/selectedGeometries/SelectedRemoteGeometry">
					
					<table class="geometry-table">
						<thead>
							<tr>
								<th width="20px">#</th>
								<th width="300px"><xsl:value-of select="$i18n.Name" /></th>
								<th width="300px"><xsl:value-of select="$i18n.Description" /></th>
								<th width="16px" />
							</tr>
						</thead>
						<tbody>
							<xsl:apply-templates select="$queryInstance/selectedGeometries/SelectedRemoteGeometry" mode="table" />
						</tbody>					
					</table>
					
				</xsl:if>
				
			</div>
		
		</div>
	
	</xsl:template>
	
	<xsl:template match="Geometry" mode="table">
	
		<tr>
			<td><xsl:value-of select="index" /></td>
			<td><xsl:value-of select="MapIcon/name" /></td>
			<td><xsl:value-of select="coordinates" /></td>
			<xsl:if test="../../IconMapQuery/showIconPUDInfo = 'true'">
				<td>
					<xsl:choose>
						<xsl:when test="propertyUnitDesignation"><xsl:value-of select="propertyUnitDesignation" /></xsl:when>
						<xsl:otherwise>-</xsl:otherwise>
					</xsl:choose>
				</td>
			</xsl:if>
			<td><xsl:value-of select="comment" /></td>
		</tr>
	
	</xsl:template>
	
	<xsl:template match="SelectedRemoteGeometry" mode="table">
	
		<tr>
			<td><xsl:value-of select="index" /></td>
			<td><xsl:value-of select="name" /></td>
			<td><xsl:value-of select="description" /></td>
		</tr>
	
	</xsl:template>
	
</xsl:stylesheet>