package com.nordicpeak.flowengine.queries.iconmapquery.beans;

import java.io.Serializable;
import java.sql.Blob;
import java.sql.SQLException;

import javax.sql.rowset.serial.SerialBlob;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "icon_map_query_instance_prints")
@XMLElement
public class IconMapQueryInstancePrint extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -8980174708468159022L;

	@Key
	@DAOManaged(autoGenerated = true)
	@XMLElement
	private Integer queryPrintID;

	@DAOManaged(columnName = "queryInstanceID")
	@ManyToOne
	private IconMapQueryInstance iconMapQueryInstance;

	@DAOManaged
	@XMLElement
	private String layout;

	@DAOManaged
	@XMLElement
	private String format;

	@DAOManaged
	@XMLElement
	private Integer scale;

	@DAOManaged
	@XMLElement
	private Integer resolution;

	@DAOManaged
	@XMLElement
	private boolean useInPreview;

	@DAOManaged
	private Blob mapImage;

	public Integer getQueryPrintID() {

		return queryPrintID;
	}

	public void setQueryPrintID(Integer queryPrintID) {

		this.queryPrintID = queryPrintID;
	}

	public String getLayout() {

		return layout;
	}

	public void setLayout(String layout) {

		this.layout = layout;
	}

	public String getFormat() {

		return format;
	}

	public void setFormat(String format) {

		this.format = format;
	}

	public Integer getScale() {

		return scale;
	}

	public void setScale(Integer scale) {

		this.scale = scale;
	}

	public Integer getResolution() {

		return resolution;
	}

	public void setResolution(Integer resolution) {

		this.resolution = resolution;
	}

	public boolean isUseInPreview() {

		return useInPreview;
	}

	public void setUseInPreview(boolean useInPreview) {

		this.useInPreview = useInPreview;
	}

	public Blob getMapImage() {

		return mapImage;
	}

	public void setMapImage(Blob mapImage) {

		this.mapImage = mapImage;
	}

	protected final Object writeReplace() {

		try {

			if (mapImage != null) {
				mapImage = new SerialBlob(mapImage);
			}

		} catch (SQLException e) {

		}

		return this;

	}

}
