package com.nordicpeak.flowengine.queries.iconmapquery.validationerrors;

import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.queries.iconmapquery.beans.SelectedRemoteGeometry;

@XMLElement(name = "validationError")
public class SelectedRemoteGeometryValidationError extends ValidationError {

	private static final long serialVersionUID = -6856414856118008740L;

	@XMLElement
	private Integer minSelectableGeometries;

	@XMLElement
	private Integer maxSelectableGeometries;

	@XMLElement
	private SelectedRemoteGeometry selectedRemoteGeometry;

	public SelectedRemoteGeometryValidationError(String messageKey, Integer minSelectableGeometries, Integer maxSelectableGeometries) {

		super(messageKey);
		this.minSelectableGeometries = minSelectableGeometries;
		this.maxSelectableGeometries = maxSelectableGeometries;
	}

	public SelectedRemoteGeometryValidationError(SelectedRemoteGeometry selectedRemoteGeometry, String messageKey, String displayName) {

		super(messageKey, displayName);
		this.selectedRemoteGeometry = selectedRemoteGeometry;
	}

}
