<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>

	<xsl:template match="Document">
		
		<xsl:apply-templates select="ShowQueryValues"/>
		<xsl:apply-templates select="ShowQueryForm"/>
		
	</xsl:template>
	
	<xsl:template match="ShowQueryValues">
		
		<div>
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="InternalContactDetailQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<article>
				
				<div class="heading-wrapper">
					<h2>
						<xsl:attribute name="class">
							<xsl:if test="InternalContactDetailQueryInstance/QueryInstanceDescriptor/queryState = 'VISIBLE_REQUIRED'">
								<xsl:text>required</xsl:text>
							</xsl:if>
						</xsl:attribute>
						<xsl:value-of select="InternalContactDetailQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
					</h2>
					
					<xsl:call-template name="createUpdateButton">
						<xsl:with-param name="queryID" select="InternalContactDetailQueryInstance/InternalContactDetailQuery/queryID" />
					</xsl:call-template>
					
				</div>
				
				<xsl:if test="InternalContactDetailQueryInstance/InternalContactDetailQuery/description">
					<span class="italic">
						<xsl:value-of select="InternalContactDetailQueryInstance/InternalContactDetailQuery/description" disable-output-escaping="yes" />
					</span>
				</xsl:if>
				
				<div class="clearboth"/>
				
				<xsl:variable name="query" select="InternalContactDetailQueryInstance/InternalContactDetailQuery" />
				
				<fieldset>
				
					<xsl:if test="$query/showName = 'true'">
							
						<div class="split">
							<strong class="block"><xsl:value-of select="$i18n.FirstnameAndLastname" /></strong>
							<xsl:value-of select="InternalContactDetailQueryInstance/firstname" />
							<xsl:text>&#160;</xsl:text>
							<xsl:value-of select="InternalContactDetailQueryInstance/lastname" />
						</div>
							
					</xsl:if>
					
					<xsl:if test="$query/showUsername = 'true'">
					
						<div class="split">
							<xsl:if test="$query/showName = 'true'">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
								
							<strong class="block"><xsl:value-of select="$i18n.Username" /></strong>
							<xsl:value-of select="InternalContactDetailQueryInstance/username" />
						</div>
					
					</xsl:if>
					
					<xsl:if test="$query/showEmail = 'true'">
					
						<div class="split">
							<xsl:if test="($query/showName = 'true' or $query/showUsername = 'true') and not($query/showName = 'true' and $query/showUsername = 'true')">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
								
							<strong class="block"><xsl:value-of select="$i18n.Email" /></strong>
							<a href="mailto:{InternalContactDetailQueryInstance/email}" ><xsl:value-of select="InternalContactDetailQueryInstance/email" /></a>
						</div>
					
					</xsl:if>
					
					<xsl:for-each select="$query/SelectedUserAttributes/SelectedUserAttribute">
						
						<div class="split">
							<xsl:if test="position() mod 2 = 0">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
								
							<strong class="block"><xsl:value-of select="displayName" /></strong>
							<xsl:value-of select="../../../UserAttributeValues/UserAttributeValue[Name = current()/name]/Value" />
						</div>
					
					</xsl:for-each>
					
				</fieldset>
				
				<xsl:if test="$query/showManagerInfo = 'true'">
					
					<h3><xsl:value-of select="$i18n.ManagerInfo" /></h3>
					
					<fieldset class="bigpaddingtop">
						
						<xsl:if test="$query/showManagerName = 'true'">
							
							<div class="split">
								<strong class="block"><xsl:value-of select="$i18n.FirstnameAndLastname" /></strong>
								<xsl:value-of select="InternalContactDetailQueryInstance/managerFirstname" />
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="InternalContactDetailQueryInstance/managerLastname" />
							</div>
							
						</xsl:if>
						
						<xsl:if test="$query/showManagerUsername = 'true'">
							
							<div class="split">
								<xsl:if test="$query/showManagerName = 'true'">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
								
								<strong class="block"><xsl:value-of select="$i18n.Username" /></strong>
								<xsl:value-of select="InternalContactDetailQueryInstance/managerUsername" />
							</div>
							
						</xsl:if>
						
						<xsl:if test="$query/showManagerEmail = 'true'">
							
							<div class="split">
								<xsl:if test="($query/showManagerName = 'true' or $query/showManagerUsername = 'true') and not($query/showManagerName = 'true' and $query/showManagerUsername = 'true')">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
								
								<strong class="block"><xsl:value-of select="$i18n.Email" /></strong>
								<a href="mailto:{InternalContactDetailQueryInstance/managerEmail}" ><xsl:value-of select="InternalContactDetailQueryInstance/managerEmail" /></a>
							</div>
							
						</xsl:if>
						
						<xsl:for-each select="$query/SelectedManagerAttributes/SelectedManagerAttribute">
							
							<div class="split">
								<xsl:if test="position() mod 2 = 0">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
								
								<strong class="block"><xsl:value-of select="displayName" /></strong>
								<xsl:value-of select="../../../ManagerAttributeValues/ManagerAttributeValue[Name = current()/name]/Value" />
							</div>
							
						</xsl:for-each>
					
					</fieldset>
					
				</xsl:if>
				
			</article>
			
		</div>
		
	</xsl:template>
	
	<xsl:template name="printValue">
		
		<xsl:param name="value" />
		
		<xsl:choose>
			<xsl:when test="$value">
				<xsl:value-of select="$value"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>-</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
	<xsl:template match="ShowQueryForm">
	
		<xsl:variable name="shortQueryID" select="concat('q', InternalContactDetailQueryInstance/InternalContactDetailQuery/queryID)" />
	
		<xsl:variable name="queryID" select="concat('query_', InternalContactDetailQueryInstance/InternalContactDetailQuery/queryID)" />
	
		<div id="{$queryID}">
			
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="EnableAjaxPosting"> enableAjaxPosting</xsl:if>
				<xsl:if test="InternalContactDetailQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="{$queryID}" />
		
			<xsl:if test="ValidationErrors/validationError">
				<div id="{$queryID}-validationerrors" class="validationerrors">
				
					<xsl:if test="ValidationErrors/validationError">
						<div class="info-box error">
							<xsl:apply-templates select="ValidationErrors/validationError"/>
							<div class="marker"></div>
						</div>
					</xsl:if>
				</div>
			</xsl:if>
	
			<article>
			
				<xsl:if test="ValidationErrors/validationError">
					<xsl:attribute name="class">error</xsl:attribute>
				</xsl:if>
			
				<div class="heading-wrapper">
					
					<h2>
						<xsl:attribute name="class">
							<xsl:if test="InternalContactDetailQueryInstance/QueryInstanceDescriptor/queryState = 'VISIBLE_REQUIRED'">
								<xsl:text>required</xsl:text>
							</xsl:if>
						</xsl:attribute>
						<xsl:value-of select="InternalContactDetailQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
					</h2>
					
					<xsl:if test="InternalContactDetailQueryInstance/InternalContactDetailQuery/helpText">		
						<xsl:apply-templates select="InternalContactDetailQueryInstance/InternalContactDetailQuery/helpText" />
					</xsl:if>
				
				</div>
				
				<xsl:if test="InternalContactDetailQueryInstance/InternalContactDetailQuery/description">
					<span class="italic">
						<xsl:if test="/Document/useCKEditorForDescription = 'true'"><xsl:attribute name="class">italic html-description</xsl:attribute></xsl:if>
						<xsl:value-of select="InternalContactDetailQueryInstance/InternalContactDetailQuery/description" disable-output-escaping="yes" />
					</span>
				</xsl:if>
				
				<xsl:if test="not(ValidationErrors/validationError[messageKey = 'UserNotLoggedIn' or messageKey = 'UnableToGetUserDetails']) and InternalContactDetailQueryInstance/Populated = 'true'">
				
					<xsl:variable name="query" select="InternalContactDetailQueryInstance/InternalContactDetailQuery" />
					
					<fieldset>
					
						<xsl:if test="$query/showName = 'true'">
						
							<div class="split">
								<strong class="block"><xsl:value-of select="$i18n.FirstnameAndLastname" /></strong>
								<xsl:value-of select="InternalContactDetailQueryInstance/firstname" />
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="InternalContactDetailQueryInstance/lastname" />
							</div>
							
						</xsl:if>
						
						<xsl:if test="$query/showUsername = 'true'">
						
							<div class="split">
								<xsl:if test="$query/showName = 'true'">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
							
								<strong class="block"><xsl:value-of select="$i18n.Username" /></strong>
								<xsl:value-of select="InternalContactDetailQueryInstance/username" />
							</div>
						
						</xsl:if>
						
						<xsl:if test="$query/showEmail = 'true'">
						
							<div class="split">
								<xsl:if test="($query/showName = 'true' or $query/showUsername = 'true') and not($query/showName = 'true' and $query/showUsername = 'true')">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
								
								<strong class="block"><xsl:value-of select="$i18n.Email" /></strong>
								<xsl:value-of select="InternalContactDetailQueryInstance/email" />
							</div>
						
						</xsl:if>
						
						<xsl:for-each select="$query/SelectedUserAttributes/SelectedUserAttribute">
							
							<div class="split">
								<xsl:if test="position() mod 2 = 0">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
								
								<strong class="block"><xsl:value-of select="displayName" /></strong>
								<xsl:value-of select="../../../UserAttributeValues/UserAttributeValue[Name = current()/name]/Value" />
							</div>
						
						</xsl:for-each>
					
					</fieldset>
					
					<xsl:if test="$query/showManagerInfo = 'true' and not(ValidationErrors/validationError[messageKey = 'UnableToGetManagerDetails'])">
						
						<h3><xsl:value-of select="$i18n.ManagerInfo" /></h3>
						
						<fieldset class="bigpaddingtop">
							
							<xsl:if test="$query/showManagerName = 'true'">
								
								<div class="split">
									<strong class="block"><xsl:value-of select="$i18n.FirstnameAndLastname" /></strong>
									<xsl:value-of select="InternalContactDetailQueryInstance/managerFirstname" />
									<xsl:text>&#160;</xsl:text>
									<xsl:value-of select="InternalContactDetailQueryInstance/managerLastname" />
								</div>
								
							</xsl:if>
							
							<xsl:if test="$query/showManagerUsername = 'true'">
								
								<div class="split">
									<xsl:if test="$query/showManagerName = 'true'">
										<xsl:attribute name="class">split odd</xsl:attribute>
									</xsl:if>
									
									<strong class="block"><xsl:value-of select="$i18n.Username" /></strong>
									<xsl:value-of select="InternalContactDetailQueryInstance/managerUsername" />
								</div>
								
							</xsl:if>
							
							<xsl:if test="$query/showManagerEmail = 'true'">
								
								<div class="split">
									<xsl:if test="($query/showManagerName = 'true' or $query/showManagerUsername = 'true') and not($query/showManagerName = 'true' and $query/showManagerUsername = 'true')">
										<xsl:attribute name="class">split odd</xsl:attribute>
									</xsl:if>
									
									<strong class="block"><xsl:value-of select="$i18n.Email" /></strong>
									<xsl:value-of select="InternalContactDetailQueryInstance/managerEmail" />
								</div>
								
							</xsl:if>
							
							<xsl:for-each select="$query/SelectedManagerAttributes/SelectedManagerAttribute">
								
								<div class="split">
									<xsl:if test="position() mod 2 = 0">
										<xsl:attribute name="class">split odd</xsl:attribute>
									</xsl:if>
									
									<strong class="block"><xsl:value-of select="displayName" /></strong>
									<xsl:value-of select="../../../ManagerAttributeValues/ManagerAttributeValue[Name = current()/name]/Value" />
								</div>
								
							</xsl:for-each>
						
						</fieldset>
						
					</xsl:if>
					
				</xsl:if>
				
			</article>
		
		</div>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'ModuleConfigurationError']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.ModuleConfigurationError"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'UserNotLoggedIn']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.UserNotLoggedIn"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'UnableToGetUserDetails']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.UnableToGetUserDetails"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'UnableToGetManagerDetails']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.Validation.UnableToGetManagerDetails"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'ManagerDoesNotHaveRequiredFieldsForSigning']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.Validation.ManagerDoesNotHaveRequiredFieldsForSigning"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.UnknownValidationError"/>
			</strong>
		</span>
		
	</xsl:template>
		
</xsl:stylesheet>