package com.nordicpeak.flowengine.queries.internaluserqueries;

import se.unlogic.standardutils.string.Stringyfier;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement(name = "AttributeDescriptor")
public class InternalUserQueriesAttributeDescriptor extends GeneratedElementable {

	@XMLElement
	private final String name;
	
	@XMLElement
	private final String displayName;
	
	@XMLElement
	private final Stringyfier<String> stringFormatter;
	
	public InternalUserQueriesAttributeDescriptor(String name, String displayName, Stringyfier<String> stringFormatter) {
		
		if (name == null) {
			
			throw new NullPointerException("name cannot be null");
		}
		
		this.name = name;
		this.stringFormatter = stringFormatter;
		
		if (displayName == null) {
			
			this.displayName = name;
			
		} else {
			
			this.displayName = displayName;
		}
	}
	
	public String getDisplayName() {
		
		return displayName;
	}
	
	public String getName() {
		
		return name;
	}
	
	public Stringyfier<String> getStringFormatter() {
		return stringFormatter;
	}
	
	@Override
	public String toString() {
		
		return name + " (display name: " + displayName + ")";
	}
}
