package com.nordicpeak.lmsearch.beans;

import se.unlogic.standardutils.numbers.NumberUtils;

public class Address implements Comparable<Address> {

	private String streetAddress;

	private String street;

	private String streetNumber;

	private String postalAddress;

	private double x;

	private double y;

	private String objectIdentity;

	private String referenceObjectIdentity;

	public String getStreetAddress() {

		return streetAddress;
	}

	public void setStreetAddress(String streetAddress) {

		this.streetAddress = streetAddress;
	}

	public String getStreet() {

		return street;
	}

	public void setStreet(String street) {

		this.street = street;
	}

	public String getStreetNumber() {

		return streetNumber;
	}

	public void setStreetNumber(String streetNumber) {

		this.streetNumber = streetNumber;
	}
	
	public String getPostalAddress() {
	
		return postalAddress;
	}
	
	public void setPostalAddress(String postalAddress) {
	
		this.postalAddress = postalAddress;
	}

	public double getX() {

		return x;
	}

	public void setX(double x) {

		this.x = x;
	}

	public double getY() {

		return y;
	}

	public void setY(double y) {

		this.y = y;
	}

	public String getObjectIdentity() {

		return objectIdentity;
	}

	public void setObjectIdentity(String objectIdentity) {

		this.objectIdentity = objectIdentity;
	}

	public String getReferenceObjectIdentity() {

		return referenceObjectIdentity;
	}

	public void setReferenceObjectIdentity(String referenceObjectIdentity) {

		this.referenceObjectIdentity = referenceObjectIdentity;
	}

	@Override
	public int compareTo(Address o) {

		int compare = street.compareTo(o.getStreet());
		
		if(compare != 0) {
			return compare;
		}
		
		Integer streetNum = NumberUtils.toInt(streetNumber);
		Integer compStreetNum = NumberUtils.toInt(o.getStreetNumber());
		
		if(streetNum != null && compStreetNum != null) {

			return streetNum.compareTo(compStreetNum);
		}
		
		return compare;
		
	}

}
