package com.nordicpeak.flowengine.queries.listsearchqueryprovider.beans;

import java.io.Serializable;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.interfaces.ImmutableAlternative;

@Table(name = "list_search_query_instance_alternatives")
@XMLElement(name = "Alternative")
public class ListSearchAlternative extends GeneratedElementable implements ImmutableAlternative, Serializable {

	private static final long serialVersionUID = -1929589238173277553L;

	@DAOManaged(columnName = "queryInstanceID")
	@Key
	@ManyToOne
	private ListSearchQueryInstance queryInstance;

	@DAOManaged
	@Key
	@XMLElement
	private Integer alternativeID;

	@DAOManaged
	@XMLElement
	private String name;

	@DAOManaged
	@XMLElement
	private String alternativeXMLValue;
	
	@DAOManaged
	@XMLElement
	private String alternativeAttributeValue;	
	
	public ListSearchAlternative() {}
	
	public ListSearchAlternative(Integer alternativeID, String name, String alternativeXMLValue, String alternativeAttributeValue) {
		super();
		this.alternativeID = alternativeID;
		this.name = name;
		this.alternativeXMLValue = alternativeXMLValue;
		this.alternativeAttributeValue = alternativeAttributeValue;
	}

	@Override
	public boolean equals(Object obj) {
		
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		ListSearchAlternative other = (ListSearchAlternative) obj;
		if (alternativeID == null) {
			if (other.alternativeID != null) {
				return false;
			}
		} else if (!alternativeID.equals(other.alternativeID)) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		
		return name + " (alternativeID: " + alternativeID + ")";
	}
	
	@Override
	public int hashCode() {
		
		final int prime = 31;
		int result = 1;
		result = prime * result + ((alternativeID == null) ? 0 : alternativeID.hashCode());
		return result;
	}
	
	public ListSearchQueryInstance getQueryInstance() {
		
		return queryInstance;
	}

	public void setQueryInstance(ListSearchQueryInstance queryInstance) {
		
		this.queryInstance = queryInstance;
	}
	
	public static long getSerialversionuid() {
	
		return serialVersionUID;
	}
	
	public void setAlternativeID(Integer alternativeID) {
	
		this.alternativeID = alternativeID;
	}

	@Override
	public Integer getAlternativeID() {

		return alternativeID;
	}

	@Override
	public String getName() {

		return name;
	}

	public void setName(String name) {
		
		this.name = name;
	}
	
	@Override
	public String getExportXMLValue() {

		return alternativeXMLValue;
	}

	@Override
	public String getAttributeValue() {
		
		return alternativeAttributeValue;
	}
}
