package com.nordicpeak.flowengine.evaluators.loggedin;

import java.util.ArrayList;
import java.util.List;

import com.nordicpeak.flowengine.evaluators.basequerystateevaluator.BaseQueryStateEvaluator;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

@Table(name = "logged_in_query_state_evaluators")
@XMLElement
public class LoggedInQueryStateEvaluator extends BaseQueryStateEvaluator{

	private static final long serialVersionUID = 2672394798472284735L;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean inverted;

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		super.populate(xmlParser);
		
		List<ValidationError> errors = new ArrayList<ValidationError>(1);
		
		inverted = xmlParser.getPrimitiveBoolean("inverted");
		
		if(!errors.isEmpty()) {
			
			throw new ValidationException(errors);
		}
	}

	@Override
	public boolean requiresInitialization() {

		return true;
	}

	
	public boolean isInverted() {
	
		return inverted;
	}

	
	public void setInverted(boolean inverted) {
	
		this.inverted = inverted;
	}
}
