<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="ManualSignQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{ManualSignFieldQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="ManualSignQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<div class="full display-table bigmarginbottom">
				<xsl:apply-templates select="ManualSignQueryInstance/ManualSignQuery/Fields/ManualSignField" mode="show"/>
			</div>
		</div>
		
	</xsl:template>

	<xsl:template match="ManualSignField" mode="show">

		<xsl:variable name="manualSignFieldID" select="manualSignFieldID"/>
		<xsl:variable name="value" select="../../../Values/ManualSignFieldValue[ManualSignField/manualSignFieldID = $manualSignFieldID]/value"/>
		
		<xsl:variable name="even" select="(position() mod 2) = 0" />
		
		<div>
		
			<xsl:choose>
				<xsl:when test="../../layout = 'FLOAT'">
					<xsl:attribute name="class">floatleft fifty bigmarginbottom</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="class">floatleft full bigmarginbottom</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			
			<div>
				<xsl:attribute name="style">
					<xsl:value-of select="'border: 1px solid #808080; height: 55px; font-size: 10px;'"/>
					<xsl:if test="../../layout = 'FLOAT' and $even"> margin-left: 20px;</xsl:if>
				</xsl:attribute>
				
				<span style="padding-left: 4px; padding-top: 8px">
					<xsl:value-of select="label"/>
				</span>
			</div>
			
		</div>
	
	</xsl:template>
	
</xsl:stylesheet>