<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateMatchingInternalAccountQueryStateEvaluator" />
		</div>

	</xsl:template>

	<xsl:template name="createCustomFormFields">
		
		<xsl:param name="queryStateEvaluator" />
					
		<div class="floatleft full">
	
			<label>
				<xsl:value-of select="$i18n.Inclusive.title" />
			</label>
			
			<br/>
			
			<xsl:value-of select="$i18n.Inclusive.description" />
		</div>	
			
		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'inclusive'" />
					<xsl:with-param name="name" select="'inclusive'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="$queryStateEvaluator" />
				</xsl:call-template>

				<label for="inclusive">
					<xsl:value-of select="$i18n.Inclusive" />
				</label>
			</div>
		</div>

		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'not-inclusive'" />
					<xsl:with-param name="name" select="'inclusive'" />
					<xsl:with-param name="value" select="'false'" />
					<xsl:with-param name="element" select="$queryStateEvaluator" />
				</xsl:call-template>

				<label for="not-inclusive">
					<xsl:value-of select="$i18n.NotInclusive" />
				</label>
			</div>
		</div>
		
		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'requireEnabledAccount'" />
					<xsl:with-param name="name" select="'requireEnabledAccount'" />
					<xsl:with-param name="element" select="$queryStateEvaluator" />
				</xsl:call-template>

				<label for="requireEnabledAccount">
					<xsl:value-of select="$i18n.Evaluator.requireEnabledAccount" />
				</label>
			</div>
		</div>
		
	</xsl:template>

	<xsl:template match="UpdateMatchingInternalAccountQueryStateEvaluator">

		<xsl:call-template name="createQueryStateEvaluatorForm">
			<xsl:with-param name="queryStateEvaluator" select="MatchingInternalAccountQueryStateEvaluator" />
		</xsl:call-template>

	</xsl:template>

</xsl:stylesheet>