package com.nordicpeak.flowengine.multisigninghandlers;

import se.unlogic.hierarchy.core.interfaces.ForegroundModuleResponse;

import com.nordicpeak.flowengine.interfaces.ImmutableFlowInstance;

//TODO remove this and don't pass module responses this way. Use proper exceptions.
public class RequestData {

	private final SigningSession signingSession;
	private final ImmutableFlowInstance flowInstance;
	private final SigningSessionParty signingParty;
	private final ForegroundModuleResponse moduleResponse;

	public RequestData(SigningSession signingSession, ImmutableFlowInstance flowInstance, SigningSessionParty signingParty) {

		super();
		this.signingSession = signingSession;
		this.flowInstance = flowInstance;
		this.signingParty = signingParty;
		moduleResponse = null;
	}

	public RequestData(ForegroundModuleResponse moduleResponse) {

		super();
		signingSession = null;
		flowInstance = null;
		signingParty = null;
		this.moduleResponse = moduleResponse;
	}

	public SigningSession getSigningSession() {

		return signingSession;
	}

	public ImmutableFlowInstance getFlowInstance() {

		return flowInstance;
	}

	public SigningSessionParty getSigningParty() {

		return signingParty;
	}

	public ForegroundModuleResponse getModuleResponse() {

		return moduleResponse;
	}
}
