package com.nordicpeak.flowengine.paymentlog.beans;

import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.OrderBy;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement
@Table(name = "payment_account_number_part_definitions")
public class AccountNumberPartDefinition extends GeneratedElementable {
	
	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer accountPartDefinitionID;
	
	@DAOManaged
	@WebPopulate(required = true, maxLength = 255)
	@XMLElement
	private String name;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private Integer length;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean required;
	
	@DAOManaged
	@OrderBy
	@XMLElement
	private Integer sortIndex;
	
	@DAOManaged(columnName = "chartID")
	@ManyToOne
	@XMLElement
	private ChartOfAccounts chartOfAccounts;
	
	@DAOManaged
	@OneToMany
	@XMLElement(fixCase = true)
	private List<AccountNumberPart> accountNumberParts;
	
	public Integer getAccountPartDefinitionID() {
		return accountPartDefinitionID;
	}
	
	public void setAccountPartDefinitionID(Integer accountPartDefinitionID) {
		this.accountPartDefinitionID = accountPartDefinitionID;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public boolean isRequired() {
		return required;
	}
	
	public void setRequired(boolean required) {
		this.required = required;
	}
	
	public Integer getSortIndex() {
		return sortIndex;
	}
	
	public void setSortIndex(Integer sortIndex) {
		this.sortIndex = sortIndex;
	}
	
	public ChartOfAccounts getChartOfAccounts() {
		return chartOfAccounts;
	}
	
	public void setChartOfAccounts(ChartOfAccounts chartOfAccounts) {
		this.chartOfAccounts = chartOfAccounts;
	}
	
	public List<AccountNumberPart> getAccountNumberParts() {
		return accountNumberParts;
	}
	
	public void setAccountNumberParts(List<AccountNumberPart> accountNumberParts) {
		this.accountNumberParts = accountNumberParts;
	}
	
	public Integer getLength() {
		return length;
	}
	
	public void setLength(Integer length) {
		this.length = length;
	}

	@Override
	public int hashCode() {

		final int prime = 31;
		int result = 1;
		result = prime * result + ((accountPartDefinitionID == null) ? 0 : accountPartDefinitionID.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {

		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		AccountNumberPartDefinition other = (AccountNumberPartDefinition) obj;
		if (accountPartDefinitionID == null) {
			if (other.accountPartDefinitionID != null) {
				return false;
			}
		} else if (!accountPartDefinitionID.equals(other.accountPartDefinitionID)) {
			return false;
		}
		return true;
	}
	
}
