package com.nordicpeak.flowengine.queries.personquery;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.nordicpeak.flowengine.beans.QueryDescriptor;
import com.nordicpeak.flowengine.queries.basequery.BaseQueryCRUD;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;

public class PersonQueryQueryCRUD extends BaseQueryCRUD<PersonQuery, PersonQueryProviderModule> {

	protected AnnotatedDAOWrapper<PersonQuery, Integer> queryDAO;

	public PersonQueryQueryCRUD(AnnotatedDAOWrapper<PersonQuery, Integer> queryDAO, BeanRequestPopulator<PersonQuery> populator, String typeElementName, String typeLogName, String listMethodAlias, PersonQueryProviderModule callback) {

		super(PersonQuery.class, queryDAO, populator, typeElementName, typeLogName, listMethodAlias, callback);

		this.queryDAO = queryDAO;
	}

	@Override
	protected PersonQuery populateFromUpdateRequest(PersonQuery oldQuery, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {

		PersonQuery query = super.populateFromUpdateRequest(oldQuery, req, user, uriParser);

		List<ValidationError> validationErrors = new ArrayList<>();

		populateQueryDescriptor((QueryDescriptor) query.getQueryDescriptor(), req, validationErrors);

		if (!validationErrors.isEmpty()) {
			throw new ValidationException(validationErrors);
		}

		return query;
	}

}
