<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:variable name="staticcontent"><xsl:value-of select="/Document/requestinfo/contextpath"/>/static/f/<xsl:value-of select="/Document/module/sectionID"/>/<xsl:value-of select="/Document/module/moduleID"/></xsl:variable>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>

	<xsl:variable name="scripts">
		/js/predefineduserquery.js
	</xsl:variable>

	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		<xsl:apply-templates select="ShowQueryForm"/>
		
	</xsl:template>
	
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="PredefinedUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<article class="predefineduserquery show-mode">
				
				<div class="heading-wrapper">
					<h2>
						<xsl:attribute name="class">
							<xsl:if test="PredefinedUserQueryInstance/QueryInstanceDescriptor/queryState = 'VISIBLE_REQUIRED'">
								<xsl:text>required</xsl:text>
							</xsl:if>
						</xsl:attribute>
						<xsl:value-of select="PredefinedUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
					</h2>
					
					<xsl:call-template name="createUpdateButton">
						<xsl:with-param name="queryID" select="PredefinedUserQueryInstance/PredefinedUserQuery/queryID" />
					</xsl:call-template>
					
				</div>

				<xsl:if test="PredefinedUserQueryInstance/PredefinedUserQuery/description">
					<span class="italic">
						<xsl:value-of select="PredefinedUserQueryInstance/PredefinedUserQuery/description" disable-output-escaping="yes" />
					</span>
				</xsl:if>
				
				<div class="clearboth"/>
				
				<xsl:variable name="query" select="PredefinedUserQueryInstance/PredefinedUserQuery" />
				
				<fieldset>
				
					<xsl:if test="$query/showName = 'true'">
					
						<div class="split">
							<strong class="block">
								<xsl:value-of select="$i18n.Column.Firstname"/>
							</strong>
							<xsl:value-of select="PredefinedUserQueryInstance/firstname" />
						</div>
						
						<div class="split odd">
							<strong class="block">
								<xsl:value-of select="$i18n.Column.Lastname"/>
							</strong>
							<xsl:value-of select="PredefinedUserQueryInstance/lastname" />
						</div>
						
					</xsl:if>
					
					<xsl:if test="$query/showUsername = 'true'">
					
						<div class="split">
							<strong class="block">
								<xsl:value-of select="$i18n.Column.Username" />
							</strong>
							<xsl:value-of select="PredefinedUserQueryInstance/username" />
						</div>
					
					</xsl:if>
					
					<xsl:if test="$query/showCitizenIdentifier = 'true'">
						<div class="split">
							<xsl:if test="$query/showUsername = 'true'">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
							
							<strong class="block">
								<xsl:value-of select="$i18n.Column.CitizenID"/>
							</strong>
							<xsl:value-of select="PredefinedUserQueryInstance/citizenIdentifier" />
						</div>
					</xsl:if>
					
					<xsl:if test="$query/showEmail = 'true'">
						<div class="split">
							<strong class="block">
								<xsl:value-of select="$i18n.Column.Email"/>
							</strong>
							<xsl:value-of select="PredefinedUserQueryInstance/email" />
						</div>
					</xsl:if>
					
					<xsl:for-each select="$query/SelectedUserAttributes/SelectedUserAttribute">
						
						<div class="split">
							<xsl:if test="position() mod 2 = 0">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
							
							<strong class="block">
								<xsl:value-of select="displayName" />
							</strong>
							<xsl:value-of select="../../../UserAttributeValues/UserAttributeValue[Name = current()/name]/Value" />
						</div>
					
					</xsl:for-each>
				
				</fieldset>
				
				<xsl:if test="$query/showManagerInfo = 'true'">
					
					<h3><xsl:value-of select="$i18n.ManagerInfo" /></h3>
					
					<fieldset class="bigpaddingtop">
						
						<xsl:if test="$query/showManagerName = 'true'">
							
							<div class="split">
								<strong class="block">
									<xsl:value-of select="$i18n.Column.Firstname"/>
								</strong>
								<xsl:value-of select="PredefinedUserQueryInstance/managerFirstname" />
							</div>
							
							<div class="split odd">
								<strong class="block">
									<xsl:value-of select="$i18n.Column.Lastname"/>
								</strong>
								<xsl:value-of select="PredefinedUserQueryInstance/managerLastname" />
							</div>
							
						</xsl:if>
						
						<xsl:if test="$query/showManagerUsername = 'true'">
							
							<div class="split">
								<strong class="block"><xsl:value-of select="$i18n.Column.Username" /></strong>
								<xsl:value-of select="PredefinedUserQueryInstance/managerUsername" />
							</div>
							
						</xsl:if>
						
						<xsl:if test="$query/showManagerEmail = 'true'">
							
							<div class="split">
								<xsl:if test="$query/showManagerUsername = 'true'">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
								
								<strong class="block"><xsl:value-of select="$i18n.Column.Email" /></strong>
								<xsl:value-of select="PredefinedUserQueryInstance/managerEmail" />
							</div>
							
						</xsl:if>
						
						<xsl:for-each select="$query/SelectedManagerAttributes/SelectedManagerAttribute">
							
							<div class="split">
								<xsl:if test="position() mod 2 = 0">
									<xsl:attribute name="class">split odd</xsl:attribute>
								</xsl:if>
								
								<strong class="block"><xsl:value-of select="displayName" /></strong>
								<xsl:value-of select="../../../ManagerAttributeValues/ManagerAttributeValue[Name = current()/name]/Value" />
							</div>
							
						</xsl:for-each>
					
					</fieldset>
					
				</xsl:if>
				
			</article>
				
		</div>
		
	</xsl:template>
	
	<xsl:template match="ShowQueryForm">
	
		<xsl:variable name="shortQueryID" select="concat('q', PredefinedUserQueryInstance/PredefinedUserQuery/queryID)" />
	
		<xsl:variable name="queryID" select="concat('query_', PredefinedUserQueryInstance/PredefinedUserQuery/queryID)" />
	
		<div class="query" id="{$queryID}">
			
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="EnableAjaxPosting"> enableAjaxPosting</xsl:if>
				<xsl:if test="PredefinedUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="{$queryID}" />
		
			<xsl:if test="ValidationErrors/validationError">
				<div id="{$queryID}-validationerrors" class="validationerrors">
					<div class="info-box error">
					
						<xsl:choose>
							<xsl:when test="ValidationErrors/validationError[messageKey]">
								<xsl:apply-templates select="ValidationErrors/validationError[messageKey]"/>
							</xsl:when>
							<xsl:otherwise><span/></xsl:otherwise>
						</xsl:choose>
						
						<div class="marker"/>
					</div>
				</div>
			</xsl:if>
			
			<article class="predefineduserquery">
			
				<xsl:if test="ValidationErrors/validationError">
					<xsl:attribute name="class">predefineduserquery error</xsl:attribute>
				</xsl:if>
				
				<div class="heading-wrapper">
					
					<h2>
						<xsl:attribute name="class">
							<xsl:if test="PredefinedUserQueryInstance/QueryInstanceDescriptor/queryState = 'VISIBLE_REQUIRED'">
								<xsl:text>required</xsl:text>
							</xsl:if>
						</xsl:attribute>
						<xsl:value-of select="PredefinedUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
					</h2>
					
					<xsl:if test="PredefinedUserQueryInstance/PredefinedUserQuery/helpText">		
						<xsl:apply-templates select="PredefinedUserQueryInstance/PredefinedUserQuery/helpText" />
					</xsl:if>
				
				</div>

				<xsl:if test="PredefinedUserQueryInstance/PredefinedUserQuery/description">
					<span class="italic">
						<xsl:if test="/Document/useCKEditorForDescription = 'true'"><xsl:attribute name="class">italic html-description</xsl:attribute></xsl:if>
						<xsl:value-of select="PredefinedUserQueryInstance/PredefinedUserQuery/description" disable-output-escaping="yes" />
					</span>
				</xsl:if>
				
				<xsl:variable name="selectedUserID">
					<xsl:choose>
						<xsl:when test="PredefinedUserQueryInstance/userID">
							<xsl:value-of select="PredefinedUserQueryInstance/userID" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="PredefinedUserQueryInstance/PredefinedUserQuery/preSelectedUserID" />
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				
				<fieldset>
				
					<xsl:variable name="query" select="PredefinedUserQueryInstance/PredefinedUserQuery"/>
					
					<xsl:variable name="options">
						<xsl:for-each select="PredefinedUserQueryInstance/PredefinedUserQuery/selectableUsers/user">
							<option>
								<name>
									<xsl:value-of select="firstname" />
									<xsl:text> </xsl:text>
									<xsl:value-of select="lastname" />
									
									<xsl:if test="$query/showDropDownUsername = 'true' or $query/showDropDownCitizenIdentifier = 'true' or $query/SelectedDropDownAttributes/SelectedDropDownAttribute">
										<xsl:text> (</xsl:text>
										
										<xsl:if test="$query/showDropDownUsername = 'true'">
											<xsl:value-of select="username" />
										</xsl:if>
										
										<xsl:if test="$query/showDropDownCitizenIdentifier = 'true'">
											<xsl:if test="$query/showDropDownUsername = 'true'">
												<xsl:text>, </xsl:text>
											</xsl:if>
										
											<xsl:value-of select="Attributes/Attribute[Name = 'citizenIdentifier' or Name = 'managerCitizenIdentifier']/Value" />
										</xsl:if>
										
										<xsl:if test="$query/SelectedDropDownAttributes/SelectedDropDownAttribute">
											<xsl:if test="$query/showDropDownUsername = 'true' or $query/showDropDownCitizenIdentifier = 'true'">
												<xsl:text>, </xsl:text>
											</xsl:if>
											
											<xsl:variable name="attributes" select="Attributes" />
											
											<xsl:for-each select="$query/SelectedDropDownAttributes/SelectedDropDownAttribute">
												<xsl:if test="position() > 1">
													<xsl:text>, </xsl:text>
												</xsl:if>
												
												<xsl:value-of select="$attributes/Attribute[Name = current()/name]/Value" />
											</xsl:for-each>
											
										</xsl:if>
									
									<xsl:text>)</xsl:text>
									</xsl:if>
								</name>
								<value>
									<xsl:value-of select="userID" />
								</value>
							</option>
						</xsl:for-each>
					</xsl:variable>
					
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="name">
							<xsl:value-of select="'q'"/>
							<xsl:value-of select="PredefinedUserQueryInstance/PredefinedUserQuery/queryID"/>
							<xsl:value-of select="'_userID'"/>
						</xsl:with-param>
						<xsl:with-param name="addEmptyOption" select="$i18n.SelectUser"/>
						<xsl:with-param name="element" select="exsl:node-set($options)/option"/>
						<xsl:with-param name="labelElementName" select="'name'"/>
						<xsl:with-param name="valueElementName" select="'value'"/>
						<xsl:with-param name="selectedValue" select="$selectedUserID" />
						<xsl:with-param name="disabled" select="Locked"/>
					</xsl:call-template>
					
				</fieldset>
				
				<xsl:apply-templates select="PredefinedUserQueryInstance/PredefinedUserQuery/selectableUsers/user" mode="infocard" >
					<xsl:with-param name="selectedUserID" select="$selectedUserID"/>
				</xsl:apply-templates>
				
				<script type="text/javascript">initPredefinedUserQuery('<xsl:value-of select="PredefinedUserQueryInstance/PredefinedUserQuery/queryID" />');</script>
				
			</article>
			
		</div>
		
	</xsl:template>
	
	<xsl:template match="user" mode="infocard">
		<xsl:param name="query" select="../../." />
		<xsl:param name="queryInstance" select="../../../." />
		<xsl:param name="selectedUserID" />
		
		<div class="user bigmargintop" data-userid="{userID}">
			
			<xsl:if test="not($selectedUserID and $selectedUserID = userID)">
				<xsl:attribute name="style">
					<xsl:text>display: none;</xsl:text>
				</xsl:attribute>
			</xsl:if>
			
<!-- 			<xsl:attribute name="style"> -->
<!-- 				<xsl:choose> -->
<!-- 					<xsl:when test="$selectedUserID and $selectedUserID = userID" /> -->
<!-- 					<xsl:otherwise> -->
<!-- 						<xsl:text>display: none;</xsl:text> -->
<!-- 					</xsl:otherwise> -->
<!-- 				</xsl:choose> -->
<!-- 			</xsl:attribute> -->
		
			<fieldset>
				
				<xsl:if test="$query/showName = 'true'">
					
					<div class="split">
						<strong class="block">
							<xsl:value-of select="$i18n.Column.Firstname"/>
						</strong>
						<xsl:value-of select="firstname" />
					</div>
					
					<div class="split odd">
						<strong class="block">
							<xsl:value-of select="$i18n.Column.Lastname"/>
						</strong>
						<xsl:value-of select="lastname" />
					</div>
					
				</xsl:if>
				
				<xsl:if test="$query/showUsername = 'true'">
				
					<div class="split">
						<strong class="block">
							<xsl:value-of select="$i18n.Column.Username" />
						</strong>
						<xsl:value-of select="username" />
					</div>
				
				</xsl:if>
				
				<xsl:if test="$query/showCitizenIdentifier = 'true'">
					<div class="split">
						<xsl:if test="$query/showUsername = 'true'">
							<xsl:attribute name="class">split odd</xsl:attribute>
						</xsl:if>
						
						<strong class="block">
							<xsl:value-of select="$i18n.Column.CitizenID"/>
						</strong>
						<xsl:value-of select="Attributes/Attribute[Name = 'citizenIdentifier' or Name = 'managerCitizenIdentifier']/Value" />
					</div>
				</xsl:if>
				
				<xsl:if test="$query/showEmail = 'true'">
					<div class="split">
						<xsl:if test="($query/showUsername = 'true' or $query/showCitizenIdentifier = 'true') and not($query/showUsername = 'true' and $query/showCitizenIdentifier = 'true')">
							<xsl:attribute name="class">split odd</xsl:attribute>
						</xsl:if>
						
						<strong class="block">
							<xsl:value-of select="$i18n.Column.Email"/>
						</strong>
						<xsl:value-of select="email" />
					</div>
				</xsl:if>
				
				<xsl:variable name="user" select="." />
				
				<xsl:for-each select="$query/SelectedUserAttributes/SelectedUserAttribute">
					
					<div class="split">
						<xsl:if test="position() mod 2 = 0">
							<xsl:attribute name="class">split odd</xsl:attribute>
						</xsl:if>
						
						<strong class="block">
							<xsl:value-of select="displayName" />
						</strong>
						<xsl:value-of select="$user/Attributes/Attribute[Name = current()/name]/Value" />
					</div>
				
				</xsl:for-each>
			
			</fieldset>
			
			<xsl:if test="$query/showManagerInfo = 'true' and user">

				<h3><xsl:value-of select="$i18n.ManagerInfo" /></h3>
				
				<fieldset class="bigpaddingtop">
					
					<xsl:if test="$query/showManagerName = 'true'">
						
						<div class="split">
							<strong class="block">
								<xsl:value-of select="$i18n.Column.Firstname"/>
							</strong>
							<xsl:value-of select="user/firstname" />
						</div>
						
						<div class="split odd">
							<strong class="block">
								<xsl:value-of select="$i18n.Column.Lastname"/>
							</strong>
							<xsl:value-of select="user/lastname" />
						</div>
						
					</xsl:if>
					
					<xsl:if test="$query/showManagerUsername = 'true'">
						
						<div class="split">
							<strong class="block">
								<xsl:value-of select="$i18n.Column.Username" />
							</strong>
							<xsl:value-of select="user/username" />
						</div>
						
					</xsl:if>
					
					<xsl:if test="$query/showManagerEmail = 'true'">
						
						<div class="split">
							<xsl:if test="$query/showManagerUsername = 'true'">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
							
							<strong class="block">
								<xsl:value-of select="$i18n.Column.Email"/>
							</strong>
						<xsl:value-of select="user/email" />
						</div>
						
					</xsl:if>
					
					<xsl:variable name="manager" select="user" />
					
					<xsl:for-each select="$query/SelectedManagerAttributes/SelectedManagerAttribute">
						
						<div class="split">
							<xsl:if test="position() mod 2 = 0">
								<xsl:attribute name="class">split odd</xsl:attribute>
							</xsl:if>
							
							<strong class="block">
								<xsl:value-of select="displayName" />
							</strong>
							<xsl:value-of select="$manager/Attributes/Attribute[Name = current()/name]/Value" />
						</div>
					
					</xsl:for-each>
				
				</fieldset>
				
			</xsl:if>
			
		</div>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'RequiredQuery']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.Error.Required"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'InvalidUser']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.Error.InvalidUser"/>
			</strong>
		</span>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'InactiveAccountSelected']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.Error.InactiveAccountSelected"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'NoCitizenID']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="user/firstname"/>
				<xsl:text>&#160;</xsl:text>
				<xsl:value-of select="user/lastname"/>
				<xsl:text> </xsl:text>
				<xsl:value-of select="$i18n.ValidationError.NoCitizenID"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'UnableToGetManagerDetails']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.Validation.UnableToGetManagerDetails"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'ManagerDoesNotHaveRequiredFieldsForSigning']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.Validation.ManagerDoesNotHaveRequiredFieldsForSigning"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError">
	
		<xsl:choose>
			<xsl:when test="fieldName != ''">
				
				<i data-icon-after="!" title="{$i18n.Error.UnknownValidationError}"></i>
				
			</xsl:when>
			<xsl:otherwise>
				
				<span>
					<strong data-icon-before="!">
						<xsl:value-of select="$i18n.Error.UnknownValidationError"/>
					</strong>
				</span>
				
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
		
</xsl:stylesheet>