<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="PriorityQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{PriorityQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="PriorityQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<xsl:if test="PriorityQueryInstance/Alternatives">
				<p>
					<xsl:apply-templates select="PriorityQueryInstance/Alternatives/PriorityAlternative"/>
				</p>
			</xsl:if>	
					
		</div>
		
	</xsl:template>
	
	<xsl:template match="PriorityAlternative">
		
		<div class="clearboth">
			<div class="floatleft" style="min-width: 50px;">
				<strong><xsl:value-of select="position()"/></strong>
				<xsl:text>.&#160;</xsl:text>
			</div>
			
			<xsl:value-of select="name"/>
		</div>
	
	</xsl:template>

</xsl:stylesheet>