<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output encoding="ISO-8859-1" method="html" version="4.0"/>
	
	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/usergrouplist/UserGroupList.sv.xsl"/>
	<xsl:include href="QueueCommon.sv.xsl"/>
	<xsl:include href="QueueAdminModuleTemplates.xsl"/>
	
	<xsl:variable name="java.secondaryContactInternalMessagePrefix">Medskande:</xsl:variable>
	
	<xsl:variable name="java.manualEntranceSMS">Du r nu medlem i $queue.name med kplats nr. $queueSlot.position.</xsl:variable>
	<xsl:variable name="java.manualEntranceEmailSubject">Du r nu medlem i $queue.name med kplats nr. $queueSlot.position</xsl:variable>
	<xsl:variable name="java.manualEntranceEmailMessage">
	
		&lt;p&gt;Hej $contact.firstname,&lt;/p&gt;
		
		&lt;p&gt;Hr kommer en bekrftelse p att du ftt en kplats i $queue.name med kplats nr. $queueSlot.position.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
		
	</xsl:variable>
	
	<xsl:variable name="java.externalMessageReceivedUserSMS">Du har ftt ett nytt meddelande kopplat till din kplats i $queue.name</xsl:variable>
	<xsl:variable name="java.externalMessageReceivedUserEmailSubject">Nytt meddelande kopplat till din kplats i $queue.name</xsl:variable>
	<xsl:variable name="java.externalMessageReceivedUserEmailMessage">
	
		&lt;p&gt;Hej $contact.firstname,&lt;/p&gt;
		
		&lt;p&gt;Du har ftt ett nytt meddelande kopplat till din kplats i $queue.name.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.externalMessageReceivedManagerEmailSubject">Nytt meddelande kopplat till kplats i $queue.name (kplats nr. $queueSlot.position)</xsl:variable>
	<xsl:variable name="java.externalMessageReceivedManagerEmailMessage">
	
		&lt;p&gt;Hej $manager.firstname,&lt;/p&gt;
		
		&lt;p&gt;Du har ftt ett nytt meddelande kopplat till en kplats i $queue.name (kplats nr. $queueSlot.position).&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.externalMessageReceivedGlobalEmailSubject">Nytt meddelande kopplat till kplats i $queue.name (kplats nr. $queueSlot.position)</xsl:variable>
	<xsl:variable name="java.externalMessageReceivedGlobalEmailMessage">
	
		&lt;p&gt;Hej,&lt;/p&gt;
		
		&lt;p&gt;Ett nytt meddelande har skickats in kopplat till en kplats i $queue.name (kplats nr. $queueSlot.position).&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.exitUserSMS">Du str inte lngre i $queue.name</xsl:variable>
	<xsl:variable name="java.exitUserEmailSubject">Lmnat $queue.name</xsl:variable>
	<xsl:variable name="java.exitUserEmailMessage">
	
		&lt;p&gt;Hej $contact.firstname,&lt;/p&gt;
		
		&lt;p&gt;Du str inte lngre i $queue.name med kplats nr. $queueSlot.position.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
		
	</xsl:variable>
	
	<xsl:variable name="java.exitManagerEmailSubject">Kplats i $queue.name r uppsagd.</xsl:variable>
	<xsl:variable name="java.exitManagerEmailMessage">
	
		&lt;p&gt;Hej $manager.firstname,&lt;/p&gt;
		
		&lt;p&gt;En kplats i $queue.name r uppsagd.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.exitGlobalEmailSubject">Kplats i $queue.name r uppsagd.</xsl:variable>
	<xsl:variable name="java.exitGlobalEmailMessage">
	
		&lt;p&gt;Hej,&lt;/p&gt;
		
		&lt;p&gt;En kplats i $queue.name r uppsagd.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.exitRequestUserSMS">Du har begrt uttrde ur $queue.name med kplats nr. $queueSlot.position</xsl:variable>
	<xsl:variable name="java.exitRequestUserEmailSubject">Begran om uttrde frn $queue.name</xsl:variable>
	<xsl:variable name="java.exitRequestUserEmailMessage">
	
		&lt;p&gt;Hej $contact.firstname,&lt;/p&gt;
		
		&lt;p&gt;Du har begrt uttrde ur $queue.name dr du har kplats nr. $queueSlot.position.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.exitRequestManagerEmailSubject">Begran om uttrde frn $queue.name (kplats nr. $queueSlot.position)</xsl:variable>
	<xsl:variable name="java.exitRequestManagerEmailMessage">
	
		&lt;p&gt;Hej $manager.firstname,&lt;/p&gt;
		
		&lt;p&gt;Du har ftt en begran om uttrde ur $queue.name (kplats nr. $queueSlot.position).&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.exitRequestGlobalEmailSubject">Begran om uttrde frn $queue.name (kplats nr. $queueSlot.position)</xsl:variable>
	<xsl:variable name="java.exitRequestGlobalEmailMessage">
	
		&lt;p&gt;Hej,&lt;/p&gt;
		
		&lt;p&gt;Ny begran om uttrde ur $queue.name (kplats nr. $queueSlot.position).&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.paymentRequestSMS">Du har ftt en begran om betalning fr din kplats i $queue.name</xsl:variable>
	<xsl:variable name="java.paymentRequestEmailSubject">Begran om betalning fr kplats i $queue.name</xsl:variable>
	<xsl:variable name="java.paymentRequestEmailMessage">
	
		&lt;p&gt;Hej $contact.firstname,&lt;/p&gt;
		
		&lt;p&gt;Du har ftt en begran om betalning fr din kplats i $queue.name.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen, betalningsknappen finns lngst ner:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.paymentCompleteUserSMS">Betalning mottagen fr din kplats i $queue.name</xsl:variable>
	<xsl:variable name="java.paymentCompleteUserEmailSubject">Betalning mottagen fr din kplats i $queue.name</xsl:variable>
	<xsl:variable name="java.paymentCompleteUserEmailMessage">
	
		&lt;p&gt;Hej $contact.firstname,&lt;/p&gt;
		
		&lt;p&gt;Vi har mottagit en betalning fr din kplats i $queue.name.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.paymentDirectManagerEmailSubject">Betalning mottagen fr $queue.name (kplats nr. $queueSlot.position)</xsl:variable>
	<xsl:variable name="java.paymentDirectManagerEmailMessage">
	
		&lt;p&gt;Hej,&lt;/p&gt;
		
		&lt;p&gt;En betalning fr $queue.name (kplats nr. $queueSlot.position) har mottagits.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.paymentDirectGlobalEmailSubject">Betalning mottagen fr $queue.name (kplats nr. $queueSlot.position)</xsl:variable>
	<xsl:variable name="java.paymentDirectGlobalEmailMessage">
	
		&lt;p&gt;Hej,&lt;/p&gt;
		
		&lt;p&gt;En betalning fr $queue.name (kplats nr. $queueSlot.position) har mottagits.&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.paymentInvoiceManagerEmailSubject">Faktura betalning vald fr $queue.name (kplats nr. $queueSlot.position)</xsl:variable>
	<xsl:variable name="java.paymentInvoiceManagerEmailMessage">
	
		&lt;p&gt;Hej,&lt;/p&gt;
		
		&lt;p&gt;Faktura betalning har valts fr $queue.name (kplats nr. $queueSlot.position).&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>
	
	<xsl:variable name="java.paymentInvoiceGlobalEmailSubject">Faktura betalning vald fr $queue.name (kplats nr. $queueSlot.position)</xsl:variable>
	<xsl:variable name="java.paymentInvoiceGlobalEmailMessage">
	
		&lt;p&gt;Hej,&lt;/p&gt;
		
		&lt;p&gt;Faktura betalning har valts fr $queue.name (kplats nr. $queueSlot.position).&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa kplatsen:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$queueSlot.url"&gt;$queueSlot.url&lt;/a&gt;
		&lt;/p&gt;
	
	</xsl:variable>

	<xsl:variable name="java.i18nUserQueueSlotModuleAlias">Adress till Mina kplatser</xsl:variable>
	<xsl:variable name="java.i18nUserQueueSlotModuleAliasDescription">Den kompletta url:en till Mina kplatser fr denna profil</xsl:variable>
	<xsl:variable name="java.i18nQueueSlotAdminModuleAlias">Adress till kplatsadministrationen</xsl:variable>
	<xsl:variable name="java.i18nQueueSlotAdminModuleAliasDescription">Den kompletta url:en till kplatsadministrationen fr denna profil</xsl:variable>
	
	<xsl:variable name="i18n.Update">ndra</xsl:variable>
	<xsl:variable name="i18n.Delete">Ta bort</xsl:variable>
	<xsl:variable name="i18n.Add">Lgg till</xsl:variable>
	
	<xsl:variable name="i18n.AddQueue">Lgg till k</xsl:variable>
	<xsl:variable name="i18n.UpdateQueue">ndra k</xsl:variable>
	
	<xsl:variable name="i18n.Queue.ShowQueuePosition">Visa kposition fr medborgare</xsl:variable>
	<xsl:variable name="i18n.Queue.LeavingRequiresManagerConfirmation">Krv bekrftelse frn handlggare fr att lmna k</xsl:variable>
	<xsl:variable name="i18n.Queue.Manager.Users">Handlggare - Anvndare</xsl:variable>
	<xsl:variable name="i18n.Queue.Manager.Groups">Handlggare - Grupper</xsl:variable>
	<xsl:variable name="i18n.Queue.ProfileTitle">Koppla kn till profil</xsl:variable>
	<xsl:variable name="i18n.ProfileEmptyOption">Vlj profil</xsl:variable>

	<xsl:variable name="i18n.Queues">Ker</xsl:variable>
	<xsl:variable name="i18n.NoQueues">Inga ker hittades</xsl:variable>
	<xsl:variable name="i18n.DeleteConfirm">r du sker p att du vill ta bort</xsl:variable>
	
	<xsl:variable name="i18n.UserNotifications">Notifikationer till medborgare</xsl:variable>
	<xsl:variable name="i18n.Queue.SendEnteredUserSMS">SMS vid intrde utfrt av handlggare</xsl:variable>
	<xsl:variable name="i18n.Queue.SendExternalMessageReceivedUserSMS">SMS vid nytt meddelande frn handlggare</xsl:variable>
	<xsl:variable name="i18n.Queue.SendExitRequestUserSMS">SMS bekrftelse p begran om uttrde ur k</xsl:variable>
	<xsl:variable name="i18n.Queue.SendExitUserSMS">SMS bekrftelse p uttrde ur k</xsl:variable>
	<xsl:variable name="i18n.Queue.SendEnteredUserEmail">E-post vid intrde utfrt av handlggare</xsl:variable>
	<xsl:variable name="i18n.Queue.SendExternalMessageReceivedUserEmail">E-post vid nytt meddelande frn handlggare</xsl:variable>
	<xsl:variable name="i18n.Queue.SendExitRequestUserEmail">E-postbekrftelse p begran p uttrde ur k</xsl:variable>
	<xsl:variable name="i18n.Queue.SendPaymentCompleteUserEmail">E-postbekrftelse p betalning fr kplats</xsl:variable>
	
	<xsl:variable name="i18n.ManagerNotifications">Notifikationer till handlggare</xsl:variable>
	<xsl:variable name="i18n.Queue.SendExternalMessageReceivedManagerEmail">E-post vid nytt meddelande frn medborgare</xsl:variable>
	<xsl:variable name="i18n.Queue.sendExitRequestManagerEmail">E-post vid begran om uttrde ur kn</xsl:variable>
	<xsl:variable name="i18n.Queue.sendExitManagerEmail">E-post nr medborgare lmnat kn</xsl:variable>
	<xsl:variable name="i18n.Queue.sendPaymentCompleteManagerEmail">E-post nr medborgare betalat fr kplats (inklusive valt faktura)</xsl:variable>
	
	<xsl:variable name="i18n.GlobalNotifications">Generella notifikationer</xsl:variable>
	<xsl:variable name="i18n.Queue.SendExternalMessageReceivedGlobalEmail">E-post vid nytt meddelande frn medborgare</xsl:variable>
	<xsl:variable name="i18n.Queue.ExternalMessageReceivedGlobalEmailAddresses">E-postadresser fr notifiering om nya meddelanden frn medborgare (en adress per rad)</xsl:variable>
	<xsl:variable name="i18n.Queue.SendExitRequestGlobalEmail">E-post vid begran om uttrde ur k</xsl:variable>
	<xsl:variable name="i18n.Queue.ExitRequestGlobalEmailAddresses">E-postadresser fr notifiering vid begran om uttrde ur kn (en adress per rad)</xsl:variable>
	<xsl:variable name="i18n.Queue.SendExitGlobalEmail">E-post nr medborgaren lmnar kn</xsl:variable>
	<xsl:variable name="i18n.Queue.ExitGlobalEmailAddresses">E-postadresser fr notifiering att medborgare lmnat kn (en adress per rad)</xsl:variable>
	<xsl:variable name="i18n.Queue.SendPaymentCompleteGlobalEmail">E-post nr medborgare betalat fr kplats (inklusive valt faktura)</xsl:variable>
	<xsl:variable name="i18n.Queue.PaymentCompleteGlobalEmailAddresses">E-postadresser fr notifiering att medborgare betalat fr kplats (en adress per rad)</xsl:variable>
	
	<xsl:variable name="i18n.Queue.EmailSenderName">E-post-avsndarnamn</xsl:variable>
	<xsl:variable name="i18n.Queue.EmailSenderAddress">E-post-avsndaradress</xsl:variable>
	<xsl:variable name="i18n.validationError.PaymentProviderConfigurationError">Du har inte konfigurerat betalningstjnsten korrekt. Vnligen se felen under betalningstjnstens titel.</xsl:variable>
	<xsl:variable name="i18n.validationError.NoProfileChosen">Du mste vlja en kommun som kn skall kopplas mot.</xsl:variable>
	<xsl:variable name="i18n.Queue.eventPaymentInvoiceMessage">Beskrivning fr hndelseloggen vid betalning via faktura (fljs automatiskt av beloppet och valuta)</xsl:variable>
	<xsl:variable name="i18n.Queue.HideAddedDateFromUser">Dlj anskningsdatum fr medborgare</xsl:variable>
	<xsl:variable name="i18n.Queue.AllowDuplicateQueueSlots">Tillt fler n en kplats per person</xsl:variable>
	<xsl:variable name="i18n.Queue.WaitingPeriodActive">Anvnd karens vid arkivering av kplatser</xsl:variable>
	
	<xsl:variable name="i18n.AdvancedSettings">Avancerade instllningar</xsl:variable>
	<xsl:variable name="i18n.Queue.UseQueueForInternalUsers">Anvnd kn fr interna anvndare</xsl:variable>
	<xsl:variable name="i18n.Queue.InternalGroupDescription">Vlj grupper med anvndare som ska kunna se kplatser p denna k under mina sidor</xsl:variable>
	<xsl:variable name="i18n.Queue.InternalGroup">Grupper med interna anvndare</xsl:variable>
	
	<xsl:variable name="i18n.validationError.UpdateFailedQueueNotFound">Den angivna kn hittades inte!</xsl:variable>

</xsl:stylesheet>
