package com.nordicpeak.flowengine.queue.beans;

import java.io.Serializable;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.queries.contactdetailquery.ContactDetailQueryInstance;
import com.nordicpeak.personprovider.Person;

@Table(name = "queue_slot_contacts")
@XMLElement
public class PrimaryContact extends BaseContact implements Serializable {

	private static final long serialVersionUID = 7634780772195411121L;

	@DAOManaged
	@Key
	@XMLElement
	private Integer queueSlotID;

	@DAOManaged
	@OneToOne
	@XMLElement
	private QueueSlot queueSlot;

	public PrimaryContact() {}

	public PrimaryContact(User user) {

		super(user);
	}

	public PrimaryContact(ContactDetailQueryInstance contactDetailQueryInstance, User user) {

		super(contactDetailQueryInstance, user);
	}

	public PrimaryContact(Person person, User user) {

		super(person, user);
	}

	public QueueSlot getQueueSlot() {

		return queueSlot;
	}

	public void setQueueSlot(QueueSlot queueSlot) {

		this.queueSlot = queueSlot;
	}

}
