package com.nordicpeak.flowengine.queue.events;

import java.io.Serializable;

import com.nordicpeak.flowengine.enums.SenderType;
import com.nordicpeak.flowengine.queue.beans.ExternalMessage;
import com.nordicpeak.flowengine.queue.beans.QueueSlot;
import com.nordicpeak.flowengine.queue.beans.QueueSlotEvent;

public class ExternalMessageAddedEvent implements Serializable {

	private static final long serialVersionUID = 1873981649620240956L;

	private final QueueSlot queueSlot;
	private final QueueSlotEvent event;
	private final ExternalMessage externalMessage;
	private final SenderType senderType;

	private boolean emailNotificationSent;
	private boolean smsNotificationSent;

	public ExternalMessageAddedEvent(QueueSlot queueSlot, QueueSlotEvent event, ExternalMessage externalMessage, SenderType senderType) {

		super();
		this.queueSlot = queueSlot;
		this.event = event;
		this.externalMessage = externalMessage;
		this.senderType = senderType;
	}

	public QueueSlot getQueueSlot() {

		return queueSlot;
	}

	public QueueSlotEvent getEvent() {

		return event;
	}

	public ExternalMessage getExternalMessage() {

		return externalMessage;
	}

	public SenderType getSenderType() {

		return senderType;
	}

	public boolean isEmailNotificationSent() {

		return emailNotificationSent;
	}

	public void setEmailNotificationSent(boolean emailNotificationSent) {

		this.emailNotificationSent = emailNotificationSent;
	}

	public boolean isSmsNotificationSent() {

		return smsNotificationSent;
	}

	public void setSmsNotificationSent(boolean smsNotificationSent) {

		this.smsNotificationSent = smsNotificationSent;
	}

}
