package com.nordicpeak.flowengine.randombookingnumber.beans;

import java.io.Serializable;
import java.lang.reflect.Field;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "random_booking_interval_mappings")
@XMLElement
public class RandomBookingIntervalMapping extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -5166683291745202612L;

	public static final Field FIELD_BOOKING_SLOT_ID = ReflectionUtils.getField(RandomBookingIntervalMapping.class, "bookingSlotID");
	public static final Field FIELD_INTERVAL = ReflectionUtils.getField(RandomBookingIntervalMapping.class, "interval");

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer mappingID;

	@DAOManaged
	@XMLElement
	private Integer bookingSlotID;

	@DAOManaged(columnName = "intervalID")
	@ManyToOne
	@XMLElement(fixCase = true)
	private RandomBookingInterval interval;

	public RandomBookingIntervalMapping() {}

	public RandomBookingIntervalMapping(Integer bookingSlotID, RandomBookingInterval interval) {

		this.bookingSlotID = bookingSlotID;
		this.interval = interval;
	}

	@Override
	public String toString() {

		return "(mappingID=" + mappingID + ", bookingSlotID=" + bookingSlotID + ", interval=" + interval + ")";
	}

	public Integer getMappingID() {

		return mappingID;
	}

	public void setMappingID(Integer mappingID) {

		this.mappingID = mappingID;
	}

	public Integer getBookingSlotID() {

		return bookingSlotID;
	}

	public void setBookingSlotID(Integer bookingSlotID) {

		this.bookingSlotID = bookingSlotID;
	}

	public RandomBookingInterval getInterval() {

		return interval;
	}

	public void setInterval(RandomBookingInterval interval) {

		this.interval = interval;
	}

}
