package com.nordicpeak.flowengine.randombookingnumber.beans;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.Objects;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OrderBy;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "random_booking_number_mappings")
@XMLElement
public class RandomBookingNumberMapping extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -5166683291745202612L;

	public static final Field FIELD_BOOKING_ID = ReflectionUtils.getField(RandomBookingNumberMapping.class, "bookingID");
	public static final Field FIELD_NUMBER = ReflectionUtils.getField(RandomBookingNumberMapping.class, "number");

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer mappingID;

	@DAOManaged
	@XMLElement
	private Integer bookingID;

	@DAOManaged(columnName = "numberID")
	@ManyToOne
	@XMLElement(fixCase = true)
	private RandomBookingNumber number;

	@DAOManaged(columnName = "numberIndex")
	@OrderBy
	@XMLElement
	private Integer index;

	@DAOManaged
	@XMLElement
	private String description;

	public RandomBookingNumberMapping() {}

	public RandomBookingNumberMapping(Integer bookingID, RandomBookingNumber number) {

		this.bookingID = bookingID;
		setNumber(number);
	}

	@Override
	public String toString() {

		return "(mappingID=" + mappingID + ", index=" + index + ")";
	}

	public Integer getMappingID() {

		return mappingID;
	}

	public void setMappingID(Integer mappingID) {

		this.mappingID = mappingID;
	}

	public Integer getBookingID() {

		return bookingID;
	}

	public void setBookingID(Integer bookingID) {

		this.bookingID = bookingID;
	}

	public RandomBookingNumber getNumber() {

		return number;
	}

	public void setNumber(RandomBookingNumber number) {

		this.number = number;

		if (number != null) {

			this.index = number.getIndex();
			this.description = number.getDescription();
		}
	}

	public Integer getIndex() {

		return index;
	}

	public void setIndex(Integer index) {

		this.index = index;
	}

	public String getDescription() {

		return description;
	}

	public void setDescription(String description) {

		this.description = description;
	}

	@Override
	public int hashCode() {

		return Objects.hash(mappingID);
	}

	@Override
	public boolean equals(Object obj) {

		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		RandomBookingNumberMapping other = (RandomBookingNumberMapping) obj;
		return Objects.equals(mappingID, other.mappingID);
	}

}
