package com.nordicpeak.flowengine.randombookingnumber.daos;

import java.lang.reflect.Field;
import java.sql.SQLException;
import java.util.List;

import javax.sql.DataSource;

import se.unlogic.standardutils.dao.AnnotatedDAO;
import se.unlogic.standardutils.dao.AnnotatedDAOFactory;
import se.unlogic.standardutils.dao.HighLevelQuery;
import se.unlogic.standardutils.dao.QueryParameterFactory;

import com.nordicpeak.flowengine.randombookingnumber.beans.RandomBookingInterval;

public class RandomBookingIntervalDAO extends AnnotatedDAO<RandomBookingInterval> {

	private final QueryParameterFactory<RandomBookingInterval, Integer> intervalIDParamFactory;

	public RandomBookingIntervalDAO(DataSource dataSource, Class<RandomBookingInterval> beanClass, AnnotatedDAOFactory daoFactory) {

		super(dataSource, beanClass, daoFactory);

		intervalIDParamFactory = this.getParamFactory(RandomBookingInterval.FIELD_INTERVAL_ID, Integer.class);
	}

	public RandomBookingInterval get(Integer intervalID, Field... relations) throws SQLException {

		HighLevelQuery<RandomBookingInterval> query = new HighLevelQuery<>();

		query.addParameter(intervalIDParamFactory.getParameter(intervalID));

		if (relations != null) {

			query.addRelations(relations);
		}

		return this.get(query);
	}

	public List<RandomBookingInterval> getAll(Field... relations) throws SQLException {

		HighLevelQuery<RandomBookingInterval> query = new HighLevelQuery<>();

		if (relations != null) {

			query.addRelations(relations);
		}

		return this.getAll(query);
	}

}
