package com.nordicpeak.flowengine.remoteflowinstance;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import se.unlogic.hierarchy.core.beans.Group;
import se.unlogic.hierarchy.core.beans.SimpleAttribute;
import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.handlers.SimpleAttributeHandler;
import se.unlogic.hierarchy.core.handlers.SourceAttributeHandler;

import com.nordicpeak.flowengine.beans.BaseMessage;
import com.nordicpeak.flowengine.beans.BaseStatus;
import com.nordicpeak.flowengine.beans.ExternalMessage;
import com.nordicpeak.flowengine.beans.Flow;
import com.nordicpeak.flowengine.beans.FlowFamily;
import com.nordicpeak.flowengine.beans.FlowInstance;
import com.nordicpeak.flowengine.beans.FlowInstanceAttribute;
import com.nordicpeak.flowengine.beans.FlowInstanceEvent;
import com.nordicpeak.flowengine.beans.FlowType;
import com.nordicpeak.flowengine.beans.Status;
import com.nordicpeak.flowengine.enums.ContentType;
import com.nordicpeak.flowengine.enums.EventType;
import com.nordicpeak.flowengine.flowinstanceadmin2.beans.UserManagableFlowInstanceCounts;

public class HTTPRemoteFlowInstanceShared {

	public static final List<Class<?>> ALLOWED_CLASSES;
	public static final Map<Class<?>, Class<?>> REPLACEMENT_CLASSES;

	static {
		ArrayList<Class<?>> classes = new ArrayList<Class<?>>(29);

		classes.add(Integer.class);
		classes.add(String.class);
		classes.add(Number.class);
		classes.add(Enum.class);
		classes.add(ArrayList.class);
		classes.add(HashMap.class);
		
		classes.add(Timestamp.class);
		classes.add(Date.class);
		classes.add(java.sql.Date.class);
		
		classes.add(Flow.class);
		classes.add(FlowInstance.class);
		classes.add(FlowInstanceEvent.class);
		classes.add(FlowInstanceAttribute.class);
		classes.add(FlowFamily.class);
		classes.add(FlowType.class);
		classes.add(BaseStatus.class);
		classes.add(Status.class);
		classes.add(ContentType.class);
		classes.add(EventType.class);
		classes.add(ExternalMessage.class);
		classes.add(BaseMessage.class);
		
		classes.add(UserManagableFlowInstanceCounts.class);
		
		classes.add(SimpleAttribute.class);
		classes.add(SimpleAttributeHandler.class);
		classes.add(SourceAttributeHandler.class);

		classes.add(RemoteUser.class);
		classes.add(RemoteGroup.class);
		
		try {
			classes.add(Class.forName("java.util.Collections$SingletonList"));
		} catch (ClassNotFoundException ignore) {}
		
		ALLOWED_CLASSES = Collections.unmodifiableList(classes);
		
		Map<Class<?>, Class<?>> replacementClasses = new HashMap<>(2);
		
		replacementClasses.put(User.class, RemoteUser.class);
		replacementClasses.put(Group.class, RemoteGroup.class);
		
		REPLACEMENT_CLASSES = replacementClasses;
	}

}
