package com.nordicpeak.flowengine.queries.remotesinglesignquery.api;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.nio.charset.Charset;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.interfaces.APISource;
import com.nordicpeak.flowengine.queries.remotesinglesignquery.RemoteSinglesignQuery;

@Table(name = "remote_singlesign_query_endpoints")
@XMLElement(name = "Endpoint")
public class RemoteSinglesignQueryEndpoint extends GeneratedElementable implements Serializable, APISource {

	private static final long serialVersionUID = -8348666528294482053L;

	public static final Field QUERIES_RELATION = ReflectionUtils.getField(RemoteSinglesignQueryEndpoint.class, "queries");

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer endpointID;

	@DAOManaged
	@OneToMany
	@XMLElement(fixCase = true)
	private List<RemoteSinglesignQuery> queries;

	@DAOManaged
	@WebPopulate(required = true, maxLength = 255)
	@XMLElement
	private String name;

	@DAOManaged
	@WebPopulate(required = true, maxLength = 1024)
	@XMLElement
	private String address;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String username;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String password;

	@DAOManaged
	@WebPopulate(required = true)
	@XMLElement
	private String encoding;
	
	@Override
	public String toString() {

		return name + " (ID: " + endpointID + ")";
	}

	public Integer getEndpointID() {

		return endpointID;
	}

	public void setEndpointID(Integer endpointID) {

		this.endpointID = endpointID;
	}

	public String getName() {

		return name;
	}

	public void setName(String name) {

		this.name = name;
	}

	public String getAddress() {

		return address;
	}

	public void setAddress(String address) {

		this.address = address;
	}

	public String getUsername() {

		return username;
	}

	public void setUsername(String username) {

		this.username = username;
	}

	public String getPassword() {

		return password;
	}

	public void setPassword(String password) {

		this.password = password;
	}

	public String getEncoding() {

		return encoding;
	}

	public void setEncoding(String encoding) {

		this.encoding = encoding;
	}

	public Charset getCharset() {

		return Charset.forName(encoding);
	}

	public List<RemoteSinglesignQuery> getQueries() {

		return queries;
	}

	public void setQueries(List<RemoteSinglesignQuery> queries) {

		this.queries = queries;
	}
}
