package com.nordicpeak.flowengine;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.backgroundmodules.AnnotatedBackgroundModule;
import se.unlogic.hierarchy.core.annotations.HTMLEditorSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.ModuleSetting;
import se.unlogic.hierarchy.core.annotations.XSLVariable;
import se.unlogic.hierarchy.core.beans.Group;
import se.unlogic.hierarchy.core.beans.SimpleBackgroundModuleResponse;
import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.interfaces.BackgroundModuleResponse;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.SessionUtils;
import se.unlogic.webutils.http.URIParser;

public class RemovedGroupsBackgroundModule extends AnnotatedBackgroundModule {

	@ModuleSetting
	@HTMLEditorSettingDescriptor(name = "Footer message", description = "The the message displayed in the footer when showing more information", required = true)
	@XSLVariable(prefix = "java.")
	private String footerMessage;
	
	@Override
	protected BackgroundModuleResponse processBackgroundRequest(HttpServletRequest req, User user, URIParser uriParser) throws Exception {

		HttpSession session = req.getSession(false);
		
		if(session == null) {
			
			return null;
		}
		
		@SuppressWarnings("unchecked")
		List<Group> removedGroups = SessionUtils.getCastAttribute("removedGroups", req, List.class);
		
		if(removedGroups == null) {
			
			return null;
		}
		
		Document doc = XMLUtils.createDomDocument();
		
		Element document = doc.createElement("Document");
		
		doc.appendChild(document);
		
		Element removedGroupsElement = XMLUtils.append(doc, document, "RemovedGroups", removedGroups);
		
		if(removedGroupsElement != null) {
			
			XMLUtils.appendNewElement(doc, removedGroupsElement, "FooterMessage", footerMessage);
		}

		return new SimpleBackgroundModuleResponse(doc);
		
	}

}
