package com.nordicpeak.flowengine.restrictedflowadmin;

import java.io.Serializable;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLUtils;

import com.nordicpeak.flowengine.enums.FlowAdminColumn;

@Table(name = "restricted_flow_admin_user_column_settings")
@XMLElement(name = "FlowAdminUserColumnSetting")
public class RestrictedFlowAdminUserColumnSetting extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = 7242958689622494281L;

	@DAOManaged
	@Key
	@XMLElement
	private Integer userID;

	@DAOManaged
	@XMLElement
	private Integer columnIndex;

	@DAOManaged
	@XMLElement
	private FlowAdminColumn columnName;

	@DAOManaged
	@XMLElement
	private boolean visible;

	public Integer getUserID() {

		return userID;
	}

	public void setUserID(Integer userID) {

		this.userID = userID;
	}

	public boolean isVisible() {

		return visible;
	}

	public void setVisible(boolean visible) {

		this.visible = visible;
	}

	public Integer getColumnIndex() {

		return columnIndex;
	}

	public void setColumnIndex(Integer columnIndex) {

		this.columnIndex = columnIndex;
	}

	public FlowAdminColumn getColumnName() {

		return columnName;
	}

	public void setColumn(FlowAdminColumn columnName) {

		this.columnName = columnName;
	}
	
	
	@Override
	public Element toXML(Document doc) {
		
		Element element = super.toXML(doc);
		XMLUtils.appendNewElement(doc,element, "column", columnName.getName());

		return element;
	}

	@Override
	public String toString() {

		return columnName + " (userID: " + userID + ", columnIndex: " + columnIndex + ", visible: " + visible + ")";
	}

}
