package com.nordicpeak.flowengine.queries.ssbt;

import java.io.Serializable;

import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.queries.ssbt.enums.CompanyType;

@XMLElement
public class Company extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -9181208998759549994L;

	@XMLElement
	private String companyName;

	@XMLElement
	private String organizationNumber;

	@XMLElement
	private Integer nameProtectionNumber;

	@XMLElement
	private CompanyType companyType;

	@XMLElement
	private String companyTypeDescription;	
	
	@XMLElement
	private boolean hardCoded;
	
	@XMLElement
	private boolean error;
	
	private CompanyDetails companyDetails;
	
	public String getCompanyName() {

		return companyName;
	}

	public void setCompanyName(String companyName) {

		this.companyName = companyName;
	}

	public String getOrganizationNumber() {

		return organizationNumber;
	}

	public void setOrganizationNumber(String organizationNumber) {

		this.organizationNumber = organizationNumber;
	}

	public Integer getNameProtectionNumber() {

		return nameProtectionNumber;
	}

	public void setNameProtectionNumber(Integer nameProtectionNumber) {

		this.nameProtectionNumber = nameProtectionNumber;
	}

	
	public CompanyType getCompanyType() {
	
		return companyType;
	}

	
	public void setCompanyType(CompanyType companyType) {
	
		this.companyType = companyType;
	}

	
	public boolean isHardCoded() {
	
		return hardCoded;
	}

	
	public void setHardCoded(boolean hardCoded) {
	
		this.hardCoded = hardCoded;
	}

	
	public CompanyDetails getCompanyDetails() {
	
		return companyDetails;
	}

	
	public void setCompanyDetails(CompanyDetails companyDetails) {
	
		this.companyDetails = companyDetails;
	}

	
	public boolean isError() {
	
		return error;
	}

	
	public void setError(boolean error) {
	
		this.error = error;
	}
	
	@Override
	public String toString(){
		
		return companyName + " (" + organizationNumber + ", " + companyType + ")";
	}

	
	public String getCompanyTypeDescription() {
	
		return companyTypeDescription;
	}

	
	public void setCompanyTypeDescription(String companyTypeDescription) {
	
		this.companyTypeDescription = companyTypeDescription;
	}
}
