package com.nordicpeak.flowengine.queries.ssbt;

import java.io.Serializable;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "ssbt2_company_detail_query_instance_companies")
@XMLElement
public class SavedCompany extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -9181208998759549994L;

	@Key
	@DAOManaged(autoGenerated = true)
	private Integer companyID;
	
	@DAOManaged(columnName = "queryInstanceID")
	@ManyToOne
	private CompanyDetailsQueryInstance queryInstance;

	@DAOManaged
	@XMLElement
	private String organizationNumber;

	@DAOManaged
	@XMLElement
	private String companyName;

	public SavedCompany() {}

	public SavedCompany(Company company) {
		super();

		this.companyName = company.getCompanyName();
		this.organizationNumber = company.getOrganizationNumber();
	}

	public CompanyDetailsQueryInstance getQueryInstance() {
		return queryInstance;
	}

	public void setQueryInstance(CompanyDetailsQueryInstance queryInstance) {
		this.queryInstance = queryInstance;
	}

	public String getCompanyName() {

		return companyName;
	}

	public void setCompanyName(String companyName) {

		this.companyName = companyName;
	}

	public String getOrganizationNumber() {

		return organizationNumber;
	}

	public void setOrganizationNumber(String organizationNumber) {

		this.organizationNumber = organizationNumber;
	}

	@Override
	public String toString() {

		return companyName + " (" + organizationNumber + ")";
	}

}
