<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/CKEditor.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js			
	</xsl:variable>
	
	<xsl:variable name="scripts">
		/js/sendcontactquerymailevaluator.js		
	</xsl:variable>	
	
	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateSendContactQueryMailEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateSendContactQueryMailEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="UpdateSendContactQueryMailEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<div class="floatleft full bigmarginbottom">

				<label for="name" class="floatleft full">
					<xsl:value-of select="$i18n.name" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'name'" />
						<xsl:with-param name="name" select="'name'" />
						<xsl:with-param name="element" select="SendContactQueryMailEvaluator/EvaluatorDescriptor" />
					</xsl:call-template>
				</div>
			</div>

			<div class="floatleft full marginbottom">
	
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'enabled'" />
						<xsl:with-param name="name" select="'enabled'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="SendContactQueryMailEvaluator/EvaluatorDescriptor" />
					</xsl:call-template>
	
					<label for="enabled">
						<xsl:value-of select="$i18n.enabled" />
					</label>
				</div>
			</div>

			<h2 class="floatleft">
				<xsl:value-of select="$i18n.statusfilter.title" />
			</h2>

			<div class="clearboth floatleft marginbottom">
				<xsl:value-of select="$i18n.statusfilter.description" />
			</div>
			
			<div class="floatleft full marginbottom">
	
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'enableStatusFiltering'" />
						<xsl:with-param name="name" select="'enableStatusFiltering'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="onclick" select="'showHideStatusList();'"/>
						<xsl:with-param name="element" select="SendContactQueryMailEvaluator" />
					</xsl:call-template>
	
					<label for="enableStatusFiltering">
						<xsl:value-of select="$i18n.enableStatusFiltering" />
					</label>
				</div>
			</div>		

			<div id="statuslist">
			
				<div class="clearboth floatleft marginbottom">
					<xsl:value-of select="$i18n.statuslist.description" />
				</div>
	
				<xsl:choose>
					<xsl:when test="Statuses/Status">
						<xsl:apply-templates select="Statuses/Status" />
					</xsl:when>
					<xsl:otherwise>
						<p>
							<xsl:value-of select="$i18n.FlowHasNoStatuses" />
						</p>
					</xsl:otherwise>
				</xsl:choose>			
			
			</div>

			<h2 class="floatleft full bigmargintop">
				<xsl:value-of select="$i18n.EmailHeader" />
			</h2>

			<div class="clearboth floatleft">
				<xsl:value-of select="$i18n.EmailHeaderDescription" />
				<xsl:text>&#x20;</xsl:text>
				<xsl:value-of select="AvailableTags" />
			</div>
	
			<label class="floatleft" for="emailSubject">
				<xsl:value-of select="$i18n.EmailSubject" />
			</label>

			<div class="floatleft full marginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'emailSubject'" />
						<xsl:with-param name="name" select="'emailSubject'" />
						<xsl:with-param name="title" select="$i18n.EmailSubject"/>
						<xsl:with-param name="element" select="SendContactQueryMailEvaluator" />
					</xsl:call-template>
				</div>
			</div>
			
			<label class="floatleft" for="emailMessage">
				<xsl:value-of select="$i18n.EmailMessage" />
			</label>

			<div class="floatleft full marginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createTextArea">
						<xsl:with-param name="id" select="'emailMessage'" />
						<xsl:with-param name="name" select="'emailMessage'" />
						<xsl:with-param name="title" select="$i18n.EmailMessage"/>
						<xsl:with-param name="class" select="'message-ckeditor'" />
						<xsl:with-param name="element" select="SendContactQueryMailEvaluator" />
					</xsl:call-template>
				</div>
			</div>

			<xsl:call-template name="initializeFCKEditor">
				<xsl:with-param name="basePath"><xsl:value-of select="/Document/requestinfo/contextpath"/>/static/f/<xsl:value-of select="/Document/module/sectionID"/>/<xsl:value-of select="/Document/module/moduleID"/>/ckeditor/</xsl:with-param>
				<xsl:with-param name="customConfig">config.js</xsl:with-param>
				<xsl:with-param name="editorContainerClass">message-ckeditor</xsl:with-param>
				<xsl:with-param name="editorHeight">150</xsl:with-param>
				<xsl:with-param name="contentsCss">
					<xsl:if test="/Document/cssPath">
						<xsl:value-of select="/Document/cssPath"/>
					</xsl:if>
				</xsl:with-param>
			</xsl:call-template>
			

			<div class="floatleft full marginbottom">
	
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'attachPDF'" />
						<xsl:with-param name="name" select="'attachPDF'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="onclick" select="'showHideSendPDFAttachmentsSeparately();'"/>
						<xsl:with-param name="element" select="SendContactQueryMailEvaluator" />
					</xsl:call-template>
	
					<label for="attachPDF">
						<xsl:value-of select="$i18n.AttachPDF" />
					</label>
				</div>
			</div>

			<div class="floatleft full marginbottom">
	
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'sendPDFAttachmentsSeparately'" />
						<xsl:with-param name="name" select="'sendPDFAttachmentsSeparately'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="SendContactQueryMailEvaluator" />
					</xsl:call-template>
	
					<label for="sendPDFAttachmentsSeparately">
						<xsl:value-of select="$i18n.SendPDFAttachmentsSeparately" />
					</label>
				</div>
			</div>


			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.Submit}" />
			</div>

		</form>

	</xsl:template>

	<xsl:template match="Status">

		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id">
						<xsl:value-of select="'status'"/>
						<xsl:value-of select="statusID"/>
					</xsl:with-param>				
					<xsl:with-param name="name" select="'statusID'" />
					<xsl:with-param name="value" select="statusID" />
					<xsl:with-param name="element" select="../../SendContactQueryMailEvaluator/StatusIDs" />
					<xsl:with-param name="requestparameters" select="../../requestparameters"/>
				</xsl:call-template>

				<label for="status{statusID}">
					<xsl:value-of select="name" />
				</label>
			</div>
		</div>

	</xsl:template>

	<xsl:template match="validationError">
		<xsl:if test="fieldName and validationErrorType and not(messageKey)">
			<p class="error">
				<xsl:choose>
					<xsl:when test="validationErrorType='RequiredField'">
						<xsl:value-of select="$i18n.validation.requiredField" />
					</xsl:when>
					<xsl:when test="validationErrorType='InvalidFormat'">
						<xsl:value-of select="$i18n.validation.invalidFormat" />
					</xsl:when>
					<xsl:when test="validationErrorType='TooShort'">
						<xsl:value-of select="$i18n.validation.tooShort" />
					</xsl:when>
					<xsl:when test="validationErrorType='TooLong'">
						<xsl:value-of select="$i18n.validation.tooLong" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$i18n.validation.unknownError" />
					</xsl:otherwise>
				</xsl:choose>

				<xsl:text>&#x20;</xsl:text>

				<xsl:choose>
					<xsl:when test="fieldName = 'name'">
						<xsl:value-of select="$i18n.name" />
					</xsl:when>
					<xsl:when test="fieldName = 'emailSubject'">
						<xsl:value-of select="$i18n.emailSubject" />
					</xsl:when>
					<xsl:when test="fieldName = 'emailMessage'">
						<xsl:value-of select="$i18n.emailMessage" />
					</xsl:when>
					<xsl:when test="fieldName = 'emailRecipients'">
						<xsl:value-of select="$i18n.emailRecipients" />
						<xsl:text>&#x20;(</xsl:text>
						<xsl:value-of select="displayName" />
						<xsl:text>)</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="fieldName" />
					</xsl:otherwise>
				</xsl:choose>
			</p>
		</xsl:if>

	</xsl:template>

</xsl:stylesheet>