package com.nordicpeak.flowengine.evaluators.sendcontactquerymailevaluator;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;

public class SendContactQueryMailEvaluatorCRUD extends BaseEvaluatorCRUD<SendContactQueryMailEvaluator, SendContactQueryMailEvaluationProviderModule> {

	private static final AnnotatedRequestPopulator<SendContactQueryMailEvaluator> POPULATOR = new AnnotatedRequestPopulator<SendContactQueryMailEvaluator>(SendContactQueryMailEvaluator.class);

	public SendContactQueryMailEvaluatorCRUD(Class<SendContactQueryMailEvaluator> beanClass, AnnotatedDAOWrapper<SendContactQueryMailEvaluator, Integer> evaluatorDAO, SendContactQueryMailEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "SendContactQueryMailEvaluator", "send contact query mail evaluator", null, callback);
	}

	@Override
	protected SendContactQueryMailEvaluator populateFromUpdateRequest(SendContactQueryMailEvaluator bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {

		SendContactQueryMailEvaluator evaluator = super.populateFromUpdateRequest(bean, req, user, uriParser);
		
		List<ValidationError> errors = new ArrayList<ValidationError>();

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}
		
		return evaluator;
	}

	@Override
	protected void appendUpdateFormData(SendContactQueryMailEvaluator bean, Document doc, Element updateTypeElement, User user, HttpServletRequest req, URIParser uriParser) throws Exception {

		super.appendUpdateFormData(bean, doc, updateTypeElement, user, req, uriParser);

		XMLUtils.append(doc, updateTypeElement, "Statuses", callback.getFlowAdminModule().getCachedFlow(bean.getEvaluatorDescriptor().getQueryDescriptor().getStep().getFlow().getFlowID()).getStatuses());

		XMLUtils.appendNewElement(doc, updateTypeElement, "AvailableTags", callback.getAvailableTags());
	}

}
