package com.nordicpeak.flowengine.evaluators.setpudfromcitizenaddressevaluator;

import java.util.ArrayList;
import java.util.List;

import com.nordicpeak.flowengine.beans.QueryModification;
import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluator;
import com.nordicpeak.flowengine.interfaces.EvaluationCallback;
import com.nordicpeak.flowengine.interfaces.EvaluationEventListener;
import com.nordicpeak.flowengine.interfaces.EvaluationHandler;
import com.nordicpeak.flowengine.interfaces.QueryInstance;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.populators.StringPopulator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLValidationUtils;

@Table(name = "set_pud_from_citizen_address_evaluators")
@XMLElement
public class SetPUDFromCitizenAddressEvaluator extends BaseEvaluator implements EvaluationEventListener {

	private static final long serialVersionUID = 1129410235430246625L;

	@DAOManaged
	@WebPopulate(required = true, maxLength = 255)
	@XMLElement
	private String noPUDFoundMessage;

	private boolean initialized;

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> errors = new ArrayList<ValidationError>();

		noPUDFoundMessage = XMLValidationUtils.validateParameter("noPUDFoundMessage", xmlParser, false, 1, 255, StringPopulator.getPopulator(), errors);

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}
	}

	@Override
	public String toString() {

		return evaluatorDescriptor.toString();
	}

	@Override
	public boolean forceAjaxPosting() {

		return true;
	}

	public String getNoPUDFoundMessage() {

		return noPUDFoundMessage;
	}

	public void setNoPUDFoundMessage(String noPUDFoundMessage) {

		this.noPUDFoundMessage = noPUDFoundMessage;
	}

	@Override
	public boolean requiresInitialization() {

		return true;
	}

	@Override
	public boolean supportsEvent(Object event) {

		return false;
	}

	@Override
	public List<QueryModification> processEvent(Object event, QueryInstance queryInstance, User user, User poster, EvaluationCallback callback, EvaluationHandler evaluationHandler) {

		return null;
	}

	public boolean isInitialized() {

		return initialized;
	}

	public void setInitialized(boolean initialized) {

		this.initialized = initialized;
	}
}
