package com.nordicpeak.flowengine.evaluators.statusquerystate;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;
import com.nordicpeak.flowengine.interfaces.ImmutableStatus;

public class StatusQueryStateEvaluatorCRUD extends BaseEvaluatorCRUD<StatusQueryStateEvaluator, StatusQueryStateEvaluationProviderModule> {
	
	private static final BeanRequestPopulator<StatusQueryStateEvaluator> POPULATOR = new AnnotatedRequestPopulator<StatusQueryStateEvaluator>(StatusQueryStateEvaluator.class);
	
	public StatusQueryStateEvaluatorCRUD(Class<StatusQueryStateEvaluator> beanClass, AnnotatedDAOWrapper<StatusQueryStateEvaluator, Integer> evaluatorDAO, StatusQueryStateEvaluationProviderModule callback) {
		
		super(beanClass, evaluatorDAO, POPULATOR, "StatusQueryStateEvaluator", "status query state evaluator", null, callback);
	}
	
	@Override
	protected void appendUpdateFormData(StatusQueryStateEvaluator evaluator, Document doc, Element updateTypeElement, User user, HttpServletRequest req, URIParser uriParser) throws Exception {

		super.appendUpdateFormData(evaluator, doc, updateTypeElement, user, req, uriParser);
		
		List<? extends ImmutableStatus> statuses = callback.getFlowStatuses(evaluator.getEvaluatorDescriptor().getQueryDescriptor().getStep().getFlow().getFlowID());
		
		XMLUtils.append(doc, updateTypeElement, "Statuses", statuses);
	}
}
