package com.nordicpeak.flowengine.evaluators.tableattributeevaluator;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.populators.NonNegativeStringIntegerPopulator;
import se.unlogic.standardutils.populators.StringPopulator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLValidationUtils;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluator;

@Table(name = "table_attribute_evaluators")
@XMLElement
public class TableAttributeEvaluator extends BaseEvaluator {

	private static final long serialVersionUID = -911567587723344081L;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private Integer columnID;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String attributeName;

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> errors = new ArrayList<>();

		columnID = XMLValidationUtils.validateParameter("columnID", xmlParser, false, 1, 255, NonNegativeStringIntegerPopulator.getPopulator(), errors);
		attributeName = XMLValidationUtils.validateParameter("attributeName", xmlParser, false, 1, 255, StringPopulator.getPopulator(), errors);

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}
	}

	public Integer getColumnID() {

		return columnID;
	}

	public void setColumnID(Integer columnID) {

		this.columnID = columnID;
	}

	public String getAttributeName() {

		return attributeName;
	}

	public void setAttributeName(String attributeName) {

		this.attributeName = attributeName;
	}

	@Override
	public String toString() {

		return evaluatorDescriptor.toString();
	}

}
