package com.nordicpeak.flowengine.evaluators.tableattributesummaryevaluator;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.populators.NonNegativeStringIntegerPopulator;
import se.unlogic.standardutils.populators.StringPopulator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLParserPopulateable;
import se.unlogic.standardutils.xml.XMLValidationUtils;

@Table(name = "table_attribute_summary_evaluator_alternative_attributes")
@XMLElement
public class AlternativeAttribute extends GeneratedElementable implements Serializable, XMLParserPopulateable {

	private static final long serialVersionUID = 8272957977512606007L;

	@DAOManaged(columnName = "evaluatorID")
	@ManyToOne
	@Key
	private TableAttributeSummaryEvaluator evaluator;

	@DAOManaged
	@XMLElement
	@Key
	private Integer alternativeID;

	@DAOManaged
	@XMLElement
	private String attribute;

	public TableAttributeSummaryEvaluator getEvaluator() {

		return evaluator;
	}

	public void setEvaluator(TableAttributeSummaryEvaluator evaluator) {

		this.evaluator = evaluator;
	}

	public Integer getAlternativeID() {

		return alternativeID;
	}

	public void setAlternativeID(Integer alternativeID) {

		this.alternativeID = alternativeID;
	}

	public String getAttribute() {

		return attribute;
	}

	public void setAttribute(String attribute) {

		this.attribute = attribute;
	}

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> errors = new ArrayList<ValidationError>();

		alternativeID = XMLValidationUtils.validateParameter("alternativeID", xmlParser, true, NonNegativeStringIntegerPopulator.getPopulator(), errors);
		attribute = XMLValidationUtils.validateParameter("attribute", xmlParser, true, StringPopulator.getPopulator(), errors);

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}
	}
	
	@Override
	public String toString() {

		return "(evaluator=" + evaluator + ", alternativeID=" + alternativeID + ")";
	}
}
