<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>

	<xsl:variable name="scripts">
		/js/jquery.cookie.js
		/js/searchbackgroundmodule.js
	</xsl:variable>

	<xsl:variable name="links">
		/css/targetgroupflowbrowser.css
		/css/searchbackgroundmodule.css
	</xsl:variable>
	
	<xsl:template match="Document">
	
		<div class="search-wrapper flowbrowser bg-search">
					
			<script type="text/javascript">
				<xsl:if test="lastSearchEnabled">
					lastSearchEnabled = true;
				</xsl:if>
			</script>		
				
			<div class="inner">	
				
				<h2 class="only-mobile"><xsl:value-of select="$i18n.SearchTitle" /></h2>
				
				<input type="text" id="bg-search-field" name="search" class="search-field" data-searchmoduleuri="{flowInfoModuleURI}">
					<xsl:if test="searchHints">
						<xsl:attribute name="placeholder"><xsl:value-of select="searchHints" /></xsl:attribute>
					</xsl:if>
				</input>
				<span class="search-close-btn" />
				<a href="#" class="btn btn-blue xl search-btn only-desktop"><xsl:value-of select="$i18n.Search" /></a>
				<a href="#" class="btn btn-blue xl search-btn only-tablet-mobile"><span class="search-icon" /></a>
				
				<xsl:if test="recommendedTags/Tag">
					<div class="recommended-searches only-desktop-tablet">
						<xsl:value-of select="$i18n.RecommendedSearches" /><xsl:text>:&#160;</xsl:text>
						<xsl:apply-templates select="recommendedTags/Tag" />
					</div>
				</xsl:if>
			
			</div>
			
			<div class="search-result-wrapper grid-view">
			
				<div class="inner">
				
					<h2 class="search-results-title">
						<xsl:value-of select="$i18n.Hits.Prefix" /><xsl:text>"</xsl:text><span class="title" /><xsl:text>"&#160;</xsl:text><xsl:value-of select="$i18n.Hits.Part1" /><xsl:text>&#160;</xsl:text><span class="hits" /><xsl:text>&#160;</xsl:text><xsl:value-of select="$i18n.Hits.Part2" />
					</h2>
					
					<div class="category-list">
						
						<a class="search-close-btn" href="#"><xsl:value-of select="$i18n.close" /><xsl:text>&#160;</xsl:text><i>x</i></a>
						
						<div class="column-1"></div>
						
						<div class="column-2"></div>
						
					</div>
				
				</div>
				
			</div>
			
		</div>
	
	</xsl:template>
	
</xsl:stylesheet>