var tragetGroupAdminModuleAlias;
var flowAdminModuleAlias;

$(function() {
	
	$("#flow-search").autocomplete({
	 	source: function(request, response) {
	 		return searchFlows(request, response);
		},
		select: function( event, ui ) {
			
			addEntry(ui.item);
			
			$(this).val("");
			
			return false;
		},
		focus: function(event, ui) {
	        event.preventDefault();
	    }
	});
	
	$("#flow-list li:not(.hidden)").each(function() {
		
		var $this = $(this);
		
		var $deleteBtn = $this.find(".delete");
		
		$deleteBtn.on("click", function(e) {
			e.preventDefault();
			$this.remove();
			return false;
		});
		
	});
	
});

function searchFlows(request, response, searchURL) {
	
	var $searchnput = $("#flow-search");
	
	$searchnput.addClass("ui-autocomplete-loading");
	
	$.ajax({
		url : tragetGroupAdminModuleAlias + "/searchflow",
		dataType : "json",
		contentType: "application/x-www-form-urlencoded;charset=UTF-8",
		data : {
			q : encodeURIComponent(request.term)
		},
		success : function(data) {
			
			if(data.hits != undefined && data.hits.length > 0) {
				
				response($.map(data.hits, function(item) {
					
					return {
						label : item.Name,
						value : item.FlowFamilyID,
						Name  : item.Name,
						FlowID: item.FlowID
					}
				}));
			} else {
				response(null);
			}
			
			$searchnput.removeClass("ui-autocomplete-loading");
			
		},
		error : function() {
			
			$searchnput.removeClass("ui-autocomplete-loading");
		}
	});
}

function addEntry(item){
	
	var exists = false;
	
	$("input[name='flowFamilyID']").each(function(){
		if($(this).val() == item.value){
			exists = true;
		}
	});
	
	if(exists){
		return;
	}
	
	var $clone = $("#flow-template").clone();
	
	$clone.prepend("<img src='" + flowAdminModuleAlias + "/icon/" + item.FlowID + "' width='25' />");
	$clone.find(".text").text(item.label);
	$clone.find("input[name='flowFamilyID']").val(item.value).removeAttr("disabled");
	$clone.find("input[name='flowID-']").attr("name", "flowID-" + item.value).val(item.value).removeAttr("disabled");
	$clone.find("input[name='flowName-']").attr("name", "flowName-" + item.value).val(item.label).removeAttr("disabled");
	
	$clone.removeAttr("id");
	
	var $deleteBtn = $clone.find("a.delete");
	$deleteBtn.attr("title", $deleteBtn.attr("title") + " " + item.label);
	$deleteBtn.on("click", function(e) {
		e.preventDefault();
		$clone.remove();
		return false;
	});
	
	$("#flow-list").append($clone);
	
	$clone.show();
}