<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>

	<xsl:variable name="scripts">
		/js/setweightbyexistingtreservacaseadmin.js
	</xsl:variable>

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateSetWeightByExistingTreservaCaseEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateSetWeightByExistingTreservaCaseEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="SetWeightByExistingTreservaCaseEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="SetWeightByExistingTreservaCaseEvaluator" />
			</xsl:call-template>

			<div class="floatleft full bigmarginbottom">

				<label for="weightType" class="floatleft full required">
					<xsl:value-of select="$i18n.weightType" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'weightType'" />
						<xsl:with-param name="name" select="'weightType'" />
						<xsl:with-param name="element" select="SetWeightByExistingTreservaCaseEvaluator" />
					</xsl:call-template>
				</div>
			</div>

			<div class="floatleft full marginbottom">

				<label for="caseFoundWeight" class="floatleft full required">
					<xsl:value-of select="$i18n.caseFoundWeight" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'caseFoundWeight'" />
						<xsl:with-param name="name" select="'caseFoundWeight'" />
						<xsl:with-param name="element" select="SetWeightByExistingTreservaCaseEvaluator" />
					</xsl:call-template>
				</div>
			</div>

			<div class="floatleft full marginbottom">

				<label for="caseNotFoundWeight" class="floatleft full required">
					<xsl:value-of select="$i18n.caseNotFoundWeight" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'caseNotFoundWeight'" />
						<xsl:with-param name="name" select="'caseNotFoundWeight'" />
						<xsl:with-param name="element" select="SetWeightByExistingTreservaCaseEvaluator" />
					</xsl:call-template>
				</div>
			</div>

			<div class="floatleft full bigmarginbottom">

				<label for="apiErrorWeight" class="floatleft full required">
					<xsl:value-of select="$i18n.apiErrorWeight" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'apiErrorWeight'" />
						<xsl:with-param name="name" select="'apiErrorWeight'" />
						<xsl:with-param name="element" select="SetWeightByExistingTreservaCaseEvaluator" />
					</xsl:call-template>
				</div>
			</div>

			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="SetWeightByExistingTreservaCaseEvaluator" />
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>

					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.setAsAttribute" />
					</label>
				</div>
			</div>
			
			<div id="attributeNameContainer">
	
				<div class="floatleft full bigmarginbottom">
					<label for="attributeName" class="floatleft clearboth">
						<xsl:value-of select="$i18n.attributeName" />
					</label>
	
					<div class="floatleft full">
						<xsl:call-template name="createTextField">
							<xsl:with-param name="id" select="'attributeName'" />
							<xsl:with-param name="name" select="'attributeName'" />
							<xsl:with-param name="title" select="$i18n.attributeName" />
							<xsl:with-param name="element" select="SetWeightByExistingTreservaCaseEvaluator" />
							<xsl:with-param name="maxlength" select="'255'" />
						</xsl:call-template>
					</div>
				</div>
							    
				<p class="floatleft clearboth"><xsl:value-of select="$i18n.attributeDescription" /></p>
				
				<table class="floatleft clearboth border">
					<thead>
						<th><xsl:value-of select="$i18n.attributes.name" /></th>
						<th><xsl:value-of select="$i18n.attributes.value" /></th>
					</thead>
					<tbody>
						<tr>
							<td>prefix.number</td>
							<td><xsl:value-of select="$i18n.attributes.number" /></td>
						</tr>
						<tr>
							<td>prefix.manager</td>
							<td><xsl:value-of select="$i18n.attributes.manager" /></td>
						</tr>
						<tr>
							<td>prefix.fromDate</td>
							<td><xsl:value-of select="$i18n.attributes.fromDate" /></td>
						</tr>
					</tbody>
				</table>
			
			</div>

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.submit}" />
			</div>

		</form>

	</xsl:template>

	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'weightType'">
				<xsl:value-of select="$i18n.weightType" />
			</xsl:when>
			<xsl:when test="$fieldName = 'caseFoundWeight'">
				<xsl:value-of select="$i18n.caseFoundWeight" />
			</xsl:when>
			<xsl:when test="$fieldName = 'caseNotFoundWeight'">
				<xsl:value-of select="$i18n.caseNotFoundWeight" />
			</xsl:when>
			<xsl:when test="$fieldName = 'apiErrorWeight'">
				<xsl:value-of select="$i18n.apiErrorWeight" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>