package com.nordicpeak.flowengine.integration.treservaddecision.beans;

import java.sql.Timestamp;
import java.util.List;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.time.TimeUtils;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "treserva_sent_decisions")
@XMLElement
public class SentDecision {

	@DAOManaged
	@Key
	private String decisionID;

	@DAOManaged
	private Timestamp date;

	public SentDecision() {}

	public SentDecision(String decisionID) {

		this.decisionID = decisionID;
		this.date = TimeUtils.getCurrentTimestamp();
	}

	public String getDecisionID() {

		return decisionID;
	}

	public void setDecisionID(String decisionID) {

		this.decisionID = decisionID;
	}

	public Timestamp getDate() {

		return date;
	}

	public void setDate(Timestamp date) {

		this.date = date;
	}

	public static boolean contains(List<SentDecision> sentDecisions, String decisionID) {

		return getSentDecision(sentDecisions, decisionID) != null;
	}

	public static SentDecision getSentDecision(List<SentDecision> sentDecisions, String decisionID) {

		for (SentDecision sentDecision : sentDecisions) {

			if (sentDecision.getDecisionID().equals(decisionID)) {

				return sentDecision;
			}
		}

		return null;
	}

}
