package com.nordicpeak.flowengine.queries.userlistquery;

import java.util.ArrayList;
import java.util.List;

import javax.sql.DataSource;

import com.nordicpeak.flowengine.queries.usertreequery.UserHandlerListUserProvider;
import com.nordicpeak.listuserprovider.ListParameter;
import com.nordicpeak.listuserprovider.ListUser;
import com.nordicpeak.listuserprovider.SimpleListUser;

import se.unlogic.hierarchy.core.annotations.GroupMultiListSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.ModuleSetting;
import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.interfaces.SectionInterface;
import se.unlogic.hierarchy.core.interfaces.modules.descriptors.ForegroundModuleDescriptor;

public class GroupFilteredListUserProvider extends UserHandlerListUserProvider {

	@ModuleSetting(allowsNull = true)
	@GroupMultiListSettingDescriptor(name = "Filtered groups", description = "Groups to filter by when searching for users", required = false)
	protected List<Integer> filterGroups;

	@Override
	public void init(ForegroundModuleDescriptor moduleDescriptor, SectionInterface sectionInterface, DataSource dataSource) throws Exception {

		this.providerID = this.providerID + "." + moduleDescriptor.getModuleID();

		super.init(moduleDescriptor, sectionInterface, dataSource);

		this.userGroupListConnector.setUserGroupFilter(filterGroups);
	}

	@Override
	public void update(ForegroundModuleDescriptor descriptor, DataSource dataSource) throws Exception {

		super.update(descriptor, dataSource);

		this.userGroupListConnector.setUserGroupFilter(filterGroups);
	}
	
	@Override
	public List<ListUser> searchUsers(Integer flowID, String searchString, List<? extends ListParameter> filterParameters, User user) throws Exception {
		
		List<User> users = userGroupListConnector.getUsers(searchString, user);
		
		if (users == null) {
			return null;
		}
		
		List<ListUser> storedListUsers = new ArrayList<ListUser>(users.size());
		
		for (User searchedUser : users) {
			storedListUsers.add(new SimpleListUser(searchedUser));
		}
		
		return storedListUsers;
	}

}
