package com.nordicpeak.flowengine.evaluators.userquerymailevaluator;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;

public class UserQueryMailEvaluatorCRUD extends BaseEvaluatorCRUD<UserQueryMailEvaluator, UserQueryMailEvaluationProviderModule> {

	private static final AnnotatedRequestPopulator<UserQueryMailEvaluator> POPULATOR = new AnnotatedRequestPopulator<UserQueryMailEvaluator>(UserQueryMailEvaluator.class);

	public UserQueryMailEvaluatorCRUD(Class<UserQueryMailEvaluator> beanClass, AnnotatedDAOWrapper<UserQueryMailEvaluator, Integer> evaluatorDAO, UserQueryMailEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "UserQueryMailEvaluator", "send user mail evaluator", null, callback);
	}

	@Override
	protected void appendUpdateFormData(UserQueryMailEvaluator bean, Document doc, Element updateTypeElement, User user, HttpServletRequest req, URIParser uriParser) throws Exception {

		super.appendUpdateFormData(bean, doc, updateTypeElement, user, req, uriParser);

		XMLUtils.append(doc, updateTypeElement, "Statuses", callback.getFlowAdminModule().getCachedFlow(bean.getEvaluatorDescriptor().getQueryDescriptor().getStep().getFlow().getFlowID()).getStatuses());

		XMLUtils.appendNewElement(doc, updateTypeElement, "AvailableTags", callback.getAvailableTags());
	}

}
