package com.nordicpeak.flowengine.usersubscriptions;

import java.util.Date;

import se.unlogic.standardutils.date.DateStringyfier;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement
public class Subscription extends GeneratedElementable {

	@XMLElement
	private final String subscriptionID;

	@XMLElement
	private final String cost;

	@XMLElement(valueFormatter = DateStringyfier.class)
	private final Date startDate;

	@XMLElement(valueFormatter = DateStringyfier.class)
	private final Date endDate;

	@XMLElement
	private final boolean active;

	@XMLElement
	private final String shortDescription;

	@XMLElement
	private final String longDescription;

	public Subscription(String subscriptionID, String cost, Date startDate, Date endDate, boolean active, String shortDescription, String longDescription) {

		super();
		this.subscriptionID = subscriptionID;
		this.cost = cost;
		this.startDate = startDate;
		this.endDate = endDate;
		this.active = active;
		this.shortDescription = shortDescription;
		this.longDescription = longDescription;
	}

	public String getSubscriptionID() {

		return subscriptionID;
	}

	public String getCost() {

		return cost;
	}

	public Date getStartDate() {

		return startDate;
	}

	public Date getEndDate() {

		return endDate;
	}

	public boolean isActive() {

		return active;
	}

	public String getShortDescription() {

		return shortDescription;
	}

	public String getLongDescription() {

		return longDescription;
	}

	@Override
	public String toString() {

		return "Subscription [subscriptionID=" + subscriptionID + ", description=" + shortDescription + "]";
	}

}
