package com.nordicpeak.flowengine.evaluators.setweightbyuserageevaluator;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;

public class SetWeightByUserAgeEvaluatorCRUD extends BaseEvaluatorCRUD<SetWeightByUserAgeEvaluator, SetWeightByUserAgeEvaluationProviderModule> {

	private static final AnnotatedRequestPopulator<SetWeightByUserAgeEvaluator> POPULATOR = new AnnotatedRequestPopulator<>(SetWeightByUserAgeEvaluator.class);

	public SetWeightByUserAgeEvaluatorCRUD(Class<SetWeightByUserAgeEvaluator> beanClass, AnnotatedDAOWrapper<SetWeightByUserAgeEvaluator, Integer> evaluatorDAO, SetWeightByUserAgeEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "SetWeightByUserAgeEvaluator", "set weight by user age evaluator", null, callback);
	}

	@Override
	protected void validateUpdatePopulation(SetWeightByUserAgeEvaluator bean, HttpServletRequest req, User user, URIParser uriParser) throws Exception {

		List<ValidationError> errors = new ArrayList<>();

		if (bean.getMinAge() != null && bean.getMaxAge() != null && bean.getMinAge() > bean.getMaxAge()) {

			errors.add(new ValidationError("MinAgeBiggerThanMaxAge"));
		}

		if (bean.getMinAge() == null && bean.getMaxAge() == null) {

			errors.add(new ValidationError("NoAgeRangeSpecified"));
		}

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}

		bean.getEvaluatorDescriptor().setTargetQueryIDs(null);
	}

}
