<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>	

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateSetWeightFromAPIEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateSetWeightFromAPIEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="SetWeightFromAPIEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="SetWeightFromAPIEvaluator" />
			</xsl:call-template>

			<div class="floatleft full bigmarginbottom">

				<label for="weightType" class="floatleft full">
					<xsl:value-of select="$i18n.weightType" />
					<span class="required">*</span>
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'weightType'" />
						<xsl:with-param name="name" select="'weightType'" />
						<xsl:with-param name="element" select="SetWeightFromAPIEvaluator" />
					</xsl:call-template>
				</div>
			</div>

			<div class="floatleft full bigmarginbottom">

				<label for="sourceName">
					<xsl:value-of select="$i18n.SourceName" />
				</label>

				<div class="floatleft full">
					
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'sourceName'"/>
						<xsl:with-param name="name" select="'sourceName'"/>
						<xsl:with-param name="element" select="Sources/APISource"/>
						<xsl:with-param name="labelElementName" select="'Name'"/>
						<xsl:with-param name="valueElementName" select="'ID'"/>
						<xsl:with-param name="selectedValue" select="SetWeightFromAPIEvaluator/sourceName"/>
						<xsl:with-param name="addEmptyOption" select="$i18n.SourceName.choose"/>
						<xsl:with-param name="class" select="'full'"/>
					</xsl:call-template>
					
				</div>
			</div>

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.submit}" />
			</div>

		</form>

	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'weightType'">
				<xsl:value-of select="$i18n.weightType" />
			</xsl:when>
			<xsl:when test="$fieldName = 'sourceName'">
				<xsl:value-of select="$i18n.SourceName" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>