package com.nordicpeak.flowengine.evaluators.weightapi.beans;

import java.lang.reflect.Field;
import java.sql.Timestamp;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OrderBy;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.enums.Order;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "weight_from_api_source_events")
@XMLElement(name = "APISourceEvent")
public class WeightAPISourceEvent extends GeneratedElementable {

	public static final Field SOURCE_RELATION = ReflectionUtils.getField(WeightAPISourceEvent.class, "source");

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer eventID;

	@DAOManaged
	@OrderBy(order = Order.DESC)
	@XMLElement
	protected Timestamp added;

	@DAOManaged(dontUpdateIfNull = true)
	@XMLElement(name = "poster")
	protected User poster;

	@DAOManaged
	@XMLElement
	protected String message;

	@DAOManaged(columnName = "sourceID")
	@ManyToOne
	@XMLElement
	private WeightAPISource source;

	public WeightAPISourceEvent() {};

	public WeightAPISourceEvent(WeightAPISource source, Timestamp added, User poster, String message) {

		if (source == null) {
			throw new NullPointerException("list can not be null");
		}

		this.source = source;
		this.added = added;
		this.poster = poster;
		this.message = message;
	}

	public Integer getEventID() {
		return eventID;
	}

	public void setEventID(Integer eventID) {
		this.eventID = eventID;
	}

	public Timestamp getAdded() {
		return added;
	}

	public void setAdded(Timestamp added) {
		this.added = added;
	}

	public User getPoster() {
		return poster;
	}

	public void setPoster(User poster) {
		this.poster = poster;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public WeightAPISource getSource() {
		return source;
	}

	public void setSource(WeightAPISource source) {
		this.source = source;
	}

	@Override
	public String toString() {

		return " AlternativeListEvent (ID: " + eventID + ", list: " + getSource() + ")";
	}

}
