package com.nordicpeak.flowengine.evaluators.weightcalculatedquerystateevaluator;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.basequerystateevaluator.BaseQueryStateEvaluationCRUD;

public class WeightCalculatedQueryStateEvaluatorCRUD extends BaseQueryStateEvaluationCRUD<WeightCalculatedQueryStateEvaluator, WeightCalculatedQueryStateEvaluationProviderModule> {
	
	private static final AnnotatedRequestPopulator<WeightCalculatedQueryStateEvaluator> POPULATOR = new AnnotatedRequestPopulator<WeightCalculatedQueryStateEvaluator>(WeightCalculatedQueryStateEvaluator.class);
	
	public WeightCalculatedQueryStateEvaluatorCRUD(Class<WeightCalculatedQueryStateEvaluator> beanClass, AnnotatedDAOWrapper<WeightCalculatedQueryStateEvaluator, Integer> evaluatorDAO, WeightCalculatedQueryStateEvaluationProviderModule callback) {
		
		super(beanClass, evaluatorDAO, POPULATOR, "WeightCalculatedQueryStateEvaluator", "calculated weight query state evaluator", null, callback);
	}
	
	@Override
	protected WeightCalculatedQueryStateEvaluator populateFromUpdateRequest(WeightCalculatedQueryStateEvaluator bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {
		
		WeightCalculatedQueryStateEvaluator evaluator = super.populateFromUpdateRequest(bean, req, user, uriParser);
		
		return evaluator;
	}
	
	@Override
	protected void validateUpdatePopulation(WeightCalculatedQueryStateEvaluator bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, SQLException, Exception {
		
		List<ValidationError> errors = new ArrayList<ValidationError>();
		
		if (bean.getFromValue() != null && bean.getToValue() != null && bean.getFromValue() > bean.getToValue()) {
			
			errors.add(new ValidationError("FromValueBiggerThanToValue"));
		}
		
//		if (!StringUtils.isEmpty(bean.getExpression()) && !new expression(bean.getExpression().replaceAllVariables).isValid()) {
//
//			errors.add(new ValidationError("expression", ValidationErrorType.InvalidFormat));
//		}
		
		if (!errors.isEmpty()) {
			
			throw new ValidationException(errors);
		}
		
		bean.getEvaluatorDescriptor().setTargetQueryIDs(null);
		
	}
	
	@Override
	protected void appendUpdateFormData(WeightCalculatedQueryStateEvaluator bean, Document doc, Element updateTypeElement, User user, HttpServletRequest req, URIParser uriParser) throws Exception {
		
	}
	
}
