package com.nordicpeak.flowengine.evaluators.weightquerystateevaluator;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.basequerystateevaluator.BaseQueryStateEvaluationCRUD;

public class WeightQueryStateEvaluatorCRUD extends BaseQueryStateEvaluationCRUD<WeightQueryStateEvaluator, WeightQueryStateEvaluationProviderModule> {

	private static final AnnotatedRequestPopulator<WeightQueryStateEvaluator> POPULATOR = new AnnotatedRequestPopulator<WeightQueryStateEvaluator>(WeightQueryStateEvaluator.class);

	public WeightQueryStateEvaluatorCRUD(Class<WeightQueryStateEvaluator> beanClass, AnnotatedDAOWrapper<WeightQueryStateEvaluator, Integer> evaluatorDAO, WeightQueryStateEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "WeightQueryStateEvaluator", "weight query state evaluator", null, callback);
	}

	@Override
	protected WeightQueryStateEvaluator populateFromUpdateRequest(WeightQueryStateEvaluator bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {

		WeightQueryStateEvaluator evaluator = super.populateFromUpdateRequest(bean, req, user, uriParser);

		return evaluator;
	}

	@Override
	protected void validateUpdatePopulation(WeightQueryStateEvaluator bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, SQLException, Exception {

		List<ValidationError> errors = new ArrayList<ValidationError>();

		if (bean.getFromValue() != null && bean.getToValue() != null && bean.getFromValue() > bean.getToValue()) {

			errors.add(new ValidationError("FromValueBiggerThanToValue"));
		}

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}
		
		bean.getEvaluatorDescriptor().setTargetQueryIDs(null);

	}

	@Override
	protected void appendUpdateFormData(WeightQueryStateEvaluator bean, Document doc, Element updateTypeElement, User user, HttpServletRequest req, URIParser uriParser) throws Exception {


	}

}
